"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeleAPI = void 0;
const APIBase_1 = require("./APIBase");
const RawNonQuery_1 = require("../lib/model/RawNonQuery");
const RawQuery_1 = require("../lib/model/RawQuery");
const RawView_1 = require("../lib/view/RawView");
const markError_1 = require("./markError");
const setting_config_1 = require("../config/setting.config");
const TelApiRecords = new setting_config_1.GetTelApiRecord();
var request = require('request');
class TeleAPI extends APIBase_1.APIBase {
    // private key: string;
    secret;
    priority;
    sessdata;
    timekey;
    constructor(proirity, sessdata, timekey) {
        super();
        // this.key = "48de6c84-7726-4879-bc08-f7a5dcf63f1c";
        this.timekey = timekey,
            this.secret = "";
        this.priority = proirity;
        this.sessdata = sessdata;
    }
    getNpaNxx(req, res, pLoad, callback) {
        if (this.priority == "100") {
            console.log("Exit from TeleAPI");
            callback('', '');
        }
        else {
            const sdata = req.query;
            var options = {
                'method': 'POST',
                // 'url': 'https://apiv1.teleapi.net/dids/list?token=' + this.key + '&npa=' + `${sdata.NPA}` + '&limit=' + `${pLoad.searchqty}`,
                'url': TelApiRecords.TelApiListUrl + TelApiRecords.TelApiKEY + '&npa=' + `${sdata.NPA}` + '&limit=' + `${pLoad.searchqty}`,
                'headers': {
                    'Content-Type': 'application/json'
                }
            };
            request(options, (error, response) => {
                if (!error) {
                    try {
                        let ddata = JSON.parse(response.body);
                        if (ddata.code == 200) {
                            if (ddata.data.dids != undefined && ddata.data.dids.length > 0) {
                                let str = ddata.data.dids;
                                let hsmpData = [];
                                let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                let qrystr = "INSERT INTO `did_search` (`idaccount`, `phone_number`, `rate_center`, `state`, `provider`, `iduser`, `priorty`,`type`,`supplier_tier`,`supplier_rate`,`rates`,`camp_registry`,`path`,`idapi`,`key`) VALUE";
                                str.forEach((ele) => {
                                    let hmp = {
                                        phone_number: ele.number,
                                        rate_center: (0, markError_1.parseBody)(ele.rateCenter),
                                        state: (0, markError_1.parseBody)(ele.state),
                                        supplier_tier: (0, markError_1.parseBody)(ele.tier)
                                    };
                                    hsmpData.push(hmp);
                                    qrystr += "('" + this.sessdata.idaccount + "', '" + ele.number + "', '" + (0, markError_1.parseBody)(ele.ratecenter) + "', '" + (0, markError_1.parseBody)(ele.state) + "', '" + "teleapi" + "', '" + this.sessdata.iduser + "', '" + (0, markError_1.setToZero)(this.priority) + "','NN','" + ele.tier + "','nrc:" + ele.setup_rate + ",mrc:" + ele.monthly_rate + ",usage:" + ele.per_minute_rate + "','" + pLoad.rate + "','" + sdata.CampaignId + "','" + this.sessdata.path + "','" + (0, markError_1.setToZero)(this.sessdata.idapi) + "','" + this.timekey + "'),";
                                });
                                this.saveHmp(this.timekey, 'teleapi', hsmpData);
                                obj1.nonqrysql = qrystr.slice(0, -1);
                                obj1.prepare();
                                obj1.execute((err, data) => {
                                    callback(err, data);
                                });
                            }
                            else {
                                let obj = new RawView_1.RawView(res);
                                obj.prepare({ message: "No DID's found on [" + sdata.NPA + "]" });
                                obj.execute();
                            }
                        }
                        else {
                            callback('', ddata);
                        }
                    }
                    catch (e) {
                        console.log("Error :: TeleApi->getNpaNxx::", e);
                        callback(error, '');
                    }
                }
                else {
                    callback(error, '');
                }
            });
        }
    }
    getByRate(req, res, pLoad, callback) {
        if (this.priority == "100") {
            console.log("Exit from TeleAPI");
            callback('', '');
        }
        else {
            const sdata = req.query;
            var options = {
                'method': 'POST',
                // 'url': 'https://apiv1.teleapi.net/dids/list?token=' + this.key + '&state=' + `${sdata.State}` + '&ratecenter=' + `${sdata.RateCenter}` + '&limit=' + `${pLoad.searchqty}`,
                'url': TelApiRecords.TelApiListUrl + TelApiRecords.TelApiKEY + '&state=' + `${sdata.State}` + '&ratecenter=' + `${sdata.RateCenter}` + '&limit=' + `${pLoad.searchqty}`,
                'headers': {
                    'Content-Type': 'application/json'
                }
            };
            request(options, (error, response) => {
                if (!error) {
                    try {
                        let ddata = JSON.parse(response.body);
                        console.log("ddata", JSON.stringify(ddata));
                        if (ddata.code == 200) {
                            if (ddata.data.dids != undefined && ddata.data.dids.length > 0) {
                                let str = ddata.data.dids;
                                let hsmpData = [];
                                let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                let qrystr = "INSERT INTO `did_search` (`idaccount`, `phone_number`, `rate_center`, `state`, `provider`, `iduser`, `priorty`,`type`,`supplier_tier`,`supplier_rate`,`rates`,`camp_registry`,`path`,`idapi`,`key`) VALUE";
                                str.forEach((ele) => {
                                    let hmp = {
                                        phone_number: ele.number,
                                        rate_center: (0, markError_1.parseBody)(ele.rateCenter),
                                        state: (0, markError_1.parseBody)(ele.state),
                                        supplier_tier: (0, markError_1.parseBody)(ele.tier)
                                    };
                                    hsmpData.push(hmp);
                                    qrystr += "('" + this.sessdata.idaccount + "', '" + ele.number + "', '" + (0, markError_1.parseBody)(ele.ratecenter) + "', '" + (0, markError_1.parseBody)(ele.state) + "', '" + "teleapi" + "', '" + this.sessdata.iduser + "', '" + (0, markError_1.setToZero)(this.priority) + "','NN','" + ele.tier + "','nrc:" + ele.setup_rate + ",mrc:" + ele.monthly_rate + ",usage:" + ele.per_minute_rate + "','" + pLoad.rate + "','" + sdata.CampaignId + "','" + this.sessdata.path + "','" + (0, markError_1.setToZero)(this.sessdata.idapi) + "','" + this.timekey + "'),";
                                });
                                this.saveHmp(this.timekey, 'teleapi', hsmpData);
                                obj1.nonqrysql = qrystr.slice(0, -1);
                                obj1.prepare();
                                obj1.execute((err, data) => {
                                    callback(err, data);
                                });
                            }
                            else {
                                callback('', ddata);
                            }
                        }
                        else {
                            callback('', ddata);
                        }
                    }
                    catch (e) {
                        console.log("Error :: TeleApi->getByRate::", e);
                        callback(error, '');
                    }
                }
                else {
                    callback(error, '');
                }
            });
        }
    }
    getTollFree(req, res, callback) {
        if (this.priority == "100") {
            callback('', '');
        }
        else {
            this.getRate(req, res, this.sessdata.idtariff, "message", "TF", (err, voice_rate) => {
                if (err == 1 && voice_rate.length > 0) {
                    var sdata = req.query;
                    var options = {
                        'method': 'POST',
                        // 'url': 'https://apiv1.teleapi.net/dids/list?token=' + this.key + '&type=tollfree&limit=' + `${sdata.Qty}`,
                        'url': TelApiRecords.TelApiListUrl + TelApiRecords.TelApiKEY + '&type=tollfree&limit=' + `${sdata.Qty}`,
                        'headers': {
                            'Content-Type': 'application/json'
                        }
                    };
                    request(options, (error, response) => {
                        if (!error) {
                            try {
                                let ddata = JSON.parse(response.body);
                                console.log("ddata", ddata);
                                console.log(ddata.code);
                                if (ddata.code == 200) {
                                    if (ddata.data.dids != undefined && ddata.data.dids.length > 0) {
                                        let str = ddata.data.dids;
                                        let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        let qrystr = "INSERT INTO `did_search` (`idaccount` `phone_number`, `provider`, `iduser`, `priorty`,`type`,`supplier_rate`,`rates`,`path`,`idapi`,`key`) VALUE";
                                        str.forEach((ele) => {
                                            qrystr += "('" + this.sessdata.idaccount + "', '" + ele.number + "', '" + "teleapi" + "', '" + this.sessdata.iduser + "', '" + (0, markError_1.setToZero)(this.priority) + "','TF','nrc:" + ele.setup_rate + ",mrc:" + ele.monthly_rate + ",usage:" + ele.per_minute_rate + "','" + voice_rate[0].rate + "','" + this.sessdata.path + "','" + (0, markError_1.setToZero)(this.sessdata.idapi) + "','" + this.timekey + "'),";
                                        });
                                        obj1.nonqrysql = qrystr.slice(0, -1);
                                        obj1.prepare();
                                        obj1.execute((err, data) => {
                                            callback(err, data);
                                        });
                                    }
                                    else {
                                        callback('', ddata);
                                    }
                                }
                                else {
                                    callback('', ddata);
                                }
                            }
                            catch (e) {
                                console.log("Error :: TeleApi->getTollFree::", e);
                                callback(error, '');
                            }
                        }
                        else {
                            callback(error, '');
                        }
                    });
                }
                else {
                    callback(err, voice_rate);
                }
            });
        }
    }
    buyDID(req, res, did_details, other_data, callback) {
        const sdata = req.body;
        let types;
        let did = sdata.DID.trim();
        let len = did.length - 10;
        let npa = did.slice(len, len + 3);
        let nxx = did.slice(len + 3, len + 6);
        let id_grouporder = other_data.id_grouporder;
        let sub_type = other_data.sub_type;
        let days = other_data.days;
        this.getRateCenter(req, res, npa, nxx, (err, ratecenter_state) => {
            let ratecenter = ratecenter_state[0] !== undefined ? ratecenter_state[0].rc_abbre : '';
            let state = ratecenter_state[0] !== undefined ? ratecenter_state[0].loc_state : '';
            // To get the proration status
            /* let objv0 = new ModelRawQuery(req, res);
            // objv0.qrysql = "SELECT t.`proration`,t.`day_num` FROM `user`u JOIN `tariff`t ON u.idtariff=t.idtariff WHERE iduser= '" + this.sessdata.iduser + "'";
            objv0.qrysql = "SELECT t.`day_num`, DATE_FORMAT(IF(DATE_ADD(NOW(),INTERVAL t.day_num DAY) >NOW(), DATE_ADD(NOW(),INTERVAL t.day_num DAY),LAST_DAY(NOW())),'%Y-%m-%d %H:%i:%s') AS subscription_end_date FROM `user`u INNER JOIN `tariff` t ON t.idtariff=u.idtariff WHERE u.iduser= '" + this.sessdata.iduser + "'";
            objv0.prepare();
            objv0.execute((days_err, days) => {
                if (days_err == 1) { */
            // let proration_status = days[0].proration;
            let frates = other_data.fullrates;
            let did_dis_days = days[0].day_num > 0 ? days[0].day_num : 0;
            let prorate = typeof other_data.prorate != 'undefined' && other_data.prorate > 0 ? other_data.prorate : 0;
            types = did_details[0].type == 'TF' ? 'TF' : 'NN';
            var options = {
                'method': 'POST',
                // 'url': 'https://apiv1.teleapi.net/dids/order?token=' + this.key + '&number=' + `${sdata.DID.trim()}`,
                'url': TelApiRecords.TelApiOrderUrl + TelApiRecords.TelApiKEY + '&number=' + `${sdata.DID.trim()}`,
                'headers': {
                    'Content-Type': 'application/json'
                }
            };
            request(options, (error, response) => {
                if (!error) {
                    try {
                        console.log("TeleAPI::", response.body);
                        let sdata1 = JSON.parse(response.body);
                        // If order successfully placed
                        if (sdata1.code == 200 && sdata1.status == 'success') {
                            let providerOrderId = typeof sdata1.data.id != 'undefined' && sdata1.data.id ? sdata1.data.id : '';
                            let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                            obj.nonqrysql = "INSERT INTO `did_buy` (`npa`,`nxx`,`ratecenter`,`state`,`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`inbound_key`,`outbound_key`,`connection_key`,`sms_inbound_key`,`sms_outbound_key`,`rates`,`idapi`,`sms_provider`,`did_disconnect_days`,`nrc_rates`,`did_sub_type`, `subscription_end_date`) VALUE('" + npa + "','" + nxx + "','" + ratecenter + "','" + state + "','" + this.sessdata.idaccount + "','" + sdata1.data.user_id + "','completed','" + sdata1.data.number + "','teleapi','" + sdata1.data.id + "','" + types + "','" + this.sessdata.iduser + "','1','" + sdata.InboundVoice + "','" + sdata.OutboundVoice + "','" + sdata.Connection + "','" + sdata.InboundSMS + "','" + sdata.OutboundSMS + "','" + frates + "','" + (0, markError_1.setToZero)(this.sessdata.idapi) + "','teleapi','" + did_dis_days + "','" + frates + "','" + sub_type + "','" + days[0].subscription_end_date + "')";
                            obj.prepare();
                            obj.execute((err, data) => {
                                if (err == 1) {
                                    console.log(prorate);
                                    let objv = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                    objv.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-" + prorate + " WHERE `idaccount`='" + this.sessdata.idaccount + "'";
                                    objv.prepare();
                                    objv.execute((wallet_error, wallet_success) => {
                                        // To update the wallet transaction log
                                        let iQry = "INSERT INTO `wallet_recharge_log` SET ";
                                        iQry += "`idaccount`=" + this.sessdata.idaccount + ", ";
                                        iQry += "`amount`='-" + prorate + "', ";
                                        iQry += "`purpose`='Wallet amount successfully updated for buy a new DID', ";
                                        iQry += "`status`=1;";
                                        let objWL = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        objWL.nonqrysql = iQry;
                                        objWL.prepare();
                                        objWL.execute((error, result) => {
                                            console.log("Transaction response::", result);
                                        });
                                        // To create the DID log
                                        let objv1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        objv1.nonqrysql = "INSERT INTO `did_log` (`account_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`rates`,`idapi`,`pro_rates`,`event_type`,`description`,`full_log`) VALUE('" + this.sessdata.idaccount + "','completed','" + sdata1.data.number + "','teleapi','" + sdata1.data.id + "','" + types + "','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + frates + "','" + (0, markError_1.setToZero)(this.sessdata.idapi) + "','" + prorate + "','1','DID Buy','" + response.body + "')";
                                        objv1.prepare();
                                        objv1.execute((log_error, did_log) => { });
                                        // To delete the DID from cart
                                        let obj5 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        obj5.nonqrysql = "DELETE FROM `did_cart` WHERE did='" + sdata.DID + "'";
                                        obj5.prepare();
                                        obj5.execute((walletError, wallet) => { });
                                        // To update the process count of group order
                                        let objk = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        objk.nonqrysql = "UPDATE `did_group_order` SET `status`='1' WHERE `id_grouporder`=" + id_grouporder + ";";
                                        objk.prepare();
                                        objk.execute((error, result) => {
                                            console.log("GroupOrder process count::\n", result);
                                        });
                                        // To create the did_order
                                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`, `error_code`, `type`, `cost`, `description`, `id_grouporder`, `is_process`) VALUE('" + this.sessdata.iduser + "', '" + this.sessdata.idaccount + "', '201','" + sdata.DID + "', '2', '" + types + "', '" + frates + "', 'Order successfully created.', " + id_grouporder + ", 1)";
                                        obj.prepare();
                                        obj.execute((did_err, did_data) => {
                                            // To update the other data on current order
                                            if (did_err == 1) {
                                                let id_order = did_data.insertId;
                                                let orderID = "SORD" + id_order.toString();
                                                let log_error = "";
                                                let log_message = sdata1.status.replace(/'/g, "\\'").replace(/"/g, '\\"');
                                                let log_result = JSON.stringify(sdata1).replace(/'/g, "\\'").replace(/"/g, '\\"');
                                                obj.nonqrysql = "UPDATE `did_order` SET `order_no`='" + orderID + "', `log_statusCode`='200', `log_error`='" + log_error + "', `log_message`='" + log_message + "', `log_result`='" + log_result + "', `log_status`=0, `provider`='teleapi', `providerOrderId`='" + providerOrderId + "' WHERE `id_order`=" + id_order + ";";
                                                obj.prepare();
                                                obj.execute((error, result) => { });
                                            }
                                            let objV = new RawView_1.RawView(res);
                                            objV.prepare({
                                                error_code: 1,
                                                status: 201,
                                                message: "DID buy successfully.",
                                                result: [
                                                    {
                                                        "did": sdata.DID
                                                    }
                                                ]
                                            });
                                            objV.execute();
                                        });
                                    });
                                    /* // update end subscription date
                                    let obj0 = new ModelRawQuery(req, res);
                                    obj0.qrysql = "SELECT d.iddid, d.iduser, d.account_id, d.user_id,IF(DATE_ADD(d.`created_at`,INTERVAL t.day_num DAY) >NOW(),DATE_ADD(d.`created_at`,INTERVAL t.day_num DAY),LAST_DAY(NOW()))AS subscription_end_date,DATE_FORMAT(d.`created_at`,'%Y-%m-%d %H:%i:%s')`created_at` FROM `did_buy`d LEFT JOIN `endpoint`e ON d.connection_key = e.connection_key INNER JOIN  `user`u ON d.iduser=u.iduser INNER JOIN `tariff` t ON t.idtariff=u.idtariff WHERE d.iddid='" + data.insertId + "' AND disconnect_did_status = '1'";
                                    obj0.prepare();
                                    obj0.execute((dids_err, didRes) => {
                                        let dates = didRes[0].subscription_end_date;
                                        let isoDate = new Date(dates);
                                        let subscriptionEndDate = isoDate.toJSON().slice(0, 19).replace('T', ' ');
                                        let obj01 = new ModelRawNonQuery(req, res);
                                        obj01.nonqrysql = "UPDATE `did_buy` SET `subscription_end_date`='" + subscriptionEndDate + "' WHERE `iddid`=" + didRes[0].iddid + ";"
                                        obj01.prepare();
                                        obj01.execute((error, result) => { })
                                    }) */
                                }
                                else {
                                    let obj = new RawView_1.RawView(res);
                                    obj.prepare({
                                        error_code: 0,
                                        status: 502,
                                        message: "Something went wrong with connection"
                                    });
                                    obj.execute();
                                }
                            });
                            /* let dateObj = new Date();
                            let day = dateObj.getUTCDate();
                            let nDate: any = new Date()
                            let lDate: any = (new Date(nDate.getFullYear(), (nDate.getMonth() + 1), 0)).getDate()
                            let totalDays = (lDate - day) + 1;
                            let prorate: any;
                            if (other_data.proration == "true") {
                                prorate = ((totalDays * did_details[0].rates) / lDate) + other_data.setup_cost;
                            }
                            else {
                                prorate = (did_details[0].rates) + other_data.setup_cost;
                            } */
                        }
                        // If order failed
                        else {
                            let providerOrderId = typeof sdata1.data.id != 'undefined' && sdata1.data.id ? sdata1.data.id : '';
                            let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                            obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`, `error_code`, `type`, `cost`, `description`, `id_grouporder`, `is_process`) VALUE('" + this.sessdata.iduser + "', '" + this.sessdata.idaccount + "', '501', '" + sdata.DID + "', '4', '" + types + "', '" + frates + "', 'Order creation failed!', " + id_grouporder + ", 1)";
                            obj.prepare();
                            obj.execute((did_err, did_data) => {
                                // To update the other data on current order
                                if (did_err == 1) {
                                    let id_order = did_data.insertId;
                                    let orderID = "SORD" + id_order.toString();
                                    let log_error = JSON.stringify(sdata1).replace(/'/g, "\\'").replace(/"/g, '\\"');
                                    let log_message = sdata1.data.replace(/'/g, "\\'").replace(/"/g, '\\"');
                                    let log_result = "";
                                    obj.nonqrysql = "UPDATE `did_order` SET `order_no`='" + orderID + "', `log_statusCode`='" + sdata1.code + "', `log_error`='" + log_error + "', `log_message`='" + log_message + "', `log_result`='" + log_result + "', `log_status`=1, `provider`='teleapi', `providerOrderId`='" + providerOrderId + "' WHERE `id_order`=" + id_order + ";";
                                    obj.prepare();
                                    obj.execute((error, result) => { });
                                }
                                // To update the status of group order
                                let objk = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                objk.nonqrysql = "UPDATE `did_group_order` SET `status`='3' WHERE `id_grouporder`=" + id_grouporder + ";";
                                objk.prepare();
                                objk.execute((error, result) => {
                                    console.log("Failed");
                                });
                                let objn = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                objn.nonqrysql = "INSERT INTO `did_log`(`account_id`,`iduser`,`updated_at`,`event_type`,`description`,`did`,`full_log`) VALUE('" + this.sessdata.idaccount + "','" + this.sessdata.iduser + "',NOW(),'40','DID Buy failed from provider','" + sdata.DID.trim() + "','" + response.body + "')";
                                objn.prepare();
                                objn.execute((errorDiDLg, resDiDLg) => {
                                    console.log("DID Buy failed from provider");
                                });
                                let objV = new RawView_1.RawView(res);
                                objV.prepare({
                                    error_code: 0,
                                    status: sdata1.code,
                                    message: sdata1.data,
                                    error: sdata1
                                });
                                objV.execute();
                            });
                        }
                    }
                    catch (e) {
                        console.log("Error :: TeleApi->buyDID::", e);
                        let obj = new RawView_1.RawView(res);
                        obj.prepare({
                            error_code: 0,
                            status: 400,
                            error: error
                        });
                        obj.execute();
                    }
                }
                else {
                    let obj = new RawView_1.RawView(res);
                    obj.prepare({
                        error_code: 0,
                        status: 400,
                        error: error
                    });
                    obj.execute();
                }
            });
            /* }
            else {
                let obj = new RawView(res);
                obj.prepare({
                    error_code: 0,
                    status: 502,
                    message: "Something went wrong with get proration!"
                });
                obj.execute();
            }
        }); */
        });
    }
    disconnectDID(req, res, callback) {
        const sdata = req.body;
        let iduser = (typeof sdata.iduser != 'undefined' && sdata.iduser > 0) ? sdata.iduser : this.sessdata.iduser;
        var options = {
            // 'url': 'https://apiv1.teleapi.net/user/dids/remove?token=' + this.key + '&number=' + `${sdata.DID.trim()}`,
            'url': TelApiRecords.TelApiRemoveUrl + TelApiRecords.TelApiKEY + '&number=' + `${sdata.DID.trim()}`,
            'headers': {
                'Content-Type': 'application/json'
            }
        };
        request(options, (error, response) => {
            console.log("TeleAPI Err::", error);
            if (!error) {
                try {
                    console.log("TeleAPI Res::", response.body);
                    let data = JSON.parse(response.body);
                    if (data.code == 200) {
                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        obj.nonqrysql = "UPDATE `did_buy` set `disconnect_did_status`='3',`updated_at`=NOW() WHERE `did`='" + sdata.DID.trim() + "'AND `iduser`='" + iduser + "'";
                        obj.prepare();
                        obj.execute((error, resp) => {
                            if (error == 1) {
                                // To  update updated_at date in did log
                                let obj = new RawQuery_1.ModelRawQuery(req, res);
                                // obj.qrysql = "UPDATE `did_log` SET `updated_at`=NOW(), `disconnect_did_status`='3' WHERE `did`='" + sdata.DID.trim() + "' AND `iduser`='" + iduser + "' ORDER BY `iddidlog` DESC LIMIT 1"
                                obj.nonqrysql = "INSERT INTO `did_log` (`account_id`,`iduser`,`updated_at`,`event_type`,`description`,`did`,`disconnect_did_status`,`full_log`) VALUE('" + this.sessdata.idaccount + "','" + iduser + "',NOW(),'5','Disconnect DID from provider','" + sdata.DID.trim() + "','3','" + response.body + "')";
                                obj.prepare();
                                obj.execute((errorDiDLg, resDiDLg) => { });
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ status: 201, message: "DID Disconnected Successfully" });
                                objv.execute();
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ status: 502, message: "Something went wrong with connection!" });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objn = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        objn.nonqrysql = "INSERT INTO `did_log`(`account_id`,`iduser`,`updated_at`,`event_type`,`description`,`did`,`full_log`) VALUE('" + this.sessdata.idaccount + "','" + this.sessdata.iduser + "',NOW(),'39','DID disconnect failed from provider','" + sdata.DID.trim() + "','" + response.body + "')";
                        objn.prepare();
                        objn.execute((errorDiDLg, resDiDLg) => {
                            console.log("DID disconnect failed FROM provider");
                        });
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ status: data.code, message: data.status, error: data.data });
                        objv.execute();
                    }
                }
                catch (e) {
                    console.log("Error :: TeleApi->disconnectDID::", e);
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ status: 400, error: error, message: "DID not Disconnected!" });
                    objv.execute();
                }
            }
            else {
                console.log("TeleApi :::::::::::::::::::");
                let objv = new RawView_1.RawView(res);
                objv.prepare({ status: 400, error: error, message: "DID not Disconnected!" });
                objv.execute();
            }
        });
    }
}
exports.TeleAPI = TeleAPI;
