"use strict";
// import winston from 'winston';
// import fs from 'fs';
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Logger = void 0;
// // Define color schemes for log levels
// const colors = {
//   error: 'red',
//   warn: 'yellow',
//   info: 'green',
//   http: 'magenta',
//   debug: 'white',
// };
// winston.addColors(colors);
// // Log folder path
// let logFolder: string = '';
// const currentDate = new Date().toISOString().split('T')[0];
// // Define log format
// const format = winston.format.combine(
//   winston.format.json(),
//   winston.format.timestamp({ format: 'MM-DD-YYYY HH:mm:ss:ms' }),
//   winston.format.printf(({ timestamp, message }) => {
//     const idaccountRegex = /"idaccount":(\d+)/;
//     const match = message.match(idaccountRegex);
//     const idaccountValue = match ? match[1] : '';
//     const filteredMessage = message.replace(idaccountRegex, '').replace(/,,/g, ',');
//     checkNewLogFile(idaccountValue, filteredMessage);
//     return filteredMessage;
//   })
// );
// // Function to create logs dynamically
// function checkNewLogFile(idaccountValue: string, message: string) {
//   logFolder = `logs/${currentDate}`;
//   try {
//     if (!fs.existsSync(logFolder)) {
//       fs.mkdirSync(logFolder, { recursive: true });
//     }
//     const idaccountFilename = `${logFolder}/${100000000 + parseInt(idaccountValue)}.log`;
//     if (!fs.existsSync(idaccountFilename)) {
//       fs.writeFileSync(idaccountFilename, '');
//     }
//     const logData = `${message}\n`;
//     fs.appendFileSync(idaccountFilename, logData);
//   } catch (error) {
//     console.error('Error occurred while creating or writing to log file:', error);
//   }
// }
// // Define separate transport for unauthorized logs
// const unauthorizedLogTransport = new winston.transports.File({
//   filename: `logs/unauthorized-access.log`,
//   level: 'warn', // Unauthorized access is a warning
// });
// const transports = [
//   new winston.transports.Console({ level: 'error' }),
//   unauthorizedLogTransport, // Add unauthorized log transport
// ];
// // Create the logger instance
// const Logger = winston.createLogger({
//   format,
//   transports,
// });
// // Export the logger
// export { Logger };
const winston_1 = __importDefault(require("winston"));
const fs_1 = __importDefault(require("fs"));
// Define color schemes for log levels
const colors = {
    error: 'red',
    warn: 'yellow',
    info: 'green',
    http: 'magenta',
    debug: 'white',
};
winston_1.default.addColors(colors);
// Log folder path
let logFolder = '';
const currentDate = new Date().toISOString().split('T')[0];
// Function to dynamically get the unauthorized log transport
function getUnauthorizedLogTransport() {
    logFolder = `logs/${currentDate}`;
    if (!fs_1.default.existsSync(logFolder)) {
        fs_1.default.mkdirSync(logFolder, { recursive: true });
    }
    return new winston_1.default.transports.File({
        filename: `${logFolder}/unauthorized-access.log`,
        level: 'warn', // Unauthorized access is a warning
    });
}
// Define log format
const format = winston_1.default.format.combine(winston_1.default.format.json(), winston_1.default.format.timestamp({ format: 'MM-DD-YYYY HH:mm:ss:ms' }), winston_1.default.format.printf(({ timestamp, message }) => {
    const idaccountRegex = /"idaccount":(\d+)/;
    const match = message.match(idaccountRegex);
    const idaccountValue = match ? match[1] : '';
    const filteredMessage = message.replace(idaccountRegex, '').replace(/,,/g, ',');
    // Only create logs for idaccount if value is valid
    if (idaccountValue && !isNaN(parseInt(idaccountValue))) {
        checkNewLogFile(idaccountValue, filteredMessage);
    }
    return filteredMessage;
}));
// Function to create logs dynamically
function checkNewLogFile(idaccountValue, message) {
    logFolder = `logs/${currentDate}`;
    try {
        if (!fs_1.default.existsSync(logFolder)) {
            fs_1.default.mkdirSync(logFolder, { recursive: true });
        }
        const idaccountFilename = `${logFolder}/${100000000 + parseInt(idaccountValue)}.log`;
        if (!fs_1.default.existsSync(idaccountFilename)) {
            fs_1.default.writeFileSync(idaccountFilename, '');
        }
        const logData = `${message}\n`;
        fs_1.default.appendFileSync(idaccountFilename, logData);
    }
    catch (error) {
        console.error('Error occurred while creating or writing to log file:', error);
    }
}
// Create the logger instance with dynamic unauthorized transport
const Logger = winston_1.default.createLogger({
    format,
    transports: [
        new winston_1.default.transports.Console({ level: 'error' }),
        getUnauthorizedLogTransport(), // Recreate unauthorized log transport dynamically
    ],
});
exports.Logger = Logger;
