import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from 'src/app/shared/service/AppService.class';
import { environment } from 'src/environments/environment';
import { LoaderEnabled } from '../shared/loader/loader.service';
let AgentserviceService = class AgentserviceService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
    }
    getSingleAgent(id) {
        this.appmod = "getsingleagent";
        let result = super.getService(id);
        this.appmod = "";
        return result;
    }
    getAccSettingStatus() {
        this.appmod = "getAccSettingStatus";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    channelRequest(data) {
        this.appmod = 'channel-request';
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    getRequestChannelList(data) {
        this.appmod = "channel-request-list";
        let tmp = this.getService(data);
        this.appmod = "";
        return tmp;
    }
    channelLimitStatus(data) {
        this.appmod = "approve-and-reject-channel-limit";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    getSingleGroup(id) {
        this.appmod = "getsinglegroup";
        let result = super.getService(id);
        this.appmod = "";
        return result;
    }
    getAgents(groupKey) {
        let apiURL = environment.SERVER + "getagents";
        return this.http.get(apiURL, { headers: this.httpHeaders, params: { groupKey: groupKey } });
    }
    saveAgent(data) {
        let apiURL = environment.SERVER + "addagent";
        return this.http.post(apiURL, data, { headers: this.httpHeaders });
    }
    updateAgent(data) {
        let apiURL = environment.SERVER + "updateagent";
        return this.http.patch(apiURL, data, { headers: this.httpHeaders });
    }
    deleteAgent(id) {
        this.appmod = "deleteagent";
        let result = super.deleteService(id);
        this.appmod = "";
        return result;
    }
    saveGroup(data) {
        let apiURL = environment.SERVER + "addgroup";
        return this.http.post(apiURL, data, { headers: this.httpHeaders });
    }
    updateGroup(data) {
        let apiURL = environment.SERVER + "updategroup";
        return this.http.patch(apiURL, data, { headers: this.httpHeaders });
    }
    getGroups() {
        let apiURL = environment.SERVER + "getgroup";
        return this.http.get(apiURL, { headers: this.httpHeaders });
    }
    deleteGroup(id) {
        this.appmod = "deletegroup";
        let result = super.deleteService(id);
        this.appmod = "";
        return result;
    }
    saveMapping(data) {
        let apiURL = environment.SERVER + "addtiermapping";
        return this.http.post(apiURL, data, { headers: this.httpHeaders });
    }
    getTierMapping(id) {
        this.appmod = "getmapping";
        let result = this.getService(id);
        this.appmod = "";
        return result;
    }
    updateMapping(data) {
        let apiURL = environment.SERVER + "updatemapping";
        return this.http.put(apiURL, data, { headers: this.httpHeaders });
    }
    get_agent() {
        return this.http.get('./assets/agentdetails.json');
    }
    get_group() {
        return this.http.get('./assets/groupdetails.json');
    }
};
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "getSingleAgent", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "getAccSettingStatus", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "channelRequest", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "getRequestChannelList", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "channelLimitStatus", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "getSingleGroup", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "getAgents", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "saveAgent", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "updateAgent", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "deleteAgent", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "saveGroup", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "updateGroup", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "getGroups", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "deleteGroup", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "saveMapping", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "getTierMapping", null);
__decorate([
    LoaderEnabled()
], AgentserviceService.prototype, "updateMapping", null);
AgentserviceService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], AgentserviceService);
export { AgentserviceService };
//# sourceMappingURL=agentservice.service.js.map