import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { NavigationStart } from '@angular/router';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { filter, map } from 'rxjs/operators';
let GroupComponent = class GroupComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.searchText = { count: 0 };
        this.page = 1;
        this.count = 0;
        this.tableSize = 50;
        this.tableSizes = [50, 100, 150];
        this.responseMessage = "";
        this.groupData = [];
        this.errMessage = "";
        this.state$ = this.router.events.pipe(filter(e => e instanceof NavigationStart), map(() => this.router.getCurrentNavigation().extras.state));
        this.state$.subscribe(res => {
            if (res) {
                if (res.status == true) {
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                }
            }
        });
    }
    ngOnInit() {
        this.data.get_group().subscribe((result) => {
            this.header = result[0].headers_details;
            this.rowdata = result[0].list_data;
        });
        this.getGroup();
    }
    getGroup() {
        this.data.getGroups().subscribe(res => {
            if (res.status == 200) {
                this.groupData = res.data;
                $('#basic-datatables').DataTable().clear();
                $('#basic-datatables').DataTable().destroy();
                $.getScript('./assets/table.js');
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    deleteGroup(id) {
        if (confirm("Are you sure you want delete data!")) {
            this.data.deleteGroup(id).subscribe(res => {
                if (res.status == 201) {
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                    this.ngOnInit();
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, error => {
                this.errMessage = error.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            });
        }
        else {
            return;
        }
    }
};
GroupComponent = __decorate([
    Component({
        selector: 'app-group',
        templateUrl: './group.component.html',
        styleUrls: ['./group.component.css']
    })
], GroupComponent);
export { GroupComponent };
//# sourceMappingURL=group.component.js.map