import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
let AddtokenComponent = class AddtokenComponent {
    constructor(data, fb, dialog) {
        this.data = data;
        this.fb = fb;
        this.dialog = dialog;
        this.submitted = false;
        this.responseMessage = "";
        this.dangMessage = "";
        this.errMessage = "";
    }
    ngOnInit() {
        let session$ = sessionStorage.getItem("isLoggedIn");
        this.session = JSON.parse(session$);
        this.userType = this.session.type;
        this.data.subCustomers().subscribe((result) => {
            this.users = result.data;
        }, err => {
            console.log(err.message);
        });
        this.tokenForm = this.fb.group({
            name: ['', [Validators.required]],
            account: [''],
            user: ['', [Validators.required]],
            idtariff: [''],
            status: ['']
        });
        this.tokenForm.patchValue({
            account: this.session.idaccount,
            user: this.session.iduser,
            idtariff: this.session.idtariff,
            status: this.session.status
        });
    }
    onTokenSave() {
        this.submitted = true;
        if (this.tokenForm.value.user == '' && this.userType == 2) {
            return false;
        }
        else {
            if (this.tokenForm.invalid) {
                return;
            }
            else {
                this.data.saveToken(this.tokenForm.value).subscribe(res => {
                    if (res.data) {
                        this.responseMessage = res.message;
                        setTimeout(() => {
                            this.responseMessage = "";
                        }, 5000);
                        this.dialog.close(res.message);
                    }
                    else {
                        this.dangMessage = res.message;
                        setTimeout(() => {
                            this.dangMessage = "";
                        }, 5000);
                    }
                }, err => {
                    this.responseMessage = err.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                });
            }
        }
    }
    onSelectUser(e) {
        let iduser = e.target.value;
        let selectedUser = this.users.find(x => x.iduser == iduser);
        this.tokenForm.patchValue({
            user: selectedUser.iduser,
            idtariff: selectedUser.idtariff,
            status: selectedUser.status,
            account: selectedUser.idaccount,
        });
    }
    onReset() {
        this.submitted = false;
        if (this.userType == 2) {
            this.tokenForm.get('user').setValue('');
            this.tokenForm.get('name').setValue('');
        }
        else {
            this.tokenForm.reset({
                account: this.session.idaccount,
                user: this.session.iduser,
                idtariff: this.session.idtariff,
                status: this.session.status
            });
        }
    }
};
AddtokenComponent = __decorate([
    Component({
        selector: 'app-addtoken',
        templateUrl: './addtoken.component.html',
        styleUrls: ['./addtoken.component.css']
    })
], AddtokenComponent);
export { AddtokenComponent };
//# sourceMappingURL=addtoken.component.js.map