import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { AddtokenComponent } from '../addtoken/addtoken.component';
let TokensComponent = class TokensComponent extends AppComponentClass {
    constructor(data, dialog, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.dialog = dialog;
        this.router = router;
        this.fb = fb;
        this.filterMetadata = { count: 0 };
        this.searchText = { count: 0 };
        this.pShow = false;
        this.page = 1;
        this.count = 0;
        this.tableSize = 25;
        this.tableSizes = [25, 50, 100];
        this.responseMessage = "";
        this.msgHideAndShow = false;
        this.resData = [];
    }
    ngOnInit() {
        this.password = "password";
        // const table: any = $('#basic-datatables');
        this.data.getApiToken().subscribe(res => {
            this.resData = res.data;
            $('#basic-datatabless06').DataTable().destroy();
            $.getScript('./assets/table.js');
            this.resData.forEach(element => {
                element.pShow = false;
                element.pswd = "password";
            });
        });
    }
    keyToggle(id) {
        this.resData.forEach(element => {
            if (element.idapi == id) {
                if (element.pswd == 'password') {
                    element.pswd = 'text';
                    element.pShow = true;
                }
                else {
                    element.pswd = 'password';
                    element.pShow = false;
                }
            }
        });
    }
    openDialog() {
        const dialogRef = this.dialog.open(AddtokenComponent, {
            disableClose: true,
        });
        dialogRef.afterClosed().subscribe(result => {
            this.responseMessage = result;
            setTimeout(() => {
                this.responseMessage = "";
            }, 5000);
            this.ngOnInit();
        });
    }
    onApiDelete(id, key) {
        if (confirm("Are you sure you want delete data!")) {
            this.data.onDeleteApiToken(id + "@" + key).subscribe(res => {
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
                this.data.getApiToken().subscribe(res => {
                    this.resData = res.data;
                    $('#basic-datatabless06').DataTable().destroy();
                    $.getScript('./assets/table.js');
                    this.resData.forEach(element => {
                        element.pShow = false;
                        element.pswd = "password";
                    });
                });
            });
        }
        else {
            "Cancel!";
        }
    }
    textMessageFunc(msgText) {
        this.responseMessage = "Copied to Clipboard";
        setTimeout(() => {
            this.responseMessage = "";
        }, 5000);
    }
    applyFilter(event) {
        const filterValue = event.target.value;
        this.dataSource.filter = filterValue.trim().toLowerCase();
        if (this.dataSource.paginator) {
            this.dataSource.paginator.firstPage();
        }
    }
};
TokensComponent = __decorate([
    Component({
        selector: 'app-tokens',
        templateUrl: './tokens.component.html',
        styleUrls: ['./tokens.component.css']
    })
], TokensComponent);
export { TokensComponent };
//# sourceMappingURL=tokens.component.js.map