import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { AppService } from '../shared/service/AppService.class';
import { HttpHeaders } from '@angular/common/http';
import { APIURL } from '../app-routing.module';
import { BehaviorSubject } from 'rxjs';
import { LoaderEnabled } from '../shared/loader/loader.service';
import { environment } from 'src/environments/environment';
let AuthenticationService = class AuthenticationService extends AppService {
    constructor(http, router) {
        super(http);
        this.http = http;
        this.router = router;
        this.appmod = "login";
        this.currentUserSubject = new BehaviorSubject(JSON.parse(sessionStorage.getItem('isLoggedIn')));
        this.currentUser = this.currentUserSubject.asObservable();
    }
    get currentUserValue() {
        return this.currentUserSubject.getValue();
    }
    logout() {
        this.http.get(APIURL + "login").subscribe(res => {
            console.log("User Logged Out Successfully");
            localStorage.clear();
            sessionStorage.clear();
            this.router.navigate(['/login']).then(() => {
                location.reload();
            });
        }, err => {
            console.log("User Logged Out Successfully");
            localStorage.clear();
            sessionStorage.clear();
            this.router.navigate(['/login']).then(() => {
                location.reload();
            });
        });
    }
    forgotpass(data) {
        let tmp = this.appmod;
        this.appmod = 'custom/forgotpwd';
        let result = this.saveService(data);
        this.appmod = tmp;
        return result;
    }
    SessionLogin(type) {
        let tmp = this.appmod;
        this.appmod = 'login';
        let data = this.getService(type);
        this.appmod = tmp;
        return data;
    }
    Signup(data, url) {
        this.appmod = "signup";
        let result = super.saveService(data, url);
        this.appmod = "login";
        return result;
    }
    sendMailForgot(filter) {
        let tmp = this.appmod;
        this.appmod = "forgot-mail";
        let result = super.getService(filter);
        this.appmod = tmp;
        return result;
    }
    verifyToken(token) {
        let tmp = this.appmod;
        this.appmod = "verify-token";
        let result = super.getService(token);
        this.appmod = tmp;
        return result;
    }
    verifyUrl(url) {
        let tmp = this.appmod;
        this.appmod = "verify-url";
        let result = super.getService(url);
        this.appmod = tmp;
        return result;
    }
    updatePassword(password) {
        this.appmod = "update-password";
        let result = super.updateService(password);
        this.appmod = "login";
        return result;
    }
    googleLogin() {
        const apiURL = environment.SERVER + 'auth/google';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders });
    }
    countryCodes() {
        return this.http.get('./assets/country_codes.json');
    }
    /**
     * To setup the system Timezone
     */
    SetSystemTZ(data) {
        this.appmod = "update_sys_tz";
        let result = super.saveService(data);
        this.appmod = "login";
        return result;
    }
};
__decorate([
    LoaderEnabled()
], AuthenticationService.prototype, "SessionLogin", null);
__decorate([
    LoaderEnabled()
], AuthenticationService.prototype, "Signup", null);
__decorate([
    LoaderEnabled()
], AuthenticationService.prototype, "sendMailForgot", null);
__decorate([
    LoaderEnabled()
], AuthenticationService.prototype, "verifyToken", null);
__decorate([
    LoaderEnabled()
], AuthenticationService.prototype, "verifyUrl", null);
__decorate([
    LoaderEnabled()
], AuthenticationService.prototype, "updatePassword", null);
AuthenticationService = __decorate([
    Injectable({
        providedIn: "root"
    })
], AuthenticationService);
export { AuthenticationService };
//# sourceMappingURL=authentication.service.js.map