import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators, FormControl } from '@angular/forms';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let ForgotComponent = class ForgotComponent extends AppComponentClass {
    constructor(data, router, fb, activatedroute) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.activatedroute = activatedroute;
        this.submitted = false;
        this.errMessage = "";
        this.responseMessage = "";
        this.getForgotUserPass = [];
        this.isPasswordType = "";
        this.isUpdatePassword = false;
        this.mailSendSuccess = false;
        this.submitted1 = false;
    }
    ngOnInit() {
        this.ForgotForm = this.fb.group({
            key: new FormControl(''),
            email: new FormControl('', [Validators.required, Validators.pattern("^[a-z0-9._%+-]+@[a-z0-9.-]+\\.[a-z]{2,4}$")]),
            password: new FormControl('', [Validators.required, Validators.minLength(8)]),
            confirm_password: new FormControl('', [Validators.required, Validators.minLength(8)]),
        });
        this.activatedroute.paramMap.subscribe((params) => {
            let id = params.get('id');
            this.ForgotForm.patchValue({
                key: id,
            });
            console.log(id);
            if (id === 'forgot-password') {
                this.isUpdatePassword = false;
                return this.isPasswordType = '1';
            }
            else {
                this.data.verifyToken(id).subscribe(res => {
                    if (res.status == 201) {
                        this.responseMessage = res.message;
                        setTimeout(() => {
                            this.responseMessage = "";
                        }, 5000);
                        this.isUpdatePassword = true;
                    }
                    else {
                        this.errMessage = res.message;
                        setTimeout(() => {
                            this.errMessage = "";
                            this.router.navigate(['password/forgot-password']);
                        }, 5000);
                        this.isUpdatePassword = false;
                    }
                });
                return this.isPasswordType = "2";
            }
        });
    }
    onForgot() {
        if (this.isUpdatePassword) {
            if (this.ForgotForm.controls.password.invalid || this.ForgotForm.controls.confirm_password.invalid) {
                this.submitted = true;
                return;
            }
            else {
                if (this.ForgotForm.value.password === this.ForgotForm.value.confirm_password) {
                    this.data.updatePassword(this.ForgotForm.value).subscribe(res => {
                        if (res.status == 201) {
                            this.responseMessage = res.message;
                            setTimeout(() => {
                                this.responseMessage = "";
                                this.router.navigate(['/']);
                            }, 5000);
                        }
                        else {
                            this.errMessage = res.message;
                            setTimeout(() => {
                                this.errMessage = "";
                            }, 5000);
                        }
                    });
                }
                else {
                    this.errMessage = "Password and Confirm-Password Does Not Match!";
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }
        }
        else {
            if (this.ForgotForm.controls.email.invalid) {
                this.submitted1 = true;
                return;
            }
            else {
                var fpdata = this.ForgotForm.value;
                this.data.sendMailForgot(fpdata.email).subscribe(res => {
                    if (res.status == 201) {
                        this.responseMessage = res.message;
                        this.showMessage = res.message;
                        this.mailSendSuccess = true;
                        setTimeout(() => {
                            this.responseMessage = "";
                        }, 5000);
                    }
                    else {
                        this.errMessage = res.message;
                        setTimeout(() => {
                            this.errMessage = "";
                        }, 5000);
                    }
                });
            }
        }
    }
};
ForgotComponent = __decorate([
    Component({
        selector: 'app-forgot',
        templateUrl: './forgot.component.html',
        styleUrls: ['./forgot.component.css']
    })
], ForgotComponent);
export { ForgotComponent };
//# sourceMappingURL=forgot.component.js.map