import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { throwError } from 'rxjs';
import { catchError } from 'rxjs/operators';
let HttpErrorInterceptor = class HttpErrorInterceptor {
    constructor(router) {
        this.router = router;
    }
    intercept(request, next) {
        return next.handle(request).pipe(catchError((error) => {
            // If there is an invalid session or session doesn't exist
            if (error.status == 406) {
                let errorMessage = error.error.message;
                localStorage.clear();
                sessionStorage.clear();
                sessionStorage.setItem("errMsg", errorMessage);
                this.router.navigate(['/login']);
            }
            return throwError(error);
        }));
    }
};
HttpErrorInterceptor = __decorate([
    Injectable()
], HttpErrorInterceptor);
export { HttpErrorInterceptor };
//# sourceMappingURL=error.interceptor.js.map