import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
let JwtInterceptor = class JwtInterceptor {
    constructor() { }
    intercept(request, next) {
        // add auth header with jwt if user is logged in and request is to api url
        const currentUser = sessionStorage.getItem("authkey");
        const isLoggedIn = sessionStorage.getItem("isLoggedIn");
        // console.log(currentUser.authkey);
        if (isLoggedIn || isLoggedIn != undefined) {
            request = request.clone({
                setHeaders: {
                    Authorization: currentUser
                }
            });
        }
        return next.handle(request);
    }
};
JwtInterceptor = __decorate([
    Injectable()
], JwtInterceptor);
export { JwtInterceptor };
//# sourceMappingURL=jwt.interceptor.js.map