import { __awaiter, __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
import { AppComponentClass } from '../../shared/service/AppComponent.class';
let LoginComponent = class LoginComponent extends AppComponentClass {
    // kyc_verify_status: any;
    constructor(data, router, fb, activatedroute, userService) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.activatedroute = activatedroute;
        this.userService = userService;
        this.isEditable = false;
        this.state = false;
        this.currdomain = [];
        this.loginform = true;
        this.recoverform = false;
        this.appPermissions = [];
        this.error = '';
        this.isLoading = false;
        this.submitted = false;
        this.errMessage = "";
        this.responseMessage = "";
    }
    ngOnInit() {
        this.invokeErr();
        if (this.data.currentUserValue) {
            this.router.navigate(['/']);
        }
        let currhost = window.location.host;
        localStorage.setItem("host", currhost);
        this.currdomain = currhost.split(".");
        this.loginForm = this.fb.group({
            username: ['', { validators: [Validators.required] }],
            password: ['', { validators: [Validators.required, Validators.minLength(8)] }],
            sessionType: ['PANEL']
        });
        this.returnUrl = this.activatedroute.snapshot.queryParams['returnUrl'] || '/';
        $(document).ready(() => {
            $(".username").focus(() => {
                $(".user-icon").css("left", "-48px");
            });
            $(".username").blur(() => {
                $(".user-icon").css("left", "0px");
            });
            $(".password").focus(() => {
                $(".pass-icon").css("left", "-48px");
            });
            $(".password").blur(() => {
                $(".pass-icon").css("left", "0px");
            });
        });
    }
    get errMsg() {
        return sessionStorage.getItem("errMsg");
    }
    invokeErr() {
        this.errMessage = this.errMsg;
        setTimeout(() => {
            sessionStorage.removeItem("errMsg");
            this.errMessage = '';
        }, 5000);
    }
    showRecoverForm() {
        this.loginform = !this.loginform;
        this.recoverform = !this.recoverform;
    }
    wait(ms) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise(resolve => setTimeout(resolve, ms));
        });
    }
    onSubmit() {
        this.router.navigate(['/dashboards']);
    }
    forgotpwd() {
        this.router.navigate(['/forgot']);
    }
    get f() { return this.loginForm.controls; }
    ;
    get username() { return this.loginForm.get('username'); }
    get password() { return this.loginForm.get('password'); }
    /**
     * To authenticate the user
     */
    onLogin() {
        this.submitted = true;
        if (this.loginForm.invalid) {
            return;
        }
        sessionStorage.clear();
        this.isLoading = true;
        this.data.saveService(this.loginForm.value).subscribe(data => {
            this.isLoading = false;
            if (data.authkey) {
                sessionStorage.clear();
                let newData = data;
                sessionStorage.setItem('isLoggedIn', JSON.stringify(newData));
                sessionStorage.setItem('authkey', newData.authkey);
                sessionStorage.setItem('type', newData.type);
                sessionStorage.setItem('iduser', newData.iduser);
                sessionStorage.setItem('username', newData.username);
                sessionStorage.setItem('idaccount', newData.idaccount);
                sessionStorage.setItem('client_time', newData.client_time);
                if (newData.isPlan != "true" || newData.isAddress != "true" || newData.isEmailVerify != "true" || newData.isMobileVerify != "true") {
                    this.router.navigate(['/user/verify-profile']);
                }
                else if (newData.resetPassword == 0) {
                    this.router.navigate(['/reset-password']);
                }
                else if (newData.newUser_status == 1 && newData.isCard != "true") {
                    this.router.navigate(['/user/credit-card-authorization']);
                }
                else if (newData.newUser_status == 1 && newData.type == 2 && (newData.kyc_verify_status == 0 || newData.kyc_verify_status == 2 || newData.kyc_verify_status == 3)) {
                    this.router.navigate(['/user/account-action']);
                }
                else if (newData.newUser_status == 1 && newData.type == 2 && newData.kyc_verify_status == 1) {
                    this.router.navigate(['/dashboards']);
                }
                else {
                    this.router.navigate(['/dashboards']);
                }
            }
            else {
                if (data.error && (data.error == "DelInProcess" || data.error == "Deleted")) {
                    this.router.navigate(['/restore-account']);
                }
                else {
                    this.error = data.message;
                    $('.alert').show();
                    setTimeout(() => {
                        $('.alert').hide();
                    }, 5000);
                    this.isLoading = false;
                }
            }
        }, error => {
            this.error = error.message;
            $('.alert').show();
            setTimeout(function () {
                $('.alert').hide();
            }, 5000);
            this.isLoading = false;
        });
    }
};
LoginComponent = __decorate([
    Component({
        selector: 'app-login',
        templateUrl: './login.component.html',
        styleUrls: ['./login.component.css']
    })
], LoginComponent);
export { LoginComponent };
//# sourceMappingURL=login.component.js.map