import { __decorate } from "tslib";
import { Component, Input } from '@angular/core';
import { Validators } from '@angular/forms';
let ResetPasswordComponent = class ResetPasswordComponent {
    constructor(fb, data, router, route) {
        this.fb = fb;
        this.data = data;
        this.router = router;
        this.route = route;
        this.eyetoggle = false;
        this.eyetoggle1 = false;
        this.eyetoggle2 = false;
        this.showErr = "";
        this.oldPass = "";
        this.key = -1;
        this.responseMessage = "";
        this.errMessage = "";
        this.disabled = false;
    }
    ngOnInit() {
        this.resetpasswordForm = this.fb.group({
            old_password: ['', [Validators.required]],
            new_password: ['', [Validators.required, Validators.minLength(8)]],
            confirm_password: ['', [Validators.required, Validators.minLength(8)]]
        });
    }
    reset_password() {
        this.submitted3 = true;
        this.disabled = true;
        if (this.resetpasswordForm.invalid) {
            this.disabled = false;
            return false;
        }
        else {
            if (this.resetpasswordForm.get('new_password').value == this.resetpasswordForm.get('old_password').value) {
                alert("New password should be different from old password");
                this.disabled = false;
            }
            else {
                if (this.resetpasswordForm.get('new_password').value == this.resetpasswordForm.get('confirm_password').value) {
                    this.data.resetPass(JSON.stringify(this.resetpasswordForm.value)).subscribe(rs => {
                        if (rs.status == 201) {
                            this.responseMessage = rs.message;
                            setTimeout(() => {
                                this.router.navigate(['/login']);
                                this.responseMessage = "";
                            }, 5000);
                        }
                        else {
                            this.disabled = false;
                            this.errMessage = rs.message;
                            this.showErr = rs.message;
                            setTimeout(() => {
                                this.errMessage = "";
                            }, 5000);
                        }
                    }, err => {
                        this.disabled = false;
                        this.errMessage = err.message;
                        setTimeout(() => {
                            this.errMessage = "";
                        }, 5000);
                    });
                }
                else {
                    this.disabled = false;
                    alert("Your entered confirm password does not match");
                }
            }
        }
    }
    clear() {
        this.submitted3 = false;
        this.resetpasswordForm.reset(true);
        this.showErr = "";
    }
    eyeToggle(check) {
        if (check == 1)
            if (this.eyetoggle)
                this.eyetoggle = false;
            else
                this.eyetoggle = true;
        else if (check == 2)
            if (this.eyetoggle1)
                this.eyetoggle1 = false;
            else
                this.eyetoggle1 = true;
        else if (this.eyetoggle2)
            this.eyetoggle2 = false;
        else
            this.eyetoggle2 = true;
    }
};
__decorate([
    Input()
], ResetPasswordComponent.prototype, "currentUser", void 0);
ResetPasswordComponent = __decorate([
    Component({
        selector: 'app-reset-password',
        templateUrl: './reset-password.component.html',
        styleUrls: ['./reset-password.component.css']
    })
], ResetPasswordComponent);
export { ResetPasswordComponent };
//# sourceMappingURL=reset-password.component.js.map