import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from '../shared/service/AppService.class';
import { LoaderEnabled } from '../shared/loader/loader.service';
import { environment } from 'src/environments/environment';
let BillingService = class BillingService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
    }
    getinvoice() {
        return this.http.get('./assets/invoice.json');
    }
    getinvoicetax() {
        return this.http.get('/assets/invoice.json');
    }
    getaccount() {
        return this.http.get('./assets/account.json');
    }
    getorder() {
        return this.http.get('./assets/orderhistory.json');
    }
    getratedeck() {
        return this.http.get('./assets/ratedecks.json');
    }
    getbillingaddress() {
        return this.http.get('./assets/billingaddress.json');
    }
    get_stripecards() {
        return this.http.get('./assets/stripecards.json');
    }
    getInv() {
        this.appmod = "getInvoice";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    stripe_data(id) {
        this.appmod = "get_card_data";
        let result = super.getService(id);
        this.appmod = "";
        return result;
    }
    stripe_api_data(id) {
        this.appmod = "get_stripe_data";
        let result = super.getService(id);
        this.appmod = "";
        return result;
    }
    getUsers(type) {
        this.appmod = "user";
        let tmp = this.getService(type);
        this.appmod = "usermanagement";
        return tmp;
    }
    delete_card(payLoad) {
        this.appmod = "card_delete";
        let result = super.saveService(payLoad);
        this.appmod = "";
        return result;
    }
    stripeCards() {
        const apiURL = environment.SERVER + 'stripe-cards';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders });
    }
    monthlyInvoice(filter) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "monthly-invoice";
        return this.http.get(apiUrl, { headers: httpHeaders, params: filter });
    }
    invoiceBilling(idinvoice) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "invoice";
        return this.http.get(apiUrl, { headers: httpHeaders, params: { idinvoice: idinvoice } });
    }
    CsvInvoice(data) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "csvinvoice";
        return this.http.get(apiUrl, { headers: httpHeaders, params: data });
    }
    getInvoiceTax(data) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "get_invoice_tax";
        return this.http.get(apiUrl, { headers: httpHeaders, params: data });
    }
    // @LoaderEnabled()
    // paymentHistory(): Observable<any> {
    //   this.appmod = "paymenthistory";
    //   let result = super.getService();
    //   this.appmod = "";
    //   return result;
    // }
    paymentHistory(filter) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "paymenthistory";
        return this.http.get(apiUrl, { headers: httpHeaders, params: filter });
    }
    addBillingAddress(data) {
        let tmp = this.appmod;
        this.appmod = 'add_billing_address';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    getGeoCodeAdd(data) {
        let tmp = this.appmod;
        this.appmod = 'get_geo_code';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    getBillingAddress() {
        let tmp = this.appmod;
        this.appmod = "get_billing_address";
        let result = super.getService();
        this.appmod = tmp;
        return result;
    }
    getInvoiceAddress(idinvoice) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "invoice-address";
        return this.http.get(apiUrl, { headers: httpHeaders, params: { idinvoice: idinvoice } });
    }
    updateBillingAddress(data) {
        let tmp = this.appmod;
        this.appmod = "update_billing_address";
        let result = super.updateService(data);
        this.appmod = tmp;
        return result;
    }
    getBalance() {
        let tmp = this.appmod;
        this.appmod = "getbalance";
        let result = super.getService();
        this.appmod = tmp;
        return result;
    }
    // getBalance(): any {
    //   let apiURL = environment.SERVER+ "getbalance";
    //   let httpHeaders = new HttpHeaders({
    //     "Content-Type": "application/json"
    //   });
    //     this.http.get(apiURL, { headers: httpHeaders }).subscribe((res: any) => {
    //     this.balance.next(res.data[0].balance);
    //   });
    //   return this.balance;
    // }
    addBalance(bill) {
        this.appmod = "addbalance";
        let data = super.saveService(bill);
        this.appmod = "";
        return data;
    }
    updateBalance(bill) {
        this.appmod = "updatebalance";
        let data = super.updateService(bill);
        this.appmod = "";
        this.getBalance();
        return data;
    }
    generateInvoice(data) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "generate-invoice";
        return this.http.post(apiUrl, data, { headers: httpHeaders });
    }
    getProfile(type) {
        this.appmod = "user";
        let tmp = this.getService(type);
        this.appmod = "";
        this.getBalance();
        return tmp;
    }
};
__decorate([
    LoaderEnabled()
], BillingService.prototype, "getInv", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "stripe_data", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "stripe_api_data", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "getUsers", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "delete_card", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "stripeCards", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "monthlyInvoice", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "invoiceBilling", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "CsvInvoice", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "getInvoiceTax", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "paymentHistory", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "addBillingAddress", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "getGeoCodeAdd", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "getBillingAddress", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "getInvoiceAddress", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "updateBillingAddress", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "getBalance", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "addBalance", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "updateBalance", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "generateInvoice", null);
__decorate([
    LoaderEnabled()
], BillingService.prototype, "getProfile", null);
BillingService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], BillingService);
export { BillingService };
//# sourceMappingURL=billing.service.js.map