import { __decorate } from "tslib";
import { Component, ViewChild } from '@angular/core';
let StripeCardComponent = class StripeCardComponent {
    constructor(router, http, data, route) {
        this.router = router;
        this.http = http;
        this.data = data;
        this.route = route;
        this.errMessage = '';
        this.responseMessage = '';
        this.deletecard = [];
        this.userlist = [];
        this.activecard = [];
    }
    ngOnInit() {
        this.data.get_stripecards().subscribe((result) => {
            this.userInfo = result[0].header;
            this.userInfo1 = this.userInfo[0].name;
            this.userInfo2 = this.userInfo[1].name;
            this.tabheader1 = this.userInfo[0].tableheaders;
            this.tabheader2 = this.userInfo[1].tableheaders;
        });
        this.Delete_Active_card();
    }
    Delete_Active_card() {
        this.data.stripeCards().subscribe((res) => {
            if (res.status === 200) {
                this.data.getUsers('main').subscribe((res1) => {
                    this.userlist = res1.data[0];
                    res.data.forEach((card) => {
                        const user = this.userlist.find((user) => user.idaccount === card.idaccount);
                        if (user) {
                            card.customerName = user.first_name + ' ' + user.last_name;
                        }
                    });
                    this.deletecard = res.data.filter((card) => card.isdeleted === 1);
                    this.activecard = res.data.filter((card) => card.isdeleted === 0);
                    //this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = '';
                    }, 5000);
                    $('#basic-datatables5').dataTable().fnClearTable();
                    $('#basic-datatables5').dataTable().fnDraw();
                    $('#basic-datatables5').dataTable().fnDestroy();
                    $('#basic-datatables4').dataTable().fnClearTable();
                    $('#basic-datatables4').dataTable().fnDraw();
                    $('#basic-datatables4').dataTable().fnDestroy();
                    $.getScript('./assets/tollfree.js');
                });
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            }
        }, (err) => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = '';
            }, 5000);
        });
    }
    delete_card(id, account) {
        const payLoad = {
            id: id,
            idaccount: account,
        };
        if (confirm("Are you sure you want delete the Card!")) {
            this.data.delete_card(payLoad).subscribe((res) => {
                if (res.status == 201) {
                    this.responseMessage = res.message;
                    this.Delete_Active_card();
                    setTimeout(() => {
                        this.responseMessage = '';
                    }, 5000);
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = '';
                    }, 5000);
                }
            });
        }
    }
    // to view the pdf 
    viewFile(data) {
        const pdfModal = document.getElementById('modalPdfAppeal');
        const modalPdf = document.getElementById('modalPdf');
        modalPdf.src = data.card_pdf;
        // Open the modal
        $(pdfModal).modal('show');
    }
    formatMonth(month) {
        return month < 10 ? '0' + month : month.toString();
    }
    ngOnDestroy() {
        this.modalPdfAppeal.nativeElement.click();
    }
};
__decorate([
    ViewChild('modalPdfAppeal')
], StripeCardComponent.prototype, "modalPdfAppeal", void 0);
StripeCardComponent = __decorate([
    Component({
        selector: 'app-stripe-card',
        templateUrl: './stripe-card.component.html',
        styleUrls: ['./stripe-card.component.css'],
    })
], StripeCardComponent);
export { StripeCardComponent };
//# sourceMappingURL=stripe-card.component.js.map