import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
let AddcampaignComponent = class AddcampaignComponent {
    constructor(campaignService, fb, route, router) {
        this.campaignService = campaignService;
        this.fb = fb;
        this.route = route;
        this.router = router;
        this.responseMessage = "";
        this.brandVertical = [];
        this.isDisabled = false;
        this.errMessage = "";
    }
    ngOnInit() {
        this.campaignForm = this.fb.group({
            campaign_key: ['', Validators.required],
            campaignName: ['', Validators.required],
            // vertical: ['', Validators.required],
            // description: ['', Validators.required],
            // sample1: ['', Validators.required],
            // sample2: ['', Validators.required],
            // sample3: [],
            // sample4: [],
            // sample5: [],
            // usecase: [],
            // subUsecases: [],
            brandId: [],
            // subscriberOptin: [true],
            // subscriberOptout: [true],
            // subscriberHelp: [true],
        });
        this.campaignService.brandVertical().subscribe(res => {
            let tmp = [];
            Object.entries(res.data).forEach((ele) => {
                let t = ele[1];
                t["name"] = ele[0];
                tmp.push(t);
            });
            this.brandVertical = tmp;
        });
        this.route.paramMap.subscribe((params) => {
            this.brandId = params.get('id');
            this.campaignService.getSinglebrand(this.brandId).subscribe(result => {
                this.brand = result.data[0];
                this.brandName = this.brand.brand_name;
                this.campaignForm.patchValue({
                    brandId: this.brandId
                });
            });
        });
    }
    addCampaign() {
        if (this.campaignForm.invalid) {
            return false;
        }
        else {
            this.campaignService.onAddCampaign(this.campaignForm.value).subscribe(response => {
                if (response.status == 201) {
                    this.responseMessage = response.message;
                    this.router.navigateByUrl('/campaign/brand-details');
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                }
                else {
                    this.errMessage = response.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            });
        }
    }
};
AddcampaignComponent = __decorate([
    Component({
        selector: 'app-addcampaign',
        templateUrl: './addcampaign.component.html',
        styleUrls: ['./addcampaign.component.css'],
    })
], AddcampaignComponent);
export { AddcampaignComponent };
//# sourceMappingURL=addcampaign.component.js.map