import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let CampaignComponent = class CampaignComponent extends AppComponentClass {
    constructor(data, router, fb, route) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.route = route;
        this.brandId = null;
        /* p: number = 1;
        page = 1;
        count = 0;
        tableSize = 25;
        tableSizes = [ 25, 50, 100];
        filterTerm: string;
        filterTerm1: string; */
        this.responseMessage = "";
        this.isCampaign = false;
        this.errMessage = "";
        this.campDid = [];
    }
    ngOnInit() {
        this.data.getcampaign().subscribe((result) => {
            this.collection = result[1];
            $.getScript('./assets/table.js');
            this.heading = result[0].headers;
            this.main_heading = result[0].users;
        });
        this.route.paramMap.subscribe((params) => {
            this.brandId = params.get('id');
            if (this.brandId) {
                this.data.onGetCampaigns(this.brandId).subscribe(result => {
                    if (result.status == 200) {
                        if (result.data.length > 0) {
                            this.campaigns = result.data;
                            $.getScript('./assets/table.js');
                            this.isCampaign = true;
                        }
                    }
                    else {
                        this.errMessage = result.message;
                        setTimeout(() => {
                            this.errMessage = "";
                        }, 5000);
                    }
                });
            }
            else {
                this.data.GetCampaignsList().subscribe(result => {
                    if (result.status == 200) {
                        var userID = this.data.iduser;
                        if (result.data.length > 0) {
                            this.campaigns = result.data;
                            $.getScript('./assets/table.js');
                            this.isCampaign = true;
                        }
                    }
                    else {
                        this.errMessage = result.message;
                        setTimeout(() => {
                            this.errMessage = "";
                        }, 5000);
                    }
                });
            }
        });
    }
    /**
     * It will delete a campaign
     */
    getCampRegDID(camp, userid) {
        this.campaign_key = camp;
        this.campDid = [];
        this.data.getCampaignDID(camp, userid).subscribe((res) => {
            if (res.status == 200) {
                this.campDid = res.data;
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    onDeleteCampaign(campaign_key) {
        if (confirm("Are You Sure, You want delete this campaign?")) {
            this.data.onDeleteCampaign(campaign_key).subscribe(res => {
                if (res.status == 201) {
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                    window.location.reload();
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.errMessage = err.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            });
        }
        else {
            return false;
        }
    }
};
CampaignComponent = __decorate([
    Component({
        selector: 'app-campaign',
        templateUrl: './campaign.component.html',
        styleUrls: ['./campaign.component.css']
    })
], CampaignComponent);
export { CampaignComponent };
//# sourceMappingURL=campaign.component.js.map