import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from 'src/app/shared/service/AppService.class';
import { LoaderEnabled } from '../shared/loader/loader.service';
import { environment } from 'src/environments/environment';
let CapmaignserviceService = class CapmaignserviceService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
    }
    brandDCA() {
        this.appmod = "brandDCA";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    brandRelationship() {
        this.appmod = "brandRelationship";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    brandVettingClass() {
        this.appmod = "vettingClass";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    brandVettingProvider() {
        this.appmod = "extVettingProvider";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    brandEntityType() {
        this.appmod = "brandEntity";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    brandVertical() {
        this.appmod = "brandVertical";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    altBusinessIdType() {
        this.appmod = "altBusinessIdType";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getSinglebrand(brandId) {
        this.appmod = "brand";
        let result = super.getService(brandId);
        this.appmod = "";
        return result;
    }
    getBrand() {
        this.appmod = 'getbrands';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getBrandVetting(payLoad) {
        this.appmod = 'getBrandsVettingList';
        let result = super.getService(payLoad);
        this.appmod = "";
        return result;
    }
    getVettingClass(payLoad) {
        this.appmod = 'getVettingClass';
        let result = super.getService(payLoad);
        this.appmod = "";
        return result;
    }
    getVettingPartner(payLoad) {
        this.appmod = 'getVettingPartner';
        let result = super.getService(payLoad);
        this.appmod = "";
        return result;
    }
    //@LoaderEnabled()
    updateVetting(data) {
        this.appmod = "updateVettingForStatus";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    onAddBrand(data) {
        let apiURL = environment.SERVER + "addbrand";
        return this.http.post(apiURL, data, { headers: this.httpHeaders });
        // this.appmod = 'brandcreate';
        // let result = super.saveService(data);
        // this.appmod = "";
        // return result;
    }
    onBrandRegistefffr(data) {
        let apiURL = environment.SERVER + "registerbrand";
        return this.http.post(apiURL, data, { headers: this.httpHeaders });
        // this.appmod = 'brandcreate';
        // let result = super.saveService(data);
        // this.appmod = "";
        // return result;
    }
    onBrandRegister(data) {
        let apiUrl = environment.SERVER + 'registerbrand';
        let httpheaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiUrl, data, { headers: httpheaders });
    }
    onAddCspId(data) {
        let apiUrl = environment.SERVER + 'updateCSPID';
        let httpheaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.put(apiUrl, data, { headers: httpheaders });
    }
    onGetCampaign() {
        this.appmod = 'campaignsList';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    onGetCampaigns(brandId) {
        this.appmod = 'brandCampaign';
        let result = super.getService(brandId);
        this.appmod = "";
        return result;
    }
    GetCNPCampaignsList() {
        this.appmod = 'cnpCampaign';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    GetCampaignsList() {
        this.appmod = 'campaignsList';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    GetCampaignsListForAdmin(type) {
        this.appmod = 'campaignData';
        let result = super.getService(type);
        this.appmod = "";
        return result;
    }
    onAddCampaign(data) {
        let apiURL = environment.SERVER + "addcampaign";
        return this.http.post(apiURL, data, { headers: this.httpHeaders });
        // this.appmod = 'addcampaign';
        // let result = super.saveService(data);
        // this.appmod = "";
        // return result;
    }
    applyNewVetting(data) {
        let apiURL = environment.SERVER + "applyVetting";
        return this.http.post(apiURL, data, { headers: this.httpHeaders });
        // this.appmod = 'addcampaign';
        // let result = super.saveService(data);
        // this.appmod = "";
        // return result;
    }
    importVetting(data) {
        let apiUrl = environment.SERVER + 'importVetting';
        let httpheaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.put(apiUrl, data, { headers: httpheaders });
    }
    onRegisterCampaign(data) {
        let apiURL = environment.SERVER + "registercampaign";
        return this.http.post(apiURL, data, { headers: this.httpHeaders });
        // this.appmod = 'addcampaign';
        // let result = super.saveService(data);
        // this.appmod = "";
        // return result;
    }
    onDeleteCampaign(data) {
        this.appmod = 'deletecampaign';
        let result = super.deleteService(data);
        this.appmod = "";
        return result;
    }
    DeleteBrand(data) {
        this.appmod = 'deleteBrand';
        let result = super.deleteService(data);
        this.appmod = "";
        return result;
    }
    getCampaignCases() {
        this.appmod = "campcases";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getCampaignDIDCount(campaign_key, userID) {
        this.appmod = "getCampaignDIDCount";
        let result = super.getService(campaign_key, userID);
        this.appmod = "";
        return result;
    }
    getCampaignDID(campaign_key, userID) {
        this.appmod = "getCampaignDID";
        let result = super.getService(campaign_key, userID);
        this.appmod = "";
        return result;
    }
    getCspId() {
        let apiUrl = environment.SERVER + 'getCSP';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders });
    }
    getBrands() {
        return this.http.get('./assets/brand.json');
    }
    getcampaign() {
        return this.http.get('./assets/campaign.json');
    }
};
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "brandDCA", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "brandRelationship", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "brandVettingClass", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "brandVettingProvider", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "brandEntityType", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "brandVertical", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "altBusinessIdType", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "getSinglebrand", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "getBrand", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "getBrandVetting", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "getVettingClass", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "getVettingPartner", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "onAddBrand", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "onBrandRegistefffr", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "onBrandRegister", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "onAddCspId", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "onGetCampaign", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "onGetCampaigns", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "GetCNPCampaignsList", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "GetCampaignsList", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "GetCampaignsListForAdmin", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "onAddCampaign", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "applyNewVetting", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "importVetting", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "onRegisterCampaign", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "onDeleteCampaign", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "DeleteBrand", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "getCampaignCases", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "getCampaignDIDCount", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "getCampaignDID", null);
__decorate([
    LoaderEnabled()
], CapmaignserviceService.prototype, "getCspId", null);
CapmaignserviceService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], CapmaignserviceService);
export { CapmaignserviceService };
//# sourceMappingURL=capmaignservice.service.js.map