import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let BrandComponent = class BrandComponent extends AppComponentClass {
    constructor(data, router, fb, route) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.route = route;
        this.submitted = false;
    }
    ngOnInit() {
        this.CompanydetailsForm = this.fb.group({
            brndname: ['', [Validators.required]],
            vertical_type: ['', [Validators.required]],
            legal_organization: ['', [Validators.required]],
            country_registration: ['', [Validators.required]],
            ein: ['', [Validators.required]],
            ein_issuing_country: ['', [Validators.required]],
            duns_giin_number: ['', [Validators.required]],
            duns_number: ['', [Validators.required]],
            address_street: ['', [Validators.required]],
            city: ['', [Validators.required]],
            state: ['', [Validators.required]],
            stock_symbol: ['', [Validators.required]],
            stock_exchange: ['', [Validators.required]],
            website: ['', [Validators.required]],
            reference_id: ['', [Validators.required]]
        });
        this.ContactdetailsForm = this.fb.group({
            supportMail: ['', [Validators.required]],
            phone_number: ['', [Validators.required]],
        });
    }
    onSubmit() {
        console.log(this.CompanydetailsForm.value);
    }
    onSave() {
        console.log(this.ContactdetailsForm.value);
    }
};
BrandComponent = __decorate([
    Component({
        selector: 'app-brand',
        templateUrl: './brand.component.html',
        styleUrls: ['./brand.component.css']
    })
], BrandComponent);
export { BrandComponent };
//# sourceMappingURL=brand.component.js.map