import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from 'src/app/shared/service/AppService.class';
import { environment } from 'src/environments/environment';
import { LoaderEnabled } from '../shared/loader/loader.service';
let CampaignsService = class CampaignsService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
    }
    brandDCA() {
        this.appmod = "brandDCA";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    brandRelationship() {
        this.appmod = "brandRelationship";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    brandVettingClass() {
        this.appmod = "vettingClass";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    brandEntityType() {
        this.appmod = "brandEntity";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    brandVertical() {
        this.appmod = "brandVertical";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    altBusinessIdType() {
        this.appmod = "altBusinessIdType";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getSinglebrand(brandId) {
        this.appmod = "brand";
        let result = super.getService(brandId);
        this.appmod = "";
        return result;
    }
    getBrand() {
        this.appmod = 'getbrands';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    onAddBrand(data) {
        let apiURL = environment.SERVER + "addbrand";
        return this.http.post(apiURL, data, { headers: this.httpHeaders });
    }
    onBrandRegister(data) {
        let apiURL = environment.SERVER + "registerbrand";
        return this.http.post(apiURL, data, { headers: this.httpHeaders });
    }
    onGetCampaign() {
        this.appmod = 'campaignsList';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    onGetCampaigns(brandId) {
        this.appmod = 'brandCampaign';
        let result = super.getService(brandId);
        this.appmod = "";
        return result;
    }
    onAddCampaign(data) {
        let apiURL = environment.SERVER + "addcampaign";
        return this.http.post(apiURL, data, { headers: this.httpHeaders });
    }
    onRegisterCampaign(data) {
        let apiURL = environment.SERVER + "registercampaign";
        return this.http.post(apiURL, data, { headers: this.httpHeaders });
    }
    onDeleteCampaign(data) {
        this.appmod = 'deletecampaign';
        let result = super.deleteService(data);
        this.appmod = "";
        return result;
    }
    getCampaignCases() {
        this.appmod = "campcases";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getBrands() {
        return this.http.get('./assets/brand.json');
    }
    get_mycampaign() {
        return this.http.get('./assets/mycampaign.json');
    }
    get_brands() {
        return this.http.get('./assets/brands.json');
    }
};
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "brandDCA", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "brandRelationship", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "brandVettingClass", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "brandEntityType", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "brandVertical", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "altBusinessIdType", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "getSinglebrand", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "getBrand", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "onAddBrand", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "onBrandRegister", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "onGetCampaign", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "onGetCampaigns", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "onAddCampaign", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "onRegisterCampaign", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "onDeleteCampaign", null);
__decorate([
    LoaderEnabled()
], CampaignsService.prototype, "getCampaignCases", null);
CampaignsService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], CampaignsService);
export { CampaignsService };
//# sourceMappingURL=campaigns.service.js.map