import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from '../shared/service/AppService.class';
import { LoaderEnabled } from '../shared/loader/loader.service';
import { environment } from 'src/environments/environment';
let ConnectionsService = class ConnectionsService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.appmod = "usermanagement";
    }
    deleteIP(id) {
        this.appmod = "deleteip";
        let result = super.deleteService(id);
        this.appmod = "";
        return result;
    }
    getConnection() {
        this.appmod = 'getconnection';
        let result = super.getService();
        this.appmod = "usermanagement";
        return result;
    }
    getRoutingConnection() {
        this.appmod = 'get_routing';
        let result = super.getService();
        this.appmod = "usermanagement";
        return result;
    }
    getUrl(data) {
        this.appmod = 'get_url';
        let result = super.getService(data);
        this.appmod = "usermanagement";
        return result;
    }
    getUrls(data) {
        this.appmod = 'get_urls';
        let result = super.getService(data);
        this.appmod = "usermanagement";
        return result;
    }
    setUrl(data) {
        this.appmod = 'set_url';
        let result = super.saveService(data);
        this.appmod = "usermanagement";
        return result;
    }
    updatePassword(data) {
        this.appmod = 'set_pass';
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    get_expertSetting(data) {
        this.appmod = 'get_setting';
        let result = super.getService(data);
        this.appmod = "usermanagement";
        return result;
    }
    saveConnection(data) {
        this.appmod = 'saveconnectionIP';
        let result = super.saveService(data);
        this.appmod = "usermanagement";
        return result;
    }
    updateConnectionName(data) {
        this.appmod = 'updateconnectionname';
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    updateStatus(data, id) {
        console.log("service", id);
        this.appmod = 'updatestatus';
        let result = super.updateService(data, id);
        this.appmod = "usermanagement";
        return result;
    }
    updateConnTechPre(data) {
        this.appmod = 'updateconntechpre';
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    updateConnUserPass(data) {
        this.appmod = 'updateconnuserpass';
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    updateConnInboundCall(data) {
        this.appmod = 'updateconninboundcall';
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    updateConnection(data) {
        this.appmod = 'updateconnection';
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    saveIp(data) {
        this.appmod = 'saveip';
        let result = super.saveService(data);
        this.appmod = "usermanagement";
        return result;
    }
    getIP(data) {
        this.appmod = "getIP";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    updateIP(data) {
        this.appmod = 'updateip';
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    saveUrls(data) {
        this.appmod = 'saveurls';
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    updateUrls(data) {
        this.appmod = 'update_urls';
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    updatefqdn(data) {
        this.appmod = 'update_fqdn';
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    update_expertSetting(data) {
        this.appmod = 'update_expertsetting';
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    save_forword(data) {
        this.appmod = "save_forword";
        let result = super.saveService(data);
        this.appmod = "usermanagement";
        return result;
    }
    save_smsinbound(data) {
        this.appmod = "save_smsinbound";
        let result = super.saveService(data);
        this.appmod = "usermanagement";
        return result;
    }
    save_smsoutbound(data) {
        this.appmod = "save_smsoutbound";
        let result = super.saveService(data);
        this.appmod = "usermanagement";
        return result;
    }
    getInbound(data) {
        this.appmod = 'get_inbound';
        let result = super.getService(data);
        this.appmod = "usermanagement";
        return result;
    }
    getOutbound(data) {
        this.appmod = 'get_outbound';
        let result = super.getService(data);
        this.appmod = "usermanagement";
        return result;
    }
    updateInbound(data) {
        this.appmod = 'update_inbound';
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    updateOutbound(data) {
        this.appmod = 'update_outbound';
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    delete_connection(key) {
        this.appmod = 'deleteconnection';
        let result = super.deleteService(key);
        this.appmod = "usermanagement";
        return result;
    }
    setDefault(data) {
        let apiUrl = environment.SERVER + "default-connection";
        let httpHeaders = new HttpHeaders({
        // "Content-Type": "application/json",
        });
        return this.http.put(apiUrl, { data: data }, { headers: httpHeaders });
    }
    getconnectiondetails() {
        return this.http.get('./assets/connections.json');
    }
    connectionhelp() {
        return this.http.get('./assets/connectionhelp.json');
    }
};
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "deleteIP", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "getConnection", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "getRoutingConnection", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "getUrl", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "getUrls", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "setUrl", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "get_expertSetting", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "saveConnection", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "updateConnectionName", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "updateStatus", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "updateConnTechPre", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "updateConnUserPass", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "updateConnInboundCall", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "updateConnection", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "saveIp", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "getIP", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "updateIP", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "saveUrls", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "updateUrls", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "updatefqdn", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "update_expertSetting", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "save_forword", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "save_smsinbound", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "save_smsoutbound", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "getInbound", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "getOutbound", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "updateInbound", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "updateOutbound", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "delete_connection", null);
__decorate([
    LoaderEnabled()
], ConnectionsService.prototype, "setDefault", null);
ConnectionsService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], ConnectionsService);
export { ConnectionsService };
//# sourceMappingURL=connections.service.js.map