import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from '../shared/service/AppService.class';
import { LoaderEnabled } from '../shared/loader/loader.service';
import { environment } from 'src/environments/environment';
let FederalService = class FederalService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.appmod = "usermanagement";
    }
    getFedrlQuestion() {
        this.appmod = 'getfedQuestion';
        let result = super.getService();
        this.appmod = "usermanagement";
        return result;
    }
    saveFederal(data) {
        this.appmod = 'save_federal';
        let result = super.saveService(data);
        this.appmod = "usermanagement";
        return result;
    }
    // @LoaderEnabled()
    // getFederalPdf(): Observable<any> {
    //   this.appmod = 'get_FederalPdf';
    //   let result = super.getService();
    //   this.appmod = "usermanagement";
    //   return result;
    // }
    getFederalPdf(type) {
        const apiURL = environment.SERVER + 'get_FederalPdf';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: type });
    }
    /*KYC verification update function*/
    federalVerify(data) {
        this.appmod = "verifyfederalStatus";
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    rejectFederalStatus(data) {
        this.appmod = "rejectfederalStatus";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    cancelFederalStatus(data) {
        this.appmod = "cancelFederalStatus";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
};
__decorate([
    LoaderEnabled()
], FederalService.prototype, "getFedrlQuestion", null);
__decorate([
    LoaderEnabled()
], FederalService.prototype, "saveFederal", null);
__decorate([
    LoaderEnabled()
], FederalService.prototype, "getFederalPdf", null);
__decorate([
    LoaderEnabled()
], FederalService.prototype, "federalVerify", null);
__decorate([
    LoaderEnabled()
], FederalService.prototype, "rejectFederalStatus", null);
__decorate([
    LoaderEnabled()
], FederalService.prototype, "cancelFederalStatus", null);
FederalService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], FederalService);
export { FederalService };
//# sourceMappingURL=federal.service.js.map