import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from '../shared/service/AppService.class';
import { environment } from 'src/environments/environment';
import { LoaderEnabled } from '../shared/loader/loader.service';
let InboundService = class InboundService extends AppService {
    constructor(http, store) {
        super(http);
        this.http = http;
        this.store = store;
    }
    onDidLocationInfo() {
        let tmp = this.appmod;
        this.appmod = 'didlocationinfo';
        let result = super.getService();
        this.appmod = tmp;
        return result;
    }
    // @LoaderEnabled()
    // onGetBuyffDids(filter?: any): Observable<any> {
    //   let tmp = this.appmod;
    //   this.appmod = 'dids';
    //   let result = super.getService();
    //   this.appmod = tmp;
    //   return result;
    // }
    onGetBuyDids(filter) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "dids";
        return this.http.get(apiUrl, { headers: httpHeaders, params: filter });
    }
    onGetMultiSearch(data) {
        let bodyFormData = new FormData();
        bodyFormData.append('data', JSON.stringify(data));
        bodyFormData.append('profile_pic', data.file);
        const apiURL = environment.SERVER + 'getMultiSearch';
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, bodyFormData, { headers: httpHeaders });
    }
    onGetBuySMSDids(filter) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "smsdids";
        return this.http.get(apiUrl, { headers: httpHeaders, params: filter });
    }
    exportDID(data) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "exportdid";
        return this.http.post(apiUrl, { data: data }, { headers: httpHeaders });
    }
    exportorderDID(data) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "exportorderdid";
        return this.http.post(apiUrl, { data: data }, { headers: httpHeaders });
    }
    onDisconnectDid(did, iduser) {
        const apiURL = environment.SERVER + 'disconnect';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiURL, { DID: did, iduser: iduser }, { headers: httpHeaders });
    }
    saveData(data) {
        let tmp = this.appmod;
        this.appmod = 'custom/saveheadermapping';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    enableDisable(data) {
        let tmp = this.appmod;
        this.appmod = 'didienable';
        let result = super.updateService(data);
        this.appmod = tmp;
        return result;
    }
    onEnable_service(data) {
        this.appmod = "EnableTFsms";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    onDisable_service(data) {
        this.appmod = "disableTFsms";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    callDetailRecord(data) {
        let tmp = this.appmod;
        this.appmod = 'details_cdr';
        let result = super.getService(data);
        this.appmod = tmp;
        return result;
    }
    updateDID(data) {
        let tmp = this.appmod;
        this.appmod = "updatedid";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    onGetCampaigns(brandId) {
        this.appmod = 'brandCampaign';
        let result = super.getService(brandId);
        this.appmod = "";
        return result;
    }
    getCampaignDIDCount(campaignCount, iduser) {
        this.appmod = 'getCampaignDIDCount';
        let result = super.getService(campaignCount, iduser);
        this.appmod = "";
        return result;
    }
    getCampaignDID(campaign_key, userID) {
        this.appmod = "getCampaignDID";
        let result = super.getService(campaign_key, userID);
        this.appmod = "";
        return result;
    }
    getCampaigns(iduser) {
        this.appmod = 'getCampaign';
        let result = super.getService(iduser);
        this.appmod = "";
        return result;
    }
    getSmsProvider(iduser) {
        this.appmod = 'smsProvider';
        let result = super.getService(iduser);
        this.appmod = "";
        return result;
    }
    GetConnections(id) {
        this.appmod = 'get_connections';
        let result = super.getService(id);
        this.appmod = "";
        return result;
    }
    GetConnectionsByAccount(id) {
        this.appmod = 'get_connections_by_account';
        let result = super.getService(id);
        this.appmod = "";
        return result;
    }
    updateSelectedDids(data) {
        let tmp = this.appmod;
        this.appmod = "selected_dids";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    disconnectSelectedDids(data) {
        let tmp = this.appmod;
        this.appmod = "disconnect-dids";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    listConnections() {
        let tmp = this.appmod;
        this.appmod = 'listconnectionUI';
        let result = super.getService();
        this.appmod = tmp;
        return result;
    }
    getconnection() {
        let tmp = this.appmod;
        this.appmod = 'getconnection';
        let result = super.getService();
        this.appmod = tmp;
        return result;
    }
    singleConnections() {
        let tmp = this.appmod;
        this.appmod = 'singledefconn';
        let result = super.getService();
        this.appmod = tmp;
        return result;
    }
    onGetAllKeyByConnKey(data) {
        let tmp = this.appmod;
        this.appmod = 'get_all_Key';
        let result = super.getService(data);
        this.appmod = tmp;
        return result;
    }
    searchDIDByRate(data) {
        const apiURL = environment.SERVER + 'searchbyrate';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: data });
    }
    searchDIDByNpx(data) {
        const apiURL = environment.SERVER + 'searchbynpa';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: data });
    }
    onAddTOCart(did) {
        let tmp = this.appmod;
        this.appmod = 'addtocart';
        let result = super.saveService(did);
        this.appmod = tmp;
        return result;
    }
    enableSMS(data) {
        const apiURL = environment.SERVER + 'enablesms';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiURL, data, { headers: httpHeaders });
    }
    reProvisioningSMS(data) {
        const apiURL = environment.SERVER + 're-provisioning-sms';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiURL, data, { headers: httpHeaders });
    }
    disableSMS(id, iduser) {
        const apiURL = environment.SERVER + 'disablesms';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.delete(apiURL, { headers: httpHeaders, params: { DID: id, iduser: iduser } });
    }
    uploadDid(uploadDid, file) {
        let bodyFormData = new FormData();
        bodyFormData.append('uploadDid', JSON.stringify(uploadDid));
        bodyFormData.append('profile_pic', file);
        const apiURL = environment.SERVER + 'uploadDid';
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, bodyFormData, { headers: httpHeaders });
    }
    onAddAllToCart(did) {
        let tmp = this.appmod;
        this.appmod = 'addAllToCart';
        let result = super.saveService(did);
        this.appmod = tmp;
        return result;
    }
    onTfRequest(data) {
        let tmp = this.appmod;
        this.appmod = 'tfRequest';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    getCart() {
        this.appmod = "carts";
        let result = this.getService();
        this.appmod = "";
        return result;
    }
    onDeleteCart(id) {
        this.appmod = "deletecart";
        let result = this.deleteService(id);
        this.appmod = "";
        return result;
    }
    onClearCart() {
        this.appmod = environment.SERVER + "clearcart";
        let httpHeaders = new HttpHeaders({});
        let result = this.http.delete(this.appmod, { headers: httpHeaders });
        this.appmod = "";
        return result;
    }
    onBuyDID(did) {
        const apiURL = environment.SERVER + 'buy';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiURL, did, { headers: httpHeaders });
    }
    CreateGroupOrder(data) {
        let tmp = this.appmod;
        this.appmod = 'create_group_order';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    BuyAllDIDs(did) {
        const apiURL = environment.SERVER + 'buy_dids';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiURL, did, {
            headers: httpHeaders
        });
    }
    updateData(data) {
        let tmp = this.appmod;
        this.appmod = 'custom/saveheadermapping';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    callDetails(data) {
        let tmp = this.appmod;
        this.appmod = 'details_cdr';
        let result = super.getService(data);
        this.appmod = tmp;
        return result;
    }
    onDeleteItems(items) {
        const apiURL = environment.SERVER + 'deletecartItems';
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, items, { headers: httpHeaders });
    }
    getStates() {
        const apiURL = environment.SERVER + 'getStates';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders });
    }
    GetRateCenter(State) {
        const apiURL = environment.SERVER + 'getratecenter';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: { State: State } });
    }
    onTollFreeNumber(data) {
        const apiURL = environment.SERVER + 'searchtollfree';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: data });
    }
    GetOrdersHistory(filter) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "get_orders_history";
        return this.http.get(apiUrl, { headers: httpHeaders, params: filter });
    }
    ViewOrderHistory(filter) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "view_order_history";
        return this.http.get(apiUrl, { headers: httpHeaders, params: filter });
    }
    getDisconnectedDid() {
        let tmp = this.appmod;
        this.appmod = 'getDisconnectedDid';
        let result = super.getService();
        this.appmod = tmp;
        return result;
    }
    restoreDisconnectDid(data) {
        let tmp = this.appmod;
        this.appmod = "restoreDisconnectDid";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    // @LoaderEnabled()
    // getdidData(filter?: any): Observable<any> {
    //   let tmp = this.appmod;
    //   this.appmod = 'historyDid';
    //   let result = super.getService();
    //   this.appmod = tmp;
    //   return result;
    // }
    getdidData(filter) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "historyDid";
        return this.http.get(apiUrl, { headers: httpHeaders, params: filter });
    }
    // @LoaderEnabled()
    // getDidHistoryDetails(payload: any): Observable<any> {
    //   let tmp = this.appmod;
    //   this.appmod = 'historyDid_details';
    //   let result = super.getService(payload);
    //   this.appmod = tmp;
    //   return result;
    // }
    getCustomerHistoryDetails(payload) {
        let tmp = this.appmod;
        this.appmod = 'customerHistory_details';
        let result = super.getService(payload);
        this.appmod = tmp;
        return result;
    }
    /*  @LoaderEnabled()
     autoRenewalDetails(payload: any): Observable<any> {
       let tmp = this.appmod;
       this.appmod = 'autoRenewalDetails';
       let result = super.getService(payload);
       this.appmod = tmp;
       return result;
     } */
    getCampaignHistoryDetails(payload) {
        let tmp = this.appmod;
        this.appmod = 'campaignHistory_details';
        let result = super.getService(payload);
        this.appmod = tmp;
        return result;
    }
    getinbound() {
        return this.http.get('./assets/configure.json');
    }
    getdid() {
        return this.http.get('./assets/did.json');
    }
    get_cdr() {
        return this.http.get('./assets/inboundcdr.json');
    }
    getnumber() {
        return this.http.get('./assets/getnumber.json');
    }
    getinboundprofile() {
        return this.http.get('./assets/inboundprofile.json');
    }
    getmanagesite() {
        return this.http.get('./assets/managesites.json');
    }
    getipaddress() {
        return this.http.get('./assets/ip_address.json');
    }
    getcnamout() {
        return this.http.get('./assets/cnamout.json');
    }
    getcomplete() {
        return this.http.get('./assets/complete.json');
    }
    getuncomplete() {
        return this.http.get('./assets/uncomplete.json');
    }
    getinboundrate() {
        return this.http.get('./assets/inboundrate.json');
    }
    gettaxrate() {
        return this.http.get('./assets/taxrate.json');
    }
    getCdr() {
        return this.http.get('./assets/cdr.json');
    }
    summeryCdrForm(data) {
        this.appmod = 'SummeryCdrForm';
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
};
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onDidLocationInfo", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onGetBuyDids", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onGetMultiSearch", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onGetBuySMSDids", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "exportDID", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "exportorderDID", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onDisconnectDid", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "saveData", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "enableDisable", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onEnable_service", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onDisable_service", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "callDetailRecord", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "updateDID", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onGetCampaigns", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "getCampaignDID", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "getCampaigns", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "getSmsProvider", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "GetConnections", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "GetConnectionsByAccount", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "updateSelectedDids", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "disconnectSelectedDids", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "listConnections", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "getconnection", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "searchDIDByRate", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "searchDIDByNpx", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onAddTOCart", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "enableSMS", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "reProvisioningSMS", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "disableSMS", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "uploadDid", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onAddAllToCart", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onTfRequest", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "getCart", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onDeleteCart", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onClearCart", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onBuyDID", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "CreateGroupOrder", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "BuyAllDIDs", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "callDetails", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onDeleteItems", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "getStates", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "GetRateCenter", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "onTollFreeNumber", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "GetOrdersHistory", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "ViewOrderHistory", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "getDisconnectedDid", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "restoreDisconnectDid", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "getdidData", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "getCustomerHistoryDetails", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "getCampaignHistoryDetails", null);
__decorate([
    LoaderEnabled()
], InboundService.prototype, "summeryCdrForm", null);
InboundService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], InboundService);
export { InboundService };
//# sourceMappingURL=inbound.service.js.map