import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { FormControl, Validators } from '@angular/forms';
import { BehaviorSubject } from 'rxjs';
import * as XLSX from 'xlsx';
import { saveAs } from 'file-saver';
let OrdersHistoryComponent = class OrdersHistoryComponent extends AppComponentClass {
    constructor(data, router, fb, userService, campService) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.userService = userService;
        this.campService = campService;
        this.searchText = { count: 0 };
        this.page = 1;
        this.count = 0;
        this.tableSize = 50;
        this.tableSizes = [50, 100, 150];
        this.responseMessage = "";
        this.errMessage = "";
        this.dids = [];
        this.tab1$ = new BehaviorSubject("");
        this.tab1 = this.tab1$.asObservable();
        this.tab1Value = "";
        this.tab2$ = new BehaviorSubject("");
        this.tab2 = this.tab1$.asObservable();
        this.tab2Value = "";
        this.tab3$ = new BehaviorSubject("");
        this.tab3 = this.tab1$.asObservable();
        this.tab3Value = "";
        this.connectionKey$ = new BehaviorSubject("");
        this.connection = this.connectionKey$.asObservable();
        this.connectionValue = "";
        this.inboundKey$ = new BehaviorSubject("");
        this.inbound = this.inboundKey$.asObservable();
        this.inboundValue = "";
        this.outboundKey$ = new BehaviorSubject("");
        this.outbound = this.outboundKey$.asObservable();
        this.outboundValue = "";
        this.campaigns = [];
        this.campaign = "";
        this.did = "";
        this.selectedDid = [];
        this.isChecked = false;
        this.isSelected = false;
        this.users = [];
        this.brandId = null;
        this.isCampaign = false;
        this.submitted = false;
        this.isAdmin = false;
        this.monthNameList = [];
        /* didList: any = []; */
        this.show = false;
        this.EXCEL_TYPE = 'application/csv';
        this.EXCEL_EXTENSION = '.csv';
        this.DidProviders = [
            { name: "thinQ", value: "ThinQ" },
            { name: "inteliQ", value: "InteliQ" },
            { name: "teleapi", value: "Teleapi" },
            { name: "Peerless", value: "Peerless" },
            { name: "coreTel", value: "CoreTel" }
        ];
        this.NumberType = [
            { type: "Local Number", value: "NN" },
            { type: "Toll-Free Number", value: "TF" }
        ];
        this.CurrentUConn = [];
        this.dIFlag = false;
        this.dIFBtn = "Import DID";
        this.OrdersList = [];
    }
    ngOnInit() {
        let session$ = sessionStorage.getItem("isLoggedIn");
        let session = JSON.parse(session$);
        this.userType = session.type;
        this.OrdersList = [];
        this.data.GetOrdersHistory("").subscribe(res => {
            if (res.error == 0) {
                this.OrdersList = res.data;
                $('#basic-datatables15').DataTable().clear();
                $('#basic-datatables15').DataTable().destroy();
                $.getScript('./assets/table.js');
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.responseMessage = err.message;
            setTimeout(() => {
                this.responseMessage = "";
            }, 5000);
        });
        this.filterForm = this.fb.group({
            group_id: new FormControl("", [Validators.required]),
            selectedUser: new FormControl("", [Validators.required]),
        });
    }
    //Export CSV
    downloadCSVFile(id) {
        let session$ = sessionStorage.getItem("isLoggedIn");
        let session = JSON.parse(session$);
        let uidandacnt = session.iduser + '-' + session.idaccount;
        this.filterForm.patchValue({
            group_id: id,
            selectedUser: uidandacnt
        });
        if (this.filterForm.invalid) {
            return false;
        }
        else {
            this.data.exportorderDID(this.filterForm.value).subscribe(res => {
                if (res.status == 200) {
                    let manageDID = res.data;
                    const worksheet = XLSX.utils.json_to_sheet(manageDID);
                    const workbook = { Sheets: { 'did': worksheet }, SheetNames: ['did'] };
                    const excelBuffer = XLSX.write(workbook, { bookType: 'csv', type: 'array' });
                    this.saveAsExcelFile(excelBuffer, "orderdid_" + res.username + "_");
                }
            });
        }
    }
    saveAsExcelFile(buffer, fileName) {
        const data = new Blob([buffer], {
            type: this.EXCEL_TYPE
        });
        //let dateObj = new Date();
        let date = new Date().toLocaleDateString('en-US').replace('_', '/');
        saveAs(data, fileName + date + this.EXCEL_EXTENSION);
    }
    /**
     * To view the order
     */
    ViewOrder(id_grouporder) {
        if (id_grouporder > 0) {
            this.router.navigate(["/inbound/view-order/" + id_grouporder]);
        }
    }
};
OrdersHistoryComponent = __decorate([
    Component({
        selector: 'app-orders-history',
        templateUrl: './orders-history.component.html',
        styleUrls: ['./orders-history.component.css']
    })
], OrdersHistoryComponent);
export { OrdersHistoryComponent };
//# sourceMappingURL=orders-history.component.js.map