import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { BehaviorSubject } from 'rxjs';
let ViewOrderComponent = class ViewOrderComponent extends AppComponentClass {
    constructor(data, router, fb, userService, campService, AcRoute) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.userService = userService;
        this.campService = campService;
        this.AcRoute = AcRoute;
        this.searchText = { count: 0 };
        this.page = 1;
        this.count = 0;
        this.tableSize = 50;
        this.tableSizes = [50, 100, 150];
        this.responseMessage = "";
        this.errMessage = "";
        this.dids = [];
        this.tab1$ = new BehaviorSubject("");
        this.tab1 = this.tab1$.asObservable();
        this.tab1Value = "";
        this.tab2$ = new BehaviorSubject("");
        this.tab2 = this.tab1$.asObservable();
        this.tab2Value = "";
        this.tab3$ = new BehaviorSubject("");
        this.tab3 = this.tab1$.asObservable();
        this.tab3Value = "";
        this.connectionKey$ = new BehaviorSubject("");
        this.connection = this.connectionKey$.asObservable();
        this.connectionValue = "";
        this.inboundKey$ = new BehaviorSubject("");
        this.inbound = this.inboundKey$.asObservable();
        this.inboundValue = "";
        this.outboundKey$ = new BehaviorSubject("");
        this.outbound = this.outboundKey$.asObservable();
        this.outboundValue = "";
        this.campaigns = [];
        this.campaign = "";
        this.did = "";
        this.selectedDid = [];
        this.isChecked = false;
        this.isSelected = false;
        this.users = [];
        this.brandId = null;
        this.isCampaign = false;
        this.submitted = false;
        this.isAdmin = false;
        this.monthNameList = [];
        /* didList: any = []; */
        this.show = false;
        this.EXCEL_TYPE = 'application/csv';
        this.EXCEL_EXTENSION = '.csv';
        this.DidProviders = [
            { name: "thinQ", value: "ThinQ" },
            { name: "inteliQ", value: "InteliQ" },
            { name: "teleapi", value: "Teleapi" },
            { name: "Peerless", value: "Peerless" },
            { name: "coreTel", value: "CoreTel" }
        ];
        this.NumberType = [
            { type: "Local Number", value: "NN" },
            { type: "Toll-Free Number", value: "TF" }
        ];
        this.CurrentUConn = [];
        this.dIFlag = false;
        this.dIFBtn = "Import DID";
        this.id_grouporder = 0;
        this.OrdersList = [];
        this.vData = {};
    }
    ngOnInit() {
        let id_grouporder = this.AcRoute.snapshot.paramMap.get('id');
        if (id_grouporder) {
            this.id_grouporder = id_grouporder;
            // To load the order
            this.LoadOrder(this.id_grouporder);
        }
    }
    LoadOrder(id) {
        this.OrdersList = [];
        this.data.ViewOrderHistory({
            id_grouporder: id
        }).subscribe(res => {
            if (res.error == 0) {
                this.OrdersList = res.data;
                $.getScript('./assets/table.js');
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.responseMessage = err.message;
            setTimeout(() => {
                this.responseMessage = "";
            }, 5000);
        });
    }
    ViewOrder(data) {
        if (data) {
            this.vData = data;
        }
    }
    get UType() {
        return sessionStorage.getItem("type");
    }
};
ViewOrderComponent = __decorate([
    Component({
        selector: 'app-view-order',
        templateUrl: './view-order.component.html',
        styleUrls: ['./view-order.component.css']
    })
], ViewOrderComponent);
export { ViewOrderComponent };
//# sourceMappingURL=view-order.component.js.map