import { __decorate } from "tslib";
import { HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { LoaderEnabled } from '../shared/loader/loader.service';
import { AppService } from '../shared/service/AppService.class';
import { environment } from 'src/environments/environment';
let KycService = class KycService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
    }
    getQuestions() {
        this.appmod = 'getQuestion';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    onkycSubmit(data) {
        this.appmod = 'addkyc';
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    // @LoaderEnabled()
    // getallData(): Observable<any> {
    //   this.appmod = 'getallData';
    //   let result = super.getService();
    //   this.appmod = "";
    //   return result;
    // }
    getallData(type) {
        const apiURL = environment.SERVER + 'getallData';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: type });
    }
    /*KYC verification update function*/
    kycVerify(data) {
        this.appmod = "kycVerification";
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    rejectKycStatus(data) {
        this.appmod = "rejectKycStatus";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    checkKycRoute() {
        this.appmod = 'checkKycRoute';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    CustomerProfileInformation() {
        this.appmod = 'CustomerProfileInformation';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    cancelKycStatus(data) {
        this.appmod = "cancelKycStatus";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    getkycstatus(data) {
        const apiURL = environment.SERVER + 'getkycstatus';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: data });
    }
};
__decorate([
    LoaderEnabled()
], KycService.prototype, "getQuestions", null);
__decorate([
    LoaderEnabled()
], KycService.prototype, "onkycSubmit", null);
__decorate([
    LoaderEnabled()
], KycService.prototype, "getallData", null);
__decorate([
    LoaderEnabled()
], KycService.prototype, "kycVerify", null);
__decorate([
    LoaderEnabled()
], KycService.prototype, "rejectKycStatus", null);
__decorate([
    LoaderEnabled()
], KycService.prototype, "checkKycRoute", null);
__decorate([
    LoaderEnabled()
], KycService.prototype, "CustomerProfileInformation", null);
__decorate([
    LoaderEnabled()
], KycService.prototype, "cancelKycStatus", null);
__decorate([
    LoaderEnabled()
], KycService.prototype, "getkycstatus", null);
KycService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], KycService);
export { KycService };
//# sourceMappingURL=kyc.service.js.map