import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let CnpBrandComponent = class CnpBrandComponent extends AppComponentClass {
    constructor(data, service, dialog, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.service = service;
        this.dialog = dialog;
        this.router = router;
        this.fb = fb;
        this.inputvalue = "";
        this.show = false;
        this.buttonName = "Add Brand";
        this.submitted = false;
        this.heading = [];
        this.main_heading = "";
        this.responseMessage = "";
        this.brands = [];
        this.brand = [];
        this.campaigns = [];
        this.brandType = [];
        this.errMessage = "";
        this.cnpLIST = [];
        this.messs = '';
    }
    ngOnInit() {
        let session$ = sessionStorage.getItem("isLoggedIn");
        let session = JSON.parse(session$);
        this.userType = session.type;
        this.filterBrand = this.fb.group({
            brandId: [],
            displayName: [''],
            company_name: [''],
            website: [],
        });
        this.getBrandCnpList();
    }
    getBrandCnpList() {
        this.service.getBrandCnpList().subscribe(res => {
            if (res.status == 200) {
                this.cnpLIST = res.data;
                $('#basic-datatables').DataTable().clear();
                $('#basic-datatables').DataTable().destroy();
                $.getScript('./assets/table.js');
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    resetFilter() {
        this.messs = '';
        this.getBrandCnpList();
    }
    /**
     * It will delete a brand
     */
    showfilter() {
        if (this.show == false) {
            this.show = true;
        }
        else {
            this.show = false;
        }
    }
    applyCnpFilter() {
        if (this.filterBrand.value.brandId || this.filterBrand.value.displayName ||
            this.filterBrand.value.company_name || this.filterBrand.value.website) {
            this.service.applyCnpFilter(this.filterBrand.value).subscribe(res => {
                if (res.status == 200) {
                    this.cnpLIST = res.data;
                    this.messs = '';
                    $('#basic-datatables').DataTable().clear();
                    $('#basic-datatables').DataTable().destroy();
                    $.getScript('./assets/table.js');
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            });
        }
        else {
            this.messs = "Please Enter atleast 1 field!";
        }
    }
};
CnpBrandComponent = __decorate([
    Component({
        selector: 'app-cnp-brand',
        templateUrl: './cnp-brand.component.html',
        styleUrls: ['./cnp-brand.component.css']
    })
], CnpBrandComponent);
export { CnpBrandComponent };
//# sourceMappingURL=cnp-brand.component.js.map