import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from 'src/app/shared/service/AppService.class';
import { LoaderEnabled } from '../shared/loader/loader.service';
import { environment } from 'src/environments/environment';
let NewCamapignService = class NewCamapignService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
    }
    getBrands() {
        return this.http.get('./assets/newBrand.json');
    }
    onBrandRegister(data) {
        let apiUrl = environment.SERVER + 'registerbrand';
        let httpheaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiUrl, data, { headers: httpheaders });
    }
    brandRelationship() {
        this.appmod = "brandRelationship";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getBranAppeal(data) {
        this.appmod = "getBranAppeal";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    getBranAppealFiles(data) {
        this.appmod = "getBranAppealFiles";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    getCampaignCases() {
        this.appmod = "campaignCasesPanel";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getBrandViewFiles(data) {
        this.appmod = "getBrandAppealViewFiles";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    onGetNewCampaigns(brandId) {
        this.appmod = 'brandCampaign';
        let result = super.getService(brandId);
        this.appmod = "";
        return result;
    }
    GetCampaignsList(payLoad) {
        this.appmod = 'campaignsList';
        let result = super.getService(payLoad);
        this.appmod = "";
        return result;
    }
    GetCNPCampaignsList(payLoad) {
        this.appmod = 'cnpCampaign';
        let result = super.getService(payLoad);
        this.appmod = "";
        return result;
    }
    dcaSubmit(data) {
        this.appmod = "dcaSubmit";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    rejectFormByAdmin(data) {
        this.appmod = "rejectFormByAdmin";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    failedFormByAdmin(data) {
        this.appmod = "failedFormByAdmin";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    RequestEdit(data) {
        this.appmod = "RequestEdit";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    failedCnpFormByAdmin(data) {
        this.appmod = "failedCnpFormByAdmin";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    getCampaignDID(campaign_key, userID) {
        this.appmod = "getCampaignDID";
        let result = super.getService(campaign_key, userID);
        this.appmod = "";
        return result;
    }
    getCampaignDIDCount(campaign_key, userID) {
        this.appmod = "getCampaignDIDCount";
        let result = super.getService(campaign_key, userID);
        this.appmod = "";
        return result;
    }
    onGetCampaignsMno() {
        this.appmod = 'mnoMetaDataDetails';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    mnoMetaDataForRegister(data) {
        this.appmod = 'qualifyBrandByUsecas';
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    mnoMetaDataForResubmit(data) {
        this.appmod = 'qualifyBrandByUsecas';
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    getBrand() {
        this.appmod = 'getbrands';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getBrandCnpList() {
        this.appmod = 'getBrandCnpList';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    brandVertical() {
        this.appmod = "brandVertical";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getBrandsDetail(id) {
        this.appmod = 'brand';
        let result = super.getService(id);
        this.appmod = "";
        return result;
    }
    getCampaignsDetail(id) {
        this.appmod = 'campaignDetails';
        let result = super.getService(id);
        this.appmod = "";
        return result;
    }
    getCampaignsDetailId(id) {
        this.appmod = 'getCampaignsDetailId';
        let result = super.getService(id);
        this.appmod = "";
        return result;
    }
    getConntPratners() {
        this.appmod = "connPartnersDetails";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getResellerDetailss() {
        this.appmod = "getResellerDetails";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getBrandVetting(payLoad) {
        this.appmod = 'getBrandsVettingList';
        let result = super.getService(payLoad);
        this.appmod = "";
        return result;
    }
    getVettingClass(payLoad) {
        this.appmod = 'getVettingClass';
        let result = super.getService(payLoad);
        this.appmod = "";
        return result;
    }
    getVettingPartner(payLoad) {
        this.appmod = 'getVettingPartner';
        let result = super.getService(payLoad);
        this.appmod = "";
        return result;
    }
    //@LoaderEnabled()
    updateVetting(data) {
        this.appmod = "updateVettingForStatus";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    brandVettingClass() {
        this.appmod = "vettingClass";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    brandVettingProvider() {
        this.appmod = "extVettingProvider";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    applyNewVetting(data) {
        let apiURL = environment.SERVER + "applyVetting";
        return this.http.post(apiURL, data, { headers: this.httpHeaders });
        // this.appmod = 'addcampaign';
        // let result = super.saveService(data);
        // this.appmod = "";
        // return result;
    }
    importVetting(data) {
        let apiUrl = environment.SERVER + 'importVetting';
        let httpheaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.put(apiUrl, data, { headers: httpheaders });
    }
    onNewRegisterCampaign(data) {
        let apiURL = environment.SERVER + "registercampaign";
        return this.http.post(apiURL, data, { headers: this.httpHeaders });
    }
    getcampaign() {
        return this.http.get('./assets/newCampaign.json');
    }
    getlegalOrg() {
        return this.http.get('./assets/newBrand.json');
    }
    Duns_giinData() {
        return this.http.get('./assets/newBrand.json');
    }
    US_State() {
        return this.http.get('./assets/newBrand.json');
    }
    CA_State() {
        return this.http.get('./assets/newBrand.json');
    }
    stock_Exchange() {
        this.appmod = "stockExchange";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    altBusinessIdType() {
        this.appmod = "altBusinessIdType";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    editBrand(data) {
        this.appmod = "updateBrand";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    getCampaign(data) {
        this.appmod = "brandCampaign";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    DeleteNewBrand(data) {
        this.appmod = 'deleteBrand';
        let result = super.deleteService(data);
        this.appmod = "";
        return result;
    }
    DeleteNewCampaign(data) {
        this.appmod = 'deletecampaign';
        let result = super.deleteService(data);
        this.appmod = "";
        return result;
    }
    getBrandIdentityStatus() {
        this.appmod = "brandIdentityStatus";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getBrandEntityType() {
        this.appmod = "brandEntity";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    applyFilter(data) {
        this.appmod = "brandFilter";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    applyCnpFilter(data) {
        this.appmod = "cnpBrandFilter";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    applyCampaignFilter(data) {
        this.appmod = "campaignFilter";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    applyCNPCampaignFilter(data) {
        this.appmod = "CNPcampaignFilter";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    getuseCases() {
        this.appmod = "campaignCasesPanel";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    campaignFilter(data) {
        this.appmod = "campaignFilterForBrand";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    updateCampaignsDetail(data) {
        this.appmod = "updateCampaign";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    finalUpdateForCampaign(data) {
        this.appmod = "finalUpdateForCampaign";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    getAddress() {
        this.appmod = "company";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getCampaignMnoDetails(camId) {
        this.appmod = 'mnoMetaDataDetails';
        let result = super.getService(camId);
        this.appmod = "";
        return result;
    }
    campMnoMetaDataDetails(camId) {
        this.appmod = 'campMnoMetaDataDetails';
        let result = super.getService(camId);
        this.appmod = "";
        return result;
    }
    getCampaignEvents(camId) {
        this.appmod = 'getCampaignEvents';
        let result = super.getService(camId);
        this.appmod = "";
        return result;
    }
    resubmitBrand(brandId) {
        this.appmod = "updateBrandIdentity";
        let result = super.updateService(brandId);
        this.appmod = "";
        return result;
    }
    brandQualifyByAllUseCases(data) {
        this.appmod = 'brandQualifyByAllUseCases';
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    getlocaldata() {
        return this.http.get('./assets/newBrand.json');
    }
    getpinPreference() {
        return this.http.get('./assets/newBrand.json');
    }
    getfecCommitteeTypeCode() {
        return this.http.get('./assets/newBrand.json');
    }
    createCampaignFile(data) {
        this.appmod = "createCampaignFile";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    getBrandFeedback(brandId) {
        this.appmod = 'getBrandFeedback';
        let result = super.getService(brandId);
        this.appmod = "";
        return result;
    }
    resubmitCampaign(data) {
        this.appmod = "resubmitCampaign";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    appealVettingRequest(data, file) {
        const formData = new FormData();
        formData.append("data", JSON.stringify(data));
        formData.append("ATTACHMENTS", file);
        const apiURL = environment.SERVER + 'appealVettingRequest';
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, formData, { headers: httpHeaders });
    }
    getVettingAppealDetails(data) {
        this.appmod = 'getVettingAppealDetails';
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    getCampaignsFileById(id) {
        this.appmod = 'getCampaignsFileById';
        let result = super.getService(id);
        this.appmod = "";
        return result;
    }
    deleteCampFile(data) {
        this.appmod = 'campaignMultimediaFileDelete';
        let result = super.deleteService(data);
        this.appmod = "";
        return result;
    }
    deleteAddCampFile(data) {
        this.appmod = 'deleteAddCampFile';
        let result = super.deleteService(data);
        this.appmod = "";
        return result;
    }
};
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "onBrandRegister", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "brandRelationship", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getBranAppeal", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getBranAppealFiles", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getCampaignCases", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getBrandViewFiles", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "onGetNewCampaigns", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "GetCampaignsList", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "GetCNPCampaignsList", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "dcaSubmit", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "rejectFormByAdmin", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "failedFormByAdmin", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "RequestEdit", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "failedCnpFormByAdmin", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getCampaignDID", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getCampaignDIDCount", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "onGetCampaignsMno", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "mnoMetaDataForRegister", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "mnoMetaDataForResubmit", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getBrand", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getBrandCnpList", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "brandVertical", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getBrandsDetail", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getCampaignsDetail", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getCampaignsDetailId", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getConntPratners", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getResellerDetailss", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getBrandVetting", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getVettingClass", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getVettingPartner", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "brandVettingClass", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "brandVettingProvider", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "applyNewVetting", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "importVetting", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "onNewRegisterCampaign", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "stock_Exchange", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "altBusinessIdType", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "editBrand", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getCampaign", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "DeleteNewBrand", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "DeleteNewCampaign", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getBrandIdentityStatus", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getBrandEntityType", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "applyFilter", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "applyCnpFilter", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "applyCampaignFilter", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "applyCNPCampaignFilter", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getuseCases", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "campaignFilter", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "updateCampaignsDetail", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "finalUpdateForCampaign", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getAddress", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getCampaignMnoDetails", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "campMnoMetaDataDetails", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getCampaignEvents", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "resubmitBrand", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "brandQualifyByAllUseCases", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "createCampaignFile", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getBrandFeedback", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "resubmitCampaign", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "appealVettingRequest", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getVettingAppealDetails", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "getCampaignsFileById", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "deleteCampFile", null);
__decorate([
    LoaderEnabled()
], NewCamapignService.prototype, "deleteAddCampFile", null);
NewCamapignService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], NewCamapignService);
export { NewCamapignService };
//# sourceMappingURL=new-camapign.service.js.map