import { __decorate } from "tslib";
import { Component, ViewChild } from '@angular/core';
let EmailNotificationComponent = class EmailNotificationComponent {
    constructor(sanitizer, router, http, data, fb) {
        this.sanitizer = sanitizer;
        this.router = router;
        this.http = http;
        this.data = data;
        this.fb = fb;
        this.emailnotify = [];
        this.Customernotify = [];
        this.CustomerList = [];
        this.responseMessage = "";
        this.errMessage = "";
        this.userlist = [];
    }
    ngOnInit() {
        this.selectedAwaitCount = '';
        let session$ = sessionStorage.getItem("isLoggedIn");
        let session = JSON.parse(session$);
        this.userType = session.type;
        this.data.get_systemnotification().subscribe((result) => {
            this.systemtable = result[1].emailnotification;
            this.emailheading = this.systemtable[0].heading;
            this.btndata = this.systemtable[0].button;
            this.tabledata = this.systemtable[0].tableheaders;
            this.notifitedcustomer = result[1].notifiedcustomermodal;
            this.modalheader = this.notifitedcustomer[0].heading;
            this.modaltables = this.notifitedcustomer[0].modaltable;
        });
        this.emailnotifydata();
        this.Customernotifydata();
        $.getScript('./assets/tollfree.js');
        $.getScript('./assets/table.js');
    }
    emailnotifydata() {
        this.data.getemail_notification().subscribe((res) => {
            if (res.status == 201) {
                this.emailnotify = this.groupData(res.data);
                this.responseMessage = res.message;
                $('#basic-datatables3').dataTable().fnClearTable();
                $('#basic-datatables3').dataTable().fnDraw();
                $('#basic-datatables3').dataTable().fnDestroy();
                $.getScript('./assets/tollfree.js');
                setTimeout(() => {
                    this.responseMessage = '';
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            }
        });
    }
    groupData(data) {
        const uniqueData = Object.values(data.reduce((grouped, item) => {
            const groupKey = item.key;
            if (!grouped[groupKey]) {
                grouped[groupKey] = item;
            }
            return grouped;
        }, {}));
        return uniqueData;
    }
    Customernotifydata() {
        this.data.getemail_notification().subscribe((res) => {
            if (res.status == 201) {
                this.Customernotify = res.data;
                this.responseMessage = res.message;
                $('#basic-datatables1').dataTable().fnClearTable();
                $('#basic-datatables1').dataTable().fnDraw();
                $('#basic-datatables1').dataTable().fnDestroy();
                $.getScript('./assets/tollfree.js');
                setTimeout(() => {
                    this.responseMessage = '';
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            }
        });
    }
    NotifyCustomerLIst(key) {
        $('#basic-datatables').dataTable().fnDestroy();
        $.getScript('./assets/table.js');
        this.CustomerList = [];
        this.data.NotifyCustomerLIst(key).subscribe((res) => {
            if (res.status == 201) {
                this.CustomerList = res.data;
                this.responseMessage = res.message;
                $('#basic-datatables').dataTable().fnClearTable();
                $('#basic-datatables').dataTable().fnDraw();
                $('#basic-datatables').dataTable().fnDestroy();
                $.getScript('./assets/table.js');
                setTimeout(() => {
                    this.responseMessage = '';
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            }
        });
    }
    truncateHTMLDescription(description) {
        const maxLength = 20;
        const truncatedText = (new DOMParser().parseFromString(description, 'text/html')).body.textContent || '';
        const truncatedDescription = truncatedText.length > maxLength ? truncatedText.substring(0, maxLength) + '..' : truncatedText;
        return this.sanitizer.bypassSecurityTrustHtml(truncatedDescription);
    }
    truncateSubject(subject, maxLength) {
        return subject.length > maxLength ? subject.substring(0, maxLength) + '..' : subject;
    }
    ngOnDestroy() {
        this.closeModal.nativeElement.click();
    }
};
__decorate([
    ViewChild('closeModal')
], EmailNotificationComponent.prototype, "closeModal", void 0);
EmailNotificationComponent = __decorate([
    Component({
        selector: 'app-email-notification',
        templateUrl: './email-notification.component.html',
        styleUrls: ['./email-notification.component.css']
    })
], EmailNotificationComponent);
export { EmailNotificationComponent };
//# sourceMappingURL=email-notification.component.js.map