import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from '../shared/service/AppService.class';
import { LoaderEnabled } from '../shared/loader/loader.service';
import { BehaviorSubject } from 'rxjs';
import { environment } from 'src/environments/environment';
let NotificationService = class NotificationService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.notificationCountSubject = new BehaviorSubject({ count: 0, data: null });
        this.notificationCount$ = this.notificationCountSubject.asObservable();
        this.notificationCount1 = new BehaviorSubject({ count: 0, data: null });
        this.email_notificationCount$ = this.notificationCount1.asObservable();
        this.httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
    }
    updateNotificationCount(count, data) {
        const newData = { count, data };
        this.notificationCountSubject.next(newData);
    }
    updateCount(count, data) {
        const Data = { count, data };
        this.notificationCount1.next(Data);
    }
    get_system_notification() {
        return this.http.get('./assets/systemnotification.json');
    }
    viewNotification() {
        this.appmod = "viewNotification";
        let result = super.getService();
        this.appmod = "viewNotification";
        return result;
    }
    displayNotificationForCustomer() {
        this.appmod = "displayNotificationForCustomer";
        let result = super.getService();
        this.appmod = "displayNotificationForCustomer";
        return result;
    }
    // @LoaderEnabled()
    NotificationCountForCustomer() {
        this.appmod = "NotificationCountForCustomer";
        let result = super.getService();
        this.appmod = "NotificationCountForCustomer";
        return result;
    }
    // @LoaderEnabled()
    UpdateViewNotificationStatus(data) {
        this.appmod = "UpdateViewNotificationStatus";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    // @LoaderEnabled()
    //  get_customerdetails(data: any): Observable<any> {
    //   this.appmod = "customerStatus";
    //   let result = super.getService(data);
    //   this.appmod = "notificationSystem";
    //   return result;
    // }
    getUsers(type) {
        this.appmod = "user";
        let tmp = this.getService(type);
        this.appmod = "usermanagement";
        return tmp;
    }
    sendNotification(data) {
        let tmp = this.appmod;
        this.appmod = 'sendNotification';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    getStatus() {
        this.appmod = 'getSystemNotificationStatus';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getSuspendedService() {
        this.appmod = "getSuspendedService";
        let result = this.getService();
        this.appmod = "usermanagement";
        return result;
    }
    get_systemnotification() {
        return this.http.get('./assets/notification.json');
    }
    get_status() {
        this.appmod = "getStatusList";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    get_category() {
        this.appmod = "getcategoryList";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    get_categoryCust() {
        this.appmod = "getcategoryListCust";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    submitNotify(payLoad, file) {
        const formData = new FormData();
        for (let i = 0; i < file.length; i++) {
            formData.append("ATTACHMENTS", file[i], file[i].name);
        }
        formData.append("ATTACHMENTS", file);
        formData.append("data", payLoad);
        const apiURL = environment.SERVER + 'savenotifyemail';
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, formData, { headers: httpHeaders });
    }
    getemail_notification() {
        this.appmod = "get_EmailNotification";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getemail_notify(key) {
        this.appmod = "get_singleEmailNotify";
        let result = super.getService(key);
        this.appmod = "";
        return result;
    }
    NotifyCustomerLIst(key) {
        this.appmod = "NotifyCustomerList";
        let result = super.getService(key);
        this.appmod = "";
        return result;
    }
    sendmaildata(payLoad) {
        this.appmod = "saveCustMail";
        let result = super.saveService(payLoad);
        this.appmod = "";
        return result;
    }
    subscribe_email() {
        this.appmod = "emailsubscriber";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    update_status(payLoad) {
        this.appmod = "updatestatus_view";
        let result = super.updateService(payLoad);
        this.appmod = "";
        return result;
    }
    getEmail_subscription() {
        this.appmod = "get_Emailsubscription";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    Update_CustMail(data) {
        this.appmod = "UpdateCustMail";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    NotificationCount() {
        this.appmod = "NotificationCountList";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    Cust_MailSubsc() {
        this.appmod = 'CustomerEmailSubscrip';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
};
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "viewNotification", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "displayNotificationForCustomer", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "getUsers", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "sendNotification", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "getStatus", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "get_status", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "get_category", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "get_categoryCust", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "submitNotify", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "getemail_notification", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "getemail_notify", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "NotifyCustomerLIst", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "sendmaildata", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "subscribe_email", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "update_status", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "getEmail_subscription", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "Update_CustMail", null);
__decorate([
    LoaderEnabled()
], NotificationService.prototype, "Cust_MailSubsc", null);
NotificationService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], NotificationService);
export { NotificationService };
//# sourceMappingURL=notification.service.js.map