import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let CalldetailsrecordComponent = class CalldetailsrecordComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.searchText = { count: 0 };
        this.p = 1;
        this.page = 1;
        this.count = 0;
        this.tableSize = 50;
        this.tableSizes = [50, 100, 150];
        this.submitted = false;
        this.filterCdr = [];
    }
    ngOnInit() {
        this.cdrForm = this.fb.group({
            to_date: ['', Validators.required],
            from_date: ['', Validators.required],
            from_number: [''],
            to_number: [''],
            direction: ['outbound']
        });
        this.data.getCdr().subscribe((result) => {
            this.label = result[1];
            this.header = result[0].headers_details;
            this.rowdata = result[0].product_details;
        });
    }
    onCdrFilter() {
        this.submitted = true;
        if (this.cdrForm.invalid) {
            return false;
        }
        else {
            this.filterCdr = [];
            this.data.callDetailRecord(JSON.stringify(this.cdrForm.value)).subscribe(response => {
                if (response.data) {
                    this.filterCdr = response.data;
                }
            });
        }
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event;
    }
};
CalldetailsrecordComponent = __decorate([
    Component({
        selector: 'app-calldetailsrecord',
        templateUrl: './calldetailsrecord.component.html',
        styleUrls: ['./calldetailsrecord.component.css']
    })
], CalldetailsrecordComponent);
export { CalldetailsrecordComponent };
//# sourceMappingURL=calldetailsrecord.component.js.map