import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from 'src/app/shared/service/AppService.class';
import { environment } from 'src/environments/environment';
import { LoaderEnabled } from '../shared/loader/loader.service';
let OutboundService = class OutboundService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.appmod = "usermanagement";
    }
    taxCalculation(data) {
        this.appmod = "tax_calculation";
        let result = super.saveService(data);
        this.appmod = "usermanagement";
        return result;
    }
    saveData(data) {
        let tmp = this.appmod;
        this.appmod = 'custom/saveheadermapping';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    callDetailRecord(data) {
        let tmp = this.appmod;
        this.appmod = 'details_cdr';
        let result = super.getService(data);
        this.appmod = tmp;
        return result;
    }
    updateData(data) {
        let tmp = this.appmod;
        this.appmod = 'custom/saveheadermapping';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    testCall(data) {
        const apiURL = environment.SERVER + 'originate';
        // let httpHeaders = new HttpHeaders({
        //   "Content-Type": "application/json"
        // });
        return this.http.post(apiURL, data);
        // let tmp = this.appmod;
        // this.appmod = 'outboundcalltonumber';
        // let result = super.saveService(data);
        // this.appmod = tmp;
        // return result;
    }
    testCallviaMedia(data) {
        const apiURL = environment.SERVER + 'makeCallViaMedia';
        return this.http.post(apiURL, data);
    }
    uploadMediaFile(media, file) {
        const formData = new FormData();
        formData.append("UPLOAD", file);
        formData.append("data", JSON.stringify(media));
        const apiURL = environment.SERVER + 'uploadMedia';
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, formData, { headers: httpHeaders });
    }
    getMediaFiles() {
        let apiUrl = environment.SERVER + 'listMedia';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders });
    }
    deleteMediaFile(mediaID) {
        let apiUrl = environment.SERVER + 'deleteMedia';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.delete(apiUrl, { headers: httpHeaders, params: { mediaID: mediaID } });
    }
    get_trunks() {
        return this.http.get('./assets/trunks.json');
    }
    get_routing() {
        return this.http.get('./assets/routing_profile.json');
    }
    get_cdr() {
        return this.http.get('./assets/cdr.json');
    }
    gettestcall() {
        return this.http.get('./assets/calltesting.json');
    }
    getmedia() {
        return this.http.get('./assets/testcallmedia.json');
    }
    getMediaUpload() {
        return this.http.get('./assets/mediaupload.json');
    }
    getCdr() {
        return this.http.get('./assets/cdr.json');
    }
};
__decorate([
    LoaderEnabled()
], OutboundService.prototype, "taxCalculation", null);
__decorate([
    LoaderEnabled()
], OutboundService.prototype, "saveData", null);
__decorate([
    LoaderEnabled()
], OutboundService.prototype, "callDetailRecord", null);
__decorate([
    LoaderEnabled()
], OutboundService.prototype, "updateData", null);
__decorate([
    LoaderEnabled()
], OutboundService.prototype, "testCall", null);
__decorate([
    LoaderEnabled()
], OutboundService.prototype, "testCallviaMedia", null);
__decorate([
    LoaderEnabled()
], OutboundService.prototype, "uploadMediaFile", null);
__decorate([
    LoaderEnabled()
], OutboundService.prototype, "getMediaFiles", null);
__decorate([
    LoaderEnabled()
], OutboundService.prototype, "deleteMediaFile", null);
OutboundService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], OutboundService);
export { OutboundService };
//# sourceMappingURL=outbound.service.js.map