import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { routingForm } from '../outbound.class';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let RoutingprofileComponent = class RoutingprofileComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.p = 1;
        this.page = 1;
        this.count = 0;
        this.tableSize = 5;
        this.tableSizes = [5, 9, 12];
        this.show = false;
        this.buttonName = "Add";
        this.submitted = false;
        this.collection = "";
        this.heading = [];
        this.upper_heading = "";
    }
    ngOnInit() {
        // @subscribing form group
        this.data.solution.subscribe(res => {
            if (res != null) {
                console.log("Update data " + JSON.stringify(res));
                this.cdata = new routingForm(res);
                this.keyfield = res.id;
                this.routingForm = this.cdata.makeform(this.fb);
            }
            else {
                console.log("adding data " + JSON.stringify(res));
                this.cdata = new routingForm(null);
                this.keyfield = -1;
                this.routingForm = this.cdata.makeform(this.fb);
            }
        });
        this.data.get_routing().subscribe((result) => {
            this.label = result[1];
            this.heading = result[0].headers;
            this.rowdata = result[0].routing_profile;
            console.log("result::", result);
        });
    }
    // @to edit the record
    editRow(rowdata) {
        this.show = true;
        this.Edit(rowdata);
    }
    // @to save/update form data
    onSubmit() {
        this.submitted = true;
        if (this.routingForm.invalid) {
            return false;
        }
        else {
            console.log("submit data::", this.cdata);
            if (this.cdata.saveForm(this.routingForm)) {
                console.log("Submitted data ::\n" + JSON.stringify(this.cdata));
                if (this.keyfield == -1) {
                    this.data.saveData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
                else {
                    this.data.updateData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
            }
        }
    }
    saveForm(data) {
        console.log(data, "data");
    }
    toggle() {
        this.show = !this.show;
        // CHANGE THE NAME OF THE BUTTON.
        if (this.show)
            this.buttonName = "Close";
        else
            this.buttonName = "Add";
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event;
    }
};
RoutingprofileComponent = __decorate([
    Component({
        selector: 'app-routingprofile',
        templateUrl: './routingprofile.component.html',
        styleUrls: ['./routingprofile.component.css']
    })
], RoutingprofileComponent);
export { RoutingprofileComponent };
//# sourceMappingURL=routingprofile.component.js.map