import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let TestCallByMediaComponent = class TestCallByMediaComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.submitted = false;
        this.responseMessage = "";
        this.errMessage = "";
        this.testMediaForm = this.fb.group({
            FROM: ['', [Validators.required, Validators.minLength(10)]],
            TO: ['', [Validators.required, Validators.minLength(10)]],
            mediaID: ['', [Validators.required]]
        });
    }
    ngOnInit() {
        this.data.getmedia().subscribe((result) => {
            this.fieldform = result;
        });
        this.data.getMediaFiles().subscribe(res => {
            if (res.status == 200) {
                $('#basic-datatables').DataTable().clear();
                $('#basic-datatables').DataTable().destroy();
                this.mediaFiles = res.data;
                $.getScript('./assets/table.js');
            }
            else {
                this.errMessage = "";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    // filterByUser(e) {
    //   console.log("dataaaaaa",e);
    //   this.testMediaForm.patchValue({
    //     mediaID: e.target.value
    //   });
    // }
    allowNumbersOnly(e) {
        var code = (e.which) ? e.which : e.keyCode;
        if (code > 31 && (code < 48 || code > 57)) {
            e.preventDefault();
        }
    }
    onTestCall() {
        this.submitted = true;
        if (this.testMediaForm.invalid) {
            return false;
        }
        else {
            this.data.testCallviaMedia(this.testMediaForm.value).subscribe(response => {
                if (response.status == 200) {
                    this.responseMessage = response.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                }
                else {
                    this.errMessage = response.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.responseMessage = err.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            });
        }
    }
    resetCall() {
        this.submitted = false;
    }
    onReset() {
        this.submitted = false;
        this.testMediaForm.reset();
    }
};
TestCallByMediaComponent = __decorate([
    Component({
        selector: 'app-test-call-by-media',
        templateUrl: './test-call-by-media.component.html',
        styleUrls: ['./test-call-by-media.component.css']
    })
], TestCallByMediaComponent);
export { TestCallByMediaComponent };
//# sourceMappingURL=test-call-by-media.component.js.map