import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { FormControl } from '@angular/forms';
let TestcallComponent = class TestcallComponent extends AppComponentClass {
    // fieldform: Observable<any>;
    constructor(data, userService, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.userService = userService;
        this.router = router;
        this.fb = fb;
        this.submitted = false;
        this.responseMessage = "";
        this.errMessage = "";
        this.serviceMessage = 'Call service has been suspended. More information please contact support';
        this.testCallForm = this.fb.group({
            FROM: new FormControl(""),
            CALLEE: new FormControl(""),
            CALLER: new FormControl("")
        });
    }
    ngOnInit() {
        this.userService.getfeatureServiceStatus().subscribe(res => {
            this.featureServiceData = res.data.find(x => x.fs_id == '3');
            if (this.featureServiceData !== undefined && this.featureServiceData.as_status == 1) {
                this.isDisabledServiceStatus = false;
            }
            else {
                this.isDisabledServiceStatus = true;
                this.showMsg();
            }
        });
        this.data.gettestcall().subscribe((result) => {
            this.fieldform = result;
        });
    }
    // @to save/update form data
    onTestCall() {
        this.submitted = true;
        if (this.testCallForm.invalid) {
            return false;
        }
        else {
            this.data.testCall(this.testCallForm.value).subscribe(response => {
                if (response.status == 201) {
                    this.responseMessage = response.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                }
                else {
                    this.errMessage = response.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.errMessage = "Something went wrong with calling. Please call again.";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            });
        }
    }
    onReset() {
        this.submitted = false;
        this.testCallForm.reset();
    }
    allowNumbersOnly(e) {
        var code = (e.which) ? e.which : e.keyCode;
        if (code > 31 && (code < 48 || code > 57)) {
            e.preventDefault();
        }
    }
    showMsg() {
        this.errMessage = this.serviceMessage;
        setTimeout(() => {
            this.errMessage = "";
        }, 5000);
    }
};
TestcallComponent = __decorate([
    Component({
        selector: 'app-testcall',
        templateUrl: './testcall.component.html',
        styleUrls: ['./testcall.component.css']
    })
], TestcallComponent);
export { TestcallComponent };
//# sourceMappingURL=testcall.component.js.map