import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from 'src/app/shared/service/AppService.class';
import { LoaderEnabled } from '../shared/loader/loader.service';
import { environment } from 'src/environments/environment';
let ReportService = class ReportService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
    }
    tMobileReportList() {
        let apiUrl = environment.SERVER + 'tmobile-list';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders });
    }
    tMobileReport(month) {
        let apiUrl = environment.SERVER + 'tmobile-report';
        let httpHeaders = new HttpHeaders({});
        return this.http.get(apiUrl, { headers: httpHeaders, params: { month: month } });
    }
    gettmobile() {
        return this.http.get('./assets/tmobile.json');
    }
};
__decorate([
    LoaderEnabled()
], ReportService.prototype, "tMobileReportList", null);
__decorate([
    LoaderEnabled()
], ReportService.prototype, "tMobileReport", null);
ReportService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], ReportService);
export { ReportService };
//# sourceMappingURL=reports.service.js.map