import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { saveAs } from 'file-saver';
import * as XLSX from 'xlsx';
let TmobileComponent = class TmobileComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.page = 1;
        this.count = 0;
        this.tableSize = 25;
        this.tableSizes = [25, 50, 100];
        this.searchText = { count: 0 };
        this.errMessage = "";
        this.EXCEL_TYPE = 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet;charset=UTF-8';
        this.EXCEL_EXTENSION = '.xlsx';
    }
    ngOnInit() {
        this.data.gettmobile().subscribe((result) => {
            this.header = result[0].headers_details;
        });
        this.data.tMobileReportList().subscribe(res => {
            if (res.status == 200) {
                this.listdata = res.data;
                $.getScript('./assets/table.js');
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    exportFile(data) {
        this.data.tMobileReport(data.month).subscribe(res => {
            if (res.status == 200) {
                let data = res.data[0];
                const worksheet = XLSX.utils.json_to_sheet(data);
                const workbook = { Sheets: { 'data': worksheet }, SheetNames: ['data'] };
                const excelBuffer = XLSX.write(workbook, { bookType: 'xlsx', type: 'array' });
                this.saveAsExcelFile(excelBuffer, "tmobile_report");
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    saveAsExcelFile(buffer, fileName) {
        const data = new Blob([buffer], {
            type: this.EXCEL_TYPE
        });
        saveAs(data, fileName + new Date().getTime() + this.EXCEL_EXTENSION);
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event.length;
    }
};
TmobileComponent = __decorate([
    Component({
        selector: 'app-tmobile',
        templateUrl: './tmobile.component.html',
        styleUrls: ['./tmobile.component.css']
    })
], TmobileComponent);
export { TmobileComponent };
//# sourceMappingURL=tmobile.component.js.map