import { __decorate } from "tslib";
import { Component, ViewChild } from '@angular/core';
import { Validators } from '@angular/forms';
let CommissionPlanComponent = class CommissionPlanComponent {
    constructor(data, fb, route, router) {
        this.data = data;
        this.fb = fb;
        this.route = route;
        this.router = router;
        this.submitted = false;
        this.responseMessage = "";
        this.errMessage = "";
        this.show = false;
        this.modeltext = '';
        this.show_filter = false;
        this.commissionfilter = [];
        this.savePlan = 'Submit';
    }
    ngOnInit() {
        this.cPlanForm = this.fb.group({
            plan_name: ['', [Validators.required]],
            description: ['', [Validators.required]],
            id_plan: ['']
        });
        // this.filterCommission = this.fb.group({
        //   fType: [''],
        //   plan_name: [],
        //   fromDate: new FormControl(''),
        //   toDate: new FormControl(''),
        // }, {
        //   validator: Validators.compose([
        //     CommissionPlanComponent.dateLessThan('fromDate', 'toDate', { 'fromDate': true })
        //   ])
        // });
        // this.filterCommission.patchValue({
        // 	fType:""
        // })
        /*add filter commission plan */
        // this.data.applycommissionFilter().subscribe(response => {      
        // 	if (response.data) {
        // 		this.commissionfilter = response.data; 
        //     console.log("CHECK RESULT FOR PLAN",this.commissionfilter)
        //     $('#basic-datatables').DataTable().clear();
        //     $('#basic-datatables').DataTable().destroy();    
        // 		$.getScript('./assets/table.js');
        // 	}
        // });
        this.getCommisssionplan();
    }
    getCommisssionplan() {
        this.data.getCommissionPlan().subscribe(response => {
            if (response.data) {
                this.Cplan = response.data;
                this.Cplan.forEach(element => {
                    element.plan_n = btoa(element.plan_name);
                });
                $('#basic-datatables15').DataTable().clear();
                $('#basic-datatables15').DataTable().destroy();
                $.getScript('./assets/table.js');
            }
        });
    }
    setAsDefault(id_plan, iduser) {
        let data = id_plan + '-' + iduser;
        this.data.setDefault(data).subscribe(res => {
            if (res.status == 201) {
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
                this.ngOnInit();
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    showdata(data) {
        this.modeltext = 'Add Commission Plan',
            this.savePlan = 'Submit';
        if (data.id_plan) {
            this.modeltext = 'Edit Commission Plan';
            this.savePlan = 'Update';
            this.cPlanForm.patchValue({
                plan_name: data.plan_name,
                description: data.description,
                id_plan: data.id_plan
            });
        }
        else {
            //reset form
        }
    }
    onsubmit() {
        if (this.cPlanForm.invalid) {
            this.submitted = true;
            return;
        }
        else {
            if (this.cPlanForm.value.id_plan) {
                this.data.updateCommissionPlan(this.cPlanForm.value).subscribe(res => {
                    if (res.status == 200) {
                        this.responseMessage = res.message;
                        this.getCommisssionplan();
                        this.cPlanForm.reset();
                        this.closeModal.nativeElement.click();
                        setTimeout(() => {
                            this.responseMessage = "";
                        }, 3000);
                    }
                    else {
                        this.errMessage = res.message;
                        setTimeout(() => {
                            this.errMessage = "";
                        }, 3000);
                    }
                });
            }
            else {
                this.savePlan = 'Submit';
                this.data.saveCommissionPlan(this.cPlanForm.value).subscribe(res => {
                    if (res.status == 200) {
                        this.responseMessage = res.message;
                        this.getCommisssionplan();
                        this.cPlanForm.reset();
                        this.closeModal.nativeElement.click();
                        setTimeout(() => {
                            this.responseMessage = "";
                        }, 3000);
                    }
                    else {
                        this.errMessage = res.message;
                        setTimeout(() => {
                            this.errMessage = "";
                        }, 3000);
                    }
                });
            }
        }
    }
    onClose() {
        const commitionId = this.cPlanForm.value.id_plan;
        this.submitted = false;
        this.cPlanForm.reset();
        this.cPlanForm.get('id_plan').setValue(commitionId);
    }
    deleteplan(id) {
        if (confirm("Are you sure you want delete plan!")) {
            this.data.ondeleteCommissionPlan(id).subscribe(res => {
                if (res.status == 201) {
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                    this.getCommisssionplan();
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    });
                }
            }, error => {
                this.responseMessage = error.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            });
        }
        else {
            return;
        }
    }
    /**Function for filter hide open**/
    showField() {
        if (this.show == false) {
            this.show = true;
        }
        else {
            this.show = false;
        }
    }
};
__decorate([
    ViewChild('closeModal')
], CommissionPlanComponent.prototype, "closeModal", void 0);
CommissionPlanComponent = __decorate([
    Component({
        selector: 'app-commission-plan',
        templateUrl: './commission-plan.component.html',
        styleUrls: ['./commission-plan.component.css']
    })
], CommissionPlanComponent);
export { CommissionPlanComponent };
//# sourceMappingURL=commission-plan.component.js.map