import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from "@angular/common/http";
import { environment } from "src/environments/environment";
import { LoaderEnabled } from "../shared/loader/loader.service";
import { AppService } from "../shared/service/AppService.class";
let ResellerService = class ResellerService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
    }
    patchValue(arg0) {
        throw new Error('Method not implemented.');
    }
    getsuppiler() {
        return this.http.get('./assets/reseller.json');
    }
    saveReseller(data) {
        let tmp = this.appmod;
        this.appmod = "saveReseller";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    getTariffs() {
        this.appmod = "getTariffs";
        let tmp = this.getService();
        this.appmod = "";
        return tmp;
    }
    getPreferenceService() {
        this.appmod = "service";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getReseller(data) {
        this.appmod = "getReseller";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    /*customer details filter services*/
    applyCustomerDFilter(data) {
        this.appmod = "customerDetailsFilter";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    commissionTerm() {
        this.appmod = "commissionTerm";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    /*DELETE RESELLER service*/
    onDeleteReseller(iduser) {
        const apiURL = environment.SERVER + 'deleteReseller';
        let httpHeaders = new HttpHeaders({});
        return this.http.delete(apiURL, { headers: httpHeaders, params: { iduser: iduser } });
    }
    /*end here domian block services..*/
    getsingleReseller(data) {
        this.appmod = "getResellerPlan_tariff";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    updateResellerbyID(data) {
        let tmp = this.appmod;
        this.appmod = 'updateResellerbyID';
        let result = super.updateService(data);
        this.appmod = tmp;
        return result;
    }
    // @LoaderEnabled()
    // getsingleUser(data: any): Observable<any> {
    //   this.appmod = "getsingleReseller";
    //   let result = super.getService(data);
    //   this.appmod = "";
    //   return result;
    // }
    applyresellerFilter(data) {
        this.appmod = "resellerFilter";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    /* Reseller services closed here*/
    /*FOR COMMISSION DETAILS*/
    /*GET commission detail filter service*/
    applyCommDetailsFilter(data) {
        this.appmod = "commDetailsFilter";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    /*end here commission detail services..*/
    /*FOR COMMISSION PLAN*/
    /*INSERT commission plan service*/
    saveCommissionPlan(data) {
        this.appmod = "saveCommissionPlan";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    /*GET commission plan service*/
    getCommissionPlan(data) {
        this.appmod = "getCommissionPlan";
        let tmp = this.getService(data);
        this.appmod = "";
        return tmp;
    }
    setDefault(data) {
        let apiUrl = environment.SERVER + "default_plan";
        let httpHeaders = new HttpHeaders({
        // "Content-Type": "application/json",
        });
        return this.http.put(apiUrl, { data: data }, { headers: httpHeaders });
    }
    /*UPDATE commission plan service*/
    updateCommissionPlan(data) {
        this.appmod = "updateCommissionPlan";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    /*DELETE commission plan service*/
    ondeleteCommissionPlan(id_plan) {
        const apiURL = environment.SERVER + 'deleteCommissionPlan';
        let httpHeaders = new HttpHeaders({});
        return this.http.delete(apiURL, { headers: httpHeaders, params: { id_plan: id_plan } });
    }
    // @LoaderEnabled()
    // getsingleCommPlan(data: any): Observable<any> {
    //   this.appmod = "singleGetCommissionPlan";
    //   let result = super.getService(data);
    //   this.appmod = "";
    //   return result;
    // }
    // @LoaderEnabled()
    // Loginreseller(resellerLogin:any): Observable<any> {
    //   const apiURL = 'http://localhost:4250/reseller_login';
    //   let httpHeaders = new HttpHeaders({
    //   });
    //   return this.http.post(apiURL, { headers: httpHeaders, params: { resellerLogin: resellerLogin } });
    // }
    // @LoaderEnabled()
    // applycommissionFilter(): Observable<any> {
    //   this.appmod = "commissionFilter";
    //   let result = super.getService();
    //   this.appmod = "";
    //   return result;
    // }
    /*end here commission detail services..*/
    /*FOR COMMISSION PLAN--Tiers*/
    /*INSERT commission tiers service*/
    saveCommissionTier(data) {
        this.appmod = "saveCommissionTier";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    /*GET commission Tier service*/
    getCommissionTier(data) {
        this.appmod = "getCommissionTier";
        let tmp = this.getService(data);
        this.appmod = "";
        return tmp;
    }
    /*UPDATE commission tiers service*/
    updateCommPTier(data) {
        this.appmod = "updateCommissionTier";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    /*DELETE commission plan service*/
    ondeleteTier(id_tier) {
        const apiURL = environment.SERVER + 'deleteCommissionTier';
        let httpHeaders = new HttpHeaders({});
        return this.http.delete(apiURL, { headers: httpHeaders, params: { id_tier: id_tier } });
    }
    PayTransaction(data) {
        this.appmod = "PayTransactionAmount";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
};
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "saveReseller", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "getTariffs", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "getPreferenceService", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "getReseller", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "applyCustomerDFilter", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "commissionTerm", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "onDeleteReseller", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "getsingleReseller", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "updateResellerbyID", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "applyresellerFilter", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "applyCommDetailsFilter", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "saveCommissionPlan", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "getCommissionPlan", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "setDefault", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "updateCommissionPlan", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "ondeleteCommissionPlan", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "saveCommissionTier", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "getCommissionTier", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "updateCommPTier", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "ondeleteTier", null);
__decorate([
    LoaderEnabled()
], ResellerService.prototype, "PayTransaction", null);
ResellerService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], ResellerService);
export { ResellerService };
//# sourceMappingURL=reseller.service.js.map