import { __decorate } from "tslib";
import { Pipe } from '@angular/core';
let FilterListPipe = class FilterListPipe {
    transform(items, searchText, filterMetadata) {
        if (!items)
            return [];
        if (!searchText) {
            filterMetadata.count = items.length;
            return items;
        }
        searchText = searchText.toLowerCase();
        let filteredItems = items.filter(it => {
            return Object.keys(it).some(key => {
                return String(it[key]).toLowerCase().includes(searchText.toLowerCase());
            });
        });
        filterMetadata.count = filteredItems.length;
        return filteredItems;
    }
};
FilterListPipe = __decorate([
    Pipe({
        name: 'filterList'
    })
], FilterListPipe);
export { FilterListPipe };
//# sourceMappingURL=filter-pipe.pipe.js.map