import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { throwError } from 'rxjs';
import { catchError, map } from 'rxjs/operators';
import { LoaderService } from './loader.service';
let LoaderHttpInterceptor = class LoaderHttpInterceptor {
    constructor() { }
    intercept(req, next) {
        LoaderService.showLoader();
        return next.handle(req).pipe(map(res => {
            LoaderService.hideLoader();
            return res;
        }), catchError(error => {
            LoaderService.hideLoader();
            return throwError(error);
        }));
    }
};
LoaderHttpInterceptor = __decorate([
    Injectable()
], LoaderHttpInterceptor);
export { LoaderHttpInterceptor };
//# sourceMappingURL=loader-interceptor.js.map