var LoaderService_1;
import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { map, catchError } from 'rxjs/operators';
let LoaderService = LoaderService_1 = class LoaderService {
    constructor() { }
    get loaderEnabled() {
        return LoaderService_1.loaderEnabled;
    }
    static showLoader() {
        LoaderService_1.loaderEnabled = true;
    }
    static hideLoader() {
        LoaderService_1.loaderEnabled = false;
    }
};
LoaderService.loaderEnabled = false;
LoaderService = LoaderService_1 = __decorate([
    Injectable({
        providedIn: 'root'
    })
], LoaderService);
export { LoaderService };
export function LoaderEnabled() {
    return function (target, propertyKey, descriptor) {
        const original = descriptor.value;
        descriptor.value = function () {
            LoaderService.showLoader();
            return original.apply(this, arguments)
                .pipe(map((res) => {
                setTimeout(() => {
                    LoaderService.hideLoader();
                }, 3000);
                return res;
            }), catchError((err) => {
                LoaderService.hideLoader();
                throw err;
            }));
        };
        return descriptor;
    };
}
//# sourceMappingURL=loader.service.js.map