import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { NotificationType } from "./notification";
let NotificationComponent = class NotificationComponent {
    constructor(_notificationSvc) {
        this._notificationSvc = _notificationSvc;
        this.notifications = [];
    }
    _addNotification(notification) {
        this.notifications.push(notification);
        if (notification.timeout !== 0) {
            setTimeout(() => this.close(notification), notification.timeout);
        }
    }
    ngOnInit() {
        console.log('amit');
        this._subscription = this._notificationSvc.getObservable().subscribe(notification => this._addNotification(notification));
    }
    ngOnDestroy() {
        this._subscription.unsubscribe();
    }
    close(notification) {
        this.notifications = this.notifications.filter(notif => notif.id !== notification.id);
    }
    className(notification) {
        let style;
        switch (notification.type) {
            case NotificationType.success:
                style = 'success';
                break;
            case NotificationType.warning:
                style = 'warning';
                break;
            case NotificationType.error:
                style = 'error';
                break;
            default:
                style = 'info';
                break;
        }
        return style;
    }
};
NotificationComponent = __decorate([
    Component({
        selector: 'app-notification',
        templateUrl: './notification.component.html',
        styleUrls: ['./notification.component.scss']
    })
], NotificationComponent);
export { NotificationComponent };
//# sourceMappingURL=notification.component.js.map