import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { Subject } from "rxjs";
import { Notification, NotificationType } from "./notification";
let NotificationService = class NotificationService {
    constructor() {
        this._subject = new Subject();
        this._idx = 0;
    }
    getObservable() {
        return this._subject.asObservable();
    }
    info(message, timeout = 3000) {
        console.log('info');
        this._subject.next(new Notification(this._idx++, NotificationType.info, message, timeout));
    }
    success(message, timeout = 3000) {
        this._subject.next(new Notification(this._idx++, NotificationType.success, message, timeout));
    }
    warning(message, timeout = 3000) {
        this._subject.next(new Notification(this._idx++, NotificationType.warning, message, timeout));
    }
    error(message, timeout = 0) {
        this._subject.next(new Notification(this._idx++, NotificationType.error, message, timeout));
    }
};
NotificationService = __decorate([
    Injectable()
], NotificationService);
export { NotificationService };
//# sourceMappingURL=notification.service.js.map