import { __decorate } from "tslib";
import { HttpHeaders } from '@angular/common/http';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import { environment } from '../../../environments/environment';
import { APIURL } from '../../app-routing.module';
import { LoaderEnabled } from '../loader/loader.service';
export class AppService {
    constructor(http) {
        this.http = http;
        this.debug = environment.production;
        this.service_data = new BehaviorSubject(null);
        this.solution = this.service_data.asObservable();
        this.frm_label = new BehaviorSubject("List Details");
        this.label = this.frm_label.asObservable();
        this.frm_status = new BehaviorSubject(false);
        this.status = this.frm_status.asObservable();
    }
    push(arg0) {
        throw new Error("Method not implemented.");
    }
    every(arg0) {
        throw new Error("Method not implemented.");
    }
    debug_log(log) {
        if (!this.debug) {
        }
    }
    get Action() {
        return this.action;
    }
    set Action(v) {
        this.action = v;
    }
    set Data(v) {
        this.debug_log("Setting current data");
        this.service_data.next(v);
    }
    changefrm(value) {
        this.frm_status.next(value);
    }
    changelabel(lbl) {
        this.frm_label.next(lbl);
    }
    getReport(data) {
        return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type: "main", filter: JSON.stringify(data) } });
    }
    getOption(data, filter) {
        if (filter == undefined) {
            return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type: data } });
        }
        else {
            return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type: data, filter: JSON.stringify(filter) } });
        }
    }
    getServiceParam(type, filter) {
        if (filter == undefined) {
            if (type != undefined)
                return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type } });
            else
                return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type: "main" } });
        }
        else {
            if (type != undefined)
                return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type, filter: JSON.stringify(filter) } });
            else
                return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type: "main", filter: JSON.stringify(filter) } });
        }
    }
    getOptionParams(url, filter) {
        return this.http.get(APIURL + url, { headers: { "Content-Type": "application/json" }, params: { type: url, data: filter } });
    }
    // public getDownload(data:string):Observable<Blob>{
    //   return this.http.get(APIURL+'download/'+this.appmod, {headers: {"Content-Type": "application/octet-stream"}, params: {type:"download", data:data}, responseType: 'blob', observe: 'body'});
    // }
    getDownload(data, type = 'download') {
        return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/octet-stream" }, params: { type: type, data: data }, responseType: 'blob', observe: 'body' });
    }
    getServiceQParam(type) {
        if (type == undefined) {
            return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type: "main" } });
        }
        else {
            return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type: JSON.stringify(type) } });
        }
    }
    getService(type, filter, where) {
        if (filter == undefined) {
            if (where == undefined) {
                if (type != undefined)
                    return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type } });
                else
                    return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type: "main" } });
            }
            else {
                if (type != undefined)
                    return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type, where } });
                else
                    return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type: "main", where } });
            }
        }
        else {
            if (type != undefined)
                return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type, filter: JSON.stringify(filter) } });
            else
                return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { type: "main", filter: JSON.stringify(filter) } });
        }
    }
    getCalandarService(variables) {
        if (variables != undefined)
            return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { variables: JSON.stringify(variables) } });
    }
    saveService(data, type) {
        if (type != undefined)
            return this.http.post(APIURL + this.appmod, { "data": data }, { headers: { "Content-Type": "application/json" }, params: { type } });
        else
            return this.http.post(APIURL + this.appmod, { "data": data }, { headers: { "Content-Type": "application/json" }, params: { type: "main" } });
    }
    detailService(key, type) {
        if (type != undefined)
            return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { id: key.toString(), type: type, authkey: localStorage.getItem('token') } });
        else
            return this.http.get(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { id: key.toString(), type: "detail", authkey: localStorage.getItem('token') } });
    }
    statusService(data, key, type) {
        if (type != undefined)
            return this.http.post(APIURL + this.appmod + key, { "data": data, "id": key }, { headers: { "Content-Type": "application/json" }, params: { id: key.toString(), type: type } });
        else
            return this.http.post(APIURL + this.appmod + key, { "data": data, "id": key }, { headers: { "Content-Type": "application/json" }, params: { id: key.toString(), type: "status" } });
    }
    updateService(data, key, type) {
        if (key != undefined) {
            if (type != undefined)
                return this.http.put(APIURL + this.appmod, { "data": data }, { headers: { "Content-Type": "application/json" }, params: { id: key.toString(), type: type } });
            else
                return this.http.put(APIURL + this.appmod, { "data": data }, { headers: { "Content-Type": "application/json" }, params: { id: key.toString(), type: "main" } });
        }
        else {
            return this.http.put(APIURL + this.appmod, { "data": data }, { headers: { "Content-Type": "application/json" }, params: { type: type } });
        }
    }
    custupdateService(data, type) {
        if (type != undefined)
            return this.http.put(APIURL + this.appmod, { "data": data }, { headers: { "Content-Type": "application/json" }, params: { type: type } });
        else
            return this.http.put(APIURL + this.appmod, { "data": data }, { headers: { "Content-Type": "application/json" }, params: { type: "main" } });
    }
    updatePassword(data, key) {
        return this.http.put(APIURL + 'custom/changepassword/', { "data": data }, { headers: { "Content-Type": "application/json" }, params: { id: key.toString() } });
    }
    updatePass(data, key) {
        return this.http.put(APIURL + 'custom/changepass/', { "data": data }, { headers: { "Content-Type": "application/json" } });
    }
    deleteService(key, type) {
        if (type != undefined)
            return this.http.delete(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { id: key.toString(), type: type } });
        else
            return this.http.delete(APIURL + this.appmod, { headers: { "Content-Type": "application/json" }, params: { id: key.toString(), type: "main" } });
    }
    getReportwhere(data, where) {
        if (where == undefined)
            return this.http.get(APIURL + "reports/" + data + "/");
        else
            return this.http.get(APIURL + "reports/" + data + "/", { headers: { "Content-Type": "application/json" }, params: { where } });
    }
    PatchService(data, key, type) {
        if (key != undefined) {
            if (type != undefined)
                return this.http.patch(APIURL + this.appmod, { "data": data }, { headers: { "Content-Type": "application/json" }, params: { id: key.toString(), type: type } });
            else
                return this.http.patch(APIURL + this.appmod, { "data": data }, { headers: { "Content-Type": "application/json" }, params: { id: key.toString(), type: "main" } });
        }
        else {
            if (type != undefined)
                return this.http.patch(APIURL + this.appmod, { "data": data }, { headers: { "Content-Type": "application/json" }, params: { type: type } });
            else
                return this.http.patch(APIURL + this.appmod, { "data": data }, { headers: { "Content-Type": "application/json" }, params: { type: "main" } });
        }
    }
    customGetService(url, filter) {
        return this.http.get(APIURL + url, { headers: { "Content-Type": "application/json" }, params: { filter } });
    }
    /** custom services **/
    customGetServiceUI(url, data) {
        return this.http.get(APIURL + url, { headers: { "Content-Type": "application/json" }, params: { type: "main", filter: JSON.stringify(data) } });
    }
    customDeleteServiceUI(url, data) {
        let options = {
            headers: new HttpHeaders({
                'Content-Type': 'application/json'
            }),
            body: {
                data: JSON.stringify(data)
            }
        };
        return this.http.delete(APIURL + url, options);
    }
    Download(data, filename) {
        this.debug_log(APIURL + "download/" + data);
        return this.http.post(APIURL + "download/" + data, { "filename": filename }, { headers: { "Content-Type": "application/octet-stream" }, params: { "filename": filename }, responseType: 'blob', observe: 'body' });
    }
}
__decorate([
    LoaderEnabled()
], AppService.prototype, "updatePassword", null);
__decorate([
    LoaderEnabled()
], AppService.prototype, "updatePass", null);
//# sourceMappingURL=AppService.class.js.map