import { __decorate } from "tslib";
import { Component, Input, Output, EventEmitter } from '@angular/core';
import { HttpRequest, HttpEventType } from '@angular/common/http';
import { of } from 'rxjs/observable/of';
import { catchError, last, map, tap } from 'rxjs/operators';
// import { MatSnackBar } from '@angular/material';
import { environment } from 'src/environments/environment';
//import { SpinnerComponent } from '../../spinner.component';
let UploadviewComponent = class UploadviewComponent {
    constructor(_http, msg) {
        this._http = _http;
        this.msg = msg;
        /** Link text */
        this.text = 'Upload';
        /** Name used in form which will be sent in HTTP request. */
        this.value = '';
        this.field = '';
        this.value1 = '';
        this.field1 = '';
        /** Target URL for file uploading. */
        this.target = environment.SERVER + '/fileupload';
        /** File extension that accepted, same as 'accept' of <input type="file" />.
            By the default, it's set to 'image/*'. */
        this.accept = [];
        /** Allow you to add handler after its completion. Bubble up response text from remote. */
        this.complete = new EventEmitter();
        this.files = [];
        this.state = false;
    }
    ngOnInit() {
    }
    onClick() {
        const fileUpload = document.getElementById('filename');
        fileUpload.onchange = () => {
            // if(this.readFile(fileUpload.files)){
            for (let index = 0; index < fileUpload.files.length; index++) {
                const file = fileUpload.files[index];
                this.files.push({ data: file, state: 'in', inProgress: false, progress: 0, canRetry: false, canCancel: true });
            }
            this.uploadFiles();
        };
        // };
        fileUpload.click();
    }
    cancelFile(file) {
        file.sub.unsubscribe();
        this.removeFileFromArray(file);
    }
    retryFile(file) {
        this.uploadFile(file);
        file.canRetry = false;
    }
    readFile(fileEvent) {
        console.log(fileEvent);
        const file = fileEvent[0];
        console.log('TYPE:' + file.type);
        console.log('SIZE:' + file.size);
        let _status = false;
        if (file.size > 0) {
            if (this.accept.length > 0) {
                this.accept.forEach(ele => {
                    console.log(ele);
                    if (ele == file.type) {
                        _status = true;
                    }
                });
            }
            else {
                _status = true;
            }
            if (!_status) {
                this.msg.open('File type is not allowd. Please upload valid file.', 'Clear', { duration: 3000 });
            }
            return _status;
        }
        else {
            this.msg.open('File have no size', 'Clear', { duration: 3000 });
            return false;
        }
    }
    uploadFile(file) {
        this.state = true;
        const fd = new FormData();
        fd.append("filename", file.data);
        // if(this.field!="")
        console.log("Message Upload data");
        console.log(this.target);
        console.log(this.value1);
        console.log(this.field1);
        fd.append(this.field, JSON.stringify(this.value));
        fd.append("id_user", sessionStorage.getItem('iduser'));
        fd.append("id_campaign", this.field);
        fd.append(this.field1, this.value1);
        const req = new HttpRequest('POST', this.target, fd, {
            reportProgress: true
        });
        console.log(req);
        file.inProgress = true;
        file.sub = this._http.request(req).pipe(map(event => {
            switch (event.type) {
                case HttpEventType.UploadProgress:
                    file.progress = Math.round(event.loaded * 100 / event.total);
                    break;
                case HttpEventType.Response:
                    {
                        console.log("Upload COmpleted in event");
                        return event;
                    }
            }
        }), tap(message => { }), last(), catchError((error) => {
            file.inProgress = false;
            file.canRetry = true;
            return of(`${file.data.name} upload failed.`);
        })).subscribe((event) => {
            console.log("Upload COmpleted on subscriber : " + JSON.stringify(event));
            this.complete.emit(event.body);
            this.state = false;
            /* if (typeof (event) === 'object') {
                  console.log("Upload COmpleted");
                  this.removeFileFromArray(file);
                  this.complete.emit(event.body);
            } */
        });
    }
    uploadFiles() {
        const fileUpload = document.getElementById('filename');
        fileUpload.value = '';
        console.log(this.files);
        this.files.forEach(file => {
            var event = this.uploadFile(file);
        });
    }
    removeFileFromArray(file) {
        const index = this.files.indexOf(file);
        if (index > -1) {
            this.files.splice(index, 1);
        }
    }
};
__decorate([
    Input()
], UploadviewComponent.prototype, "text", void 0);
__decorate([
    Input()
], UploadviewComponent.prototype, "value", void 0);
__decorate([
    Input()
], UploadviewComponent.prototype, "field", void 0);
__decorate([
    Input()
], UploadviewComponent.prototype, "value1", void 0);
__decorate([
    Input()
], UploadviewComponent.prototype, "field1", void 0);
__decorate([
    Input()
], UploadviewComponent.prototype, "target", void 0);
__decorate([
    Input()
], UploadviewComponent.prototype, "accept", void 0);
__decorate([
    Output()
], UploadviewComponent.prototype, "complete", void 0);
UploadviewComponent = __decorate([
    Component({
        selector: 'app-uploadview',
        templateUrl: './uploadview.component.html',
        styleUrls: ['./uploadview.component.css']
    })
], UploadviewComponent);
export { UploadviewComponent };
export class FileUploadModel {
}
//# sourceMappingURL=uploadview.component.js.map