import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let EmailtemplatedetailsComponent = class EmailtemplatedetailsComponent extends AppComponentClass {
    constructor(data, router, fb, route) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.route = route;
        this.page = 1;
        this.count = 0;
        this.tableSize = 25;
        this.tableSizes = [25, 50, 100];
        this.searchText = { count: 0 };
        this.errMessage = "";
        this.resMessage = "";
    }
    ngOnInit() {
        this.data.getEmailTemplates().subscribe(res => {
            if (res.status == 200) {
                this.listdata = res.data;
                $('#basic-datatables').DataTable().clear();
                $('#basic-datatables').DataTable().destroy();
                $.getScript('./assets/table.js');
            }
            else {
                this.errMessage = "";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    onToggle(event, id) {
        this.data.updateStatus(event.checked, id).subscribe(res => {
            console.log(res);
            if (res.status == 201) {
                this.ngOnInit();
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    onDelete(idemail_template) {
        if (confirm("Are you sure you want to delete data!")) {
            this.data.deleteEmailTempalte(idemail_template).subscribe(response => {
                if (response.status == 201) {
                    this.responseMessage = response.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                    this.ngOnInit();
                }
                else {
                    this.errMessage = response.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.errMessage = err.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            });
        }
        else {
            "Cancel!";
        }
    }
};
EmailtemplatedetailsComponent = __decorate([
    Component({
        selector: 'app-emailtemplatedetails',
        templateUrl: './emailtemplatedetails.component.html',
        styleUrls: ['./emailtemplatedetails.component.css']
    })
], EmailtemplatedetailsComponent);
export { EmailtemplatedetailsComponent };
//# sourceMappingURL=emailtemplatedetails.component.js.map