import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let FactorauthenticationdetailsComponent = class FactorauthenticationdetailsComponent extends AppComponentClass {
    constructor(data, router, fb, route) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.route = route;
        this.page = 1;
        this.count = 0;
        this.tableSize = 25;
        this.tableSizes = [25, 50, 100];
        this.searchText = { count: 0 };
        this.errMessage = "";
    }
    ngOnInit() {
        this.data.get2FATemplates().subscribe(res => {
            if (res.status == 200) {
                if (res.data[0]) {
                    this.listdata = res.data;
                    $.getScript('./assets/table.js');
                }
            }
            else {
                this.errMessage = "";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event.length;
    }
    onDelete(id2fa_template) {
        if (confirm("Are you sure you want to delete data!")) {
            this.data.delete2FATemplate(id2fa_template).subscribe(response => {
                if (response.status == 201) {
                    this.responseMessage = response.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                    this.ngOnInit();
                }
                else {
                    this.errMessage = response.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.errMessage = err.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            });
        }
        else {
            "Cancel!";
        }
    }
};
FactorauthenticationdetailsComponent = __decorate([
    Component({
        selector: 'app-factorauthenticationdetails',
        templateUrl: './factorauthenticationdetails.component.html',
        styleUrls: ['./factorauthenticationdetails.component.css']
    })
], FactorauthenticationdetailsComponent);
export { FactorauthenticationdetailsComponent };
//# sourceMappingURL=factorauthenticationdetails.component.js.map