import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from 'src/app/shared/service/AppService.class';
import { environment } from 'src/environments/environment';
import { LoaderEnabled } from '../shared/loader/loader.service';
let SignuptemplateService = class SignuptemplateService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
    }
    getEmailTemplate(idemail_template) {
        let apiUrl = environment.SERVER + 'email-template';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders, params: { idemail_template: idemail_template } });
    }
    getEmailTemplates() {
        let apiUrl = environment.SERVER + 'email-templates';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders });
    }
    emailTemplate(data) {
        let apiUrl = environment.SERVER + 'email-template';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiUrl, data, { headers: httpHeaders });
    }
    deleteEmailTempalte(idemail_template) {
        let apiUrl = environment.SERVER + 'email-template';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.delete(apiUrl, { headers: httpHeaders, params: { idemail_template: idemail_template } });
    }
    updateStatus(data, id) {
        let data1 = { status: data, id: id };
        let apiUrl = environment.SERVER + 'email-template-status';
        let httpheaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.put(apiUrl, data1, { headers: httpheaders });
    }
    updateEmailTemplate(data) {
        let apiUrl = environment.SERVER + 'email-template';
        let httpheaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.put(apiUrl, data, { headers: httpheaders });
    }
    getSmsTemplate(idsms_template) {
        let apiUrl = environment.SERVER + 'sms-template';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders, params: { idsms_template: idsms_template } });
    }
    getSmsTemplates() {
        let apiUrl = environment.SERVER + 'sms-templates';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders });
    }
    updateStatusSMS(data, id) {
        let data1 = { status: data, id: id };
        let apiUrl = environment.SERVER + 'sms-template-status';
        let httpheaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.put(apiUrl, data1, { headers: httpheaders });
    }
    updateSmsTemplate(data) {
        let apiUrl = environment.SERVER + "sms-template";
        let httpheaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.put(apiUrl, data, { headers: httpheaders });
    }
    twofaTemaplate(data) {
        let apiUrl = environment.SERVER + '2fa-template';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiUrl, data, { headers: httpHeaders });
    }
    get2FATemplate(id2fa_template) {
        let apiUrl = environment.SERVER + '2fa-template';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders, params: { id2fa_template: id2fa_template } });
    }
    get2FATemplates() {
        let apiUrl = environment.SERVER + '2fa-templates';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders });
    }
    update2FATemplate(data) {
        let apiUrl = environment.SERVER + '2fa-template';
        let httpheaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.put(apiUrl, data, { headers: httpheaders });
    }
    delete2FATemplate(id2fa_template) {
        let apiUrl = environment.SERVER + '2fa-template';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.delete(apiUrl, { headers: httpHeaders, params: { id2fa_template: id2fa_template } });
    }
    update_mms(mmsTemplateForm, file) {
        const formData = new FormData();
        formData.append("data", JSON.stringify(mmsTemplateForm));
        formData.append("ATTACHMENT", file);
        const apiURL = environment.SERVER + 'update_mms';
        let httpHeaders = new HttpHeaders({});
        return this.http.put(apiURL, formData, { headers: httpHeaders });
    }
    // @LoaderEnabled()
    // postmms(mmsTemplate: any, file: File | any): Observable<any> {
    //   const formData = new FormData();
    //   formData.append("ATTACHMENT", file);
    //   formData.append("data", JSON.stringify(mmsTemplate));
    //   const apiURL = environment.SERVER + 'post_mms';
    //   let httpHeaders = new HttpHeaders({
    //   });
    //   return this.http.post(apiURL, formData, { headers: httpHeaders });
    // }
    /* @LoaderEnabled()
    postmms(mmsTemplate: any, file: File | any): Observable<any> {
      const formData = new FormData();
      formData.append("ATTACHMENT", file);
      formData.append("data", JSON.stringify(mmsTemplate));
      const apiURL = environment.SERVER + 'mms';
      let httpHeaders = new HttpHeaders({
      });
      return this.http.post(apiURL, formData, { headers: httpHeaders });
    } */
    postmms(data) {
        let apiUrl = environment.SERVER + 'mmsbymedia';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiUrl, data, { headers: httpHeaders });
    }
    getmms() {
        let apiUrl = environment.SERVER + 'getmms';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders });
    }
    getmms_id(idmms_template) {
        let apiUrl = environment.SERVER + 'getmms_id';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders, params: { idmms_template: idmms_template } });
    }
    delete_mms(idmms_template) {
        let apiUrl = environment.SERVER + 'delete_mms';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.delete(apiUrl, { headers: httpHeaders, params: { idmms_template: idmms_template } });
    }
    sendMMSTemplate(data) {
        let tmp = this.appmod;
        this.appmod = 'mms';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    getMmsMediaFiles() {
        let apiUrl = environment.SERVER + 'listMmsMedia';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders });
    }
    getAllMmsMediaFiles() {
        let apiUrl = environment.SERVER + 'listallmmsmedia';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders });
    }
};
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "getEmailTemplate", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "getEmailTemplates", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "emailTemplate", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "deleteEmailTempalte", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "updateStatus", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "updateEmailTemplate", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "getSmsTemplate", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "getSmsTemplates", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "updateStatusSMS", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "updateSmsTemplate", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "twofaTemaplate", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "get2FATemplate", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "get2FATemplates", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "update2FATemplate", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "delete2FATemplate", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "update_mms", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "postmms", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "getmms", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "getmms_id", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "delete_mms", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "sendMMSTemplate", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "getMmsMediaFiles", null);
__decorate([
    LoaderEnabled()
], SignuptemplateService.prototype, "getAllMmsMediaFiles", null);
SignuptemplateService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], SignuptemplateService);
export { SignuptemplateService };
//# sourceMappingURL=signuptemplate.service.js.map