import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let SmstemplateComponent = class SmstemplateComponent extends AppComponentClass {
    constructor(data, router, fb, route) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.route = route;
        this.htmlContent = '';
        this.message = '';
        this.errMessage = '';
        this.smsTemplate = {};
        this.responseMessage = '';
        this.submitted = false;
        this.config = {
            editable: true,
            spellcheck: true,
            height: '15rem',
            minHeight: '5rem',
            placeholder: 'Enter text here...',
            translate: 'no',
            defaultParagraphSeparator: 'p',
            defaultFontName: 'Arial',
            toolbarHiddenButtons: [
                ['bold']
            ],
            customClasses: [
                {
                    name: "quote",
                    class: "quote",
                },
                {
                    name: 'redText',
                    class: 'redText'
                },
                {
                    name: "titleText",
                    class: "titleText",
                    tag: "h1",
                },
            ]
        };
        this.route.paramMap.subscribe((params) => {
            this.idSMSTemplate = params.get('id');
            if (this.idSMSTemplate) {
                this.data.getSmsTemplate(this.idSMSTemplate).subscribe(res => {
                    if (res.status == 200) {
                        if (res.data.length > 0) {
                            this.smsTemplate = res.data[0];
                            this.smsTemplateForm.patchValue({
                                idsms_template: this.smsTemplate.idsms_template,
                                name: this.smsTemplate.name,
                                type: this.smsTemplate.type,
                                body: this.smsTemplate.body
                            });
                        }
                    }
                    else {
                        this.errMessage = res.message;
                        setTimeout(() => {
                            this.errMessage = "";
                        }, 5000);
                    }
                });
            }
        });
    }
    ngOnInit() {
        this.smsTemplateForm = this.fb.group({
            idsms_template: [''],
            type: ['', [Validators.required]],
            name: ['', [Validators.required]],
            body: ['', [Validators.required]],
        });
    }
    click1(event) {
        this.message = this.smsTemplateForm.value.body + event.target.value;
        this.smsTemplateForm.patchValue({
            body: this.message
        });
    }
    click2(event) {
        this.message = this.smsTemplateForm.value.body + event.target.value;
        this.smsTemplateForm.patchValue({
            body: this.message
        });
    }
    click3(event) {
        this.message = this.smsTemplateForm.value.body + event.target.value;
        this.smsTemplateForm.patchValue({
            body: this.message
        });
    }
    click4(event) {
        this.message = this.smsTemplateForm.value.body + event.target.value;
        this.smsTemplateForm.patchValue({
            body: this.message
        });
    }
    click5(event) {
        this.message = this.smsTemplateForm.value.body + event.target.value;
        this.smsTemplateForm.patchValue({
            body: this.message
        });
    }
    onSubmit() {
        this.submitted = true;
        console.log(this.smsTemplateForm.value);
        this.data.updateSmsTemplate(this.smsTemplateForm.value).subscribe(res => {
            if (res.status == 201) {
                this.responseMessage = res.message;
                this.router.navigateByUrl('/signup-template/sms-template-details');
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    onEdit(data) { }
};
SmstemplateComponent = __decorate([
    Component({
        selector: 'app-smstemplate',
        templateUrl: './smstemplate.component.html',
        styleUrls: ['./smstemplate.component.css']
    })
], SmstemplateComponent);
export { SmstemplateComponent };
//# sourceMappingURL=smstemplate.component.js.map