import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { FormControl, Validators } from '@angular/forms';
import { Observable } from 'rxjs';
let FactorauthenticationdetailsComponent = class FactorauthenticationdetailsComponent {
    constructor(data, router, fb, route) {
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.route = route;
        this.page = 1;
        this.listdata = [];
        this.count = 0;
        this.tableSize = 25;
        this.tableSizes = [25, 50, 100];
        this.searchText = { count: 0 };
        this.isOtpEnable = false;
        this.tick = 1000;
        this.isCounter = false;
        this.submitted = false;
        this.pShow = false;
    }
    ngOnInit() {
        this.otpForm = this.fb.group({
            FROM: new FormControl('', [Validators.required, Validators.minLength(10)]),
            TO: new FormControl('', [Validators.required, Validators.minLength(10)]),
            template: new FormControl('', [Validators.required]),
            otp: new FormControl('')
        });
        this.get2FATemData();
    }
    get2FATemData() {
        this.data.get2FATemplates('sms').subscribe(res => {
            if (res.status == 200) {
                this.listdata = res.data;
                $('#basic-datatables').DataTable().clear();
                $('#basic-datatables').DataTable().destroy();
                $.getScript('./assets/table.js');
                this.listdata.forEach(element => {
                    element.pShow = false;
                    element.pswd = "password";
                });
            }
            else {
                this.errMessage = "";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    onClode() {
        this.otpForm.reset();
        //location.reload();
        this.submitted = false;
    }
    onGenerateOtp() {
        this.submitted = true;
        if (this.otpForm.value.template == 'null') {
            this.errMessage = "There is no Template Key for this Template!";
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
            return false;
        }
        if (this.otpForm.invalid) {
            return false;
        }
        else {
            this.data.SendOtpBySMS(this.otpForm.value).subscribe(res => {
                if (res.status == 200) {
                    this.otpForm.patchValue({ template: res.result[0].session_id });
                    this.counter = 120;
                    this.isCounter = false;
                    this.isOtpEnable = true;
                    this.countDown = Observable.timer(0, this.tick)
                        .take(this.counter)
                        .map(() => {
                        if (this.counter <= 1) {
                            this.isOtpEnable = true;
                            this.isCounter = true;
                        }
                        return --this.counter;
                    });
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                }
                else {
                    this.isOtpEnable = false;
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            });
        }
    }
    onDelete(id2fa_template) {
        if (confirm("Are you sure you want to delete data!")) {
            this.data.delete2FATemplate(id2fa_template).subscribe(response => {
                if (response.status == 201) {
                    this.responseMessage = response.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                    this.get2FATemData();
                    // this.ngOnInit();
                }
                else {
                    this.errMessage = response.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.errMessage = err.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            });
        }
        else {
            "Cancel!";
        }
    }
    verifyOtp() {
        this.otpForm.value.SessionId = this.otpForm.value.template;
        this.otpForm.value.OTP = this.otpForm.value.otp;
        this.data.verifySMSOtp(this.otpForm.value).subscribe(res => {
            if (res.status == 200) {
                this.resetModal();
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    resetModal() {
        $("#exampleModal").hide();
        $(".modal-backdrop").remove();
        this.isOtpEnable = false;
        this.otpForm.reset();
        this.submitted = false;
        this.otpForm.get('template').setValue('');
    }
    setDefault(id2fa_template) {
        if (confirm("Are You Sure ?")) {
            this.data.setDefaultTemplate(id2fa_template).subscribe(res => {
                if (res.status == 201) {
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                    this.ngOnInit();
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.errMessage = err.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            });
        }
        else {
            return;
        }
    }
    default() {
        this.listdata.find(element => {
            if (element.default == '1') {
                this.template = element.template_key;
            }
        });
    }
    textMessageFunc(msgText) {
        this.responseMessage = "Copied to Clipboard";
        setTimeout(() => {
            this.responseMessage = "";
        }, 5000);
    }
    keyToggle(id) {
        this.listdata.forEach(element => {
            if (element.template_key == id) {
                if (element.pswd == 'password') {
                    element.pswd = 'text';
                    element.pShow = true;
                }
                else {
                    element.pswd = 'password';
                    element.pShow = false;
                }
            }
        });
    }
};
FactorauthenticationdetailsComponent = __decorate([
    Component({
        selector: 'app-factorauthenticationdetails',
        templateUrl: './factorauthenticationdetails.component.html',
        styleUrls: ['./factorauthenticationdetails.component.css']
    })
], FactorauthenticationdetailsComponent);
export { FactorauthenticationdetailsComponent };
//# sourceMappingURL=factorauthenticationdetails.component.js.map