import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { FormControl, Validators } from '@angular/forms';
import { Observable } from 'rxjs';
import 'rxjs/add/observable/timer';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/take';
let FavoicedetailsComponent = class FavoicedetailsComponent {
    constructor(data, router, fb, route) {
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.route = route;
        this.page = 1;
        this.count = 0;
        this.tableSize = 25;
        this.tableSizes = [25, 50, 100];
        this.searchText = { count: 0 };
        this.isOtpEnable = false;
        this.tick = 1000;
        this.isCounter = false;
        this.submitted = false;
    }
    ngOnInit() {
        this.otpForm = this.fb.group({
            FROM: new FormControl('', [Validators.required, Validators.minLength(10)]),
            TO: new FormControl('', [Validators.required, Validators.minLength(10)]),
            template: new FormControl('', [Validators.required]),
            otp: new FormControl('')
        });
        this.get2FAvoice();
    }
    get2FAvoice() {
        this.data.get2FATemplates('voice').subscribe(res => {
            if (res.status == 200) {
                this.listdata = res.data;
                $('#basic-datatables').DataTable().clear();
                $('#basic-datatables').DataTable().destroy();
                $.getScript('./assets/table.js');
            }
            else {
                this.errMessage = "";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    onDelete(id2fa_template) {
        if (confirm("Are you sure you want to delete data!")) {
            this.data.delete2FATemplate(id2fa_template).subscribe(response => {
                if (response.status == 201) {
                    this.responseMessage = response.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                    this.get2FAvoice();
                    //this.ngOnInit();
                }
                else {
                    this.errMessage = response.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.errMessage = err.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            });
        }
        else {
            "Cancel!";
        }
    }
    // onGenerateOtp() {
    //   this.data.SendOtpByCall(this.otpForm.value).subscribe(res => {
    //     if (res.status == 201) {
    //       this.counter = 30;
    //       this.isCounter = false;
    //       this.isOtpEnable = true;
    //       this.countDown = Observable.timer(0, this.tick)
    //         .take(this.counter)
    //         .map(() => {
    //           if (this.counter <= 1) {
    //             this.isOtpEnable = true;
    //             this.isCounter = true;
    //           }
    //           return --this.counter
    //         });
    //       this.responseMessage = res.message;
    //       setTimeout(() => {
    //         this.responseMessage = "";
    //       }, 5000);
    //     }
    //     else {
    //       this.isOtpEnable = false;
    //       this.errMessage = res.message;
    //       setTimeout(() => {
    //         this.errMessage = "";
    //       }, 5000);
    //     }
    //   });
    // }
    onGenerateOtp() {
        this.submitted = true;
        if (this.otpForm.value.template == 'null') {
            this.errMessage = "There is no Template Key for this Template!";
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
            return false;
        }
        if (this.otpForm.invalid) {
            return false;
        }
        else {
            this.data.SendOtpByCall(this.otpForm.value).subscribe(res => {
                if (res.status == 201) {
                    this.counter = 30;
                    this.isCounter = false;
                    this.isOtpEnable = true;
                    this.countDown = Observable.timer(0, this.tick)
                        .take(this.counter)
                        .map(() => {
                        if (this.counter <= 1) {
                            this.isOtpEnable = true;
                            this.isCounter = true;
                        }
                        return --this.counter;
                    });
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                }
                else {
                    this.isOtpEnable = false;
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            });
        }
    }
    verifyOtp() {
        this.data.verifyOtp(this.otpForm.value).subscribe(res => {
            if (res.status == 200) {
                this.resetModal();
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    resetModal() {
        $("#exampleModal").hide();
        $(".modal-backdrop").remove();
        this.submitted = false;
        this.isOtpEnable = false;
        this.otpForm.reset();
        this.otpForm.get('template').setValue('');
    }
    onClode() {
        this.otpForm.reset();
        //  location.reload();
        this.submitted = false;
    }
};
FavoicedetailsComponent = __decorate([
    Component({
        selector: 'app-favoicedetails',
        templateUrl: './favoicedetails.component.html',
        styleUrls: ['./favoicedetails.component.css']
    })
], FavoicedetailsComponent);
export { FavoicedetailsComponent };
//# sourceMappingURL=favoicedetails.component.js.map