import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { inboundsmsForm } from '../sms.class';
let InboundsmsComponent = class InboundsmsComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.p = 1;
        this.page = 1;
        this.count = 0;
        this.tableSize = 5;
        this.tableSizes = [5, 9, 12];
        this.submitted = false;
    }
    ngOnInit() {
        this.data.get_smsconf().subscribe((result) => {
            this.header = result[0].headers_details,
                this.rowdata = result[0].product_details;
            this.label2 = result[2];
            console.log(result);
        });
        // @subscribing form group
        this.data.solution.subscribe(res => {
            if (res != null) {
                console.log("Update data " + JSON.stringify(res));
                this.cdata = new inboundsmsForm(res);
                this.keyfield = res.id;
                this.inboundsmsForm = this.cdata.makeform(this.fb);
            }
            else {
                console.log("adding data " + JSON.stringify(res));
                this.cdata = new inboundsmsForm(null);
                this.keyfield = -1;
                this.inboundsmsForm = this.cdata.makeform(this.fb);
            }
        });
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event;
    }
    onSubmit() {
        console.log("event task save");
        this.submitted = true;
        if (this.inboundsmsForm.invalid) {
            return false;
        }
        else {
            console.log("submit data::", this.cdata);
            if (this.cdata.saveForm(this.inboundsmsForm)) {
                console.log("Submitted data ::\n" + JSON.stringify(this.cdata));
                if (this.keyfield == -1) {
                    this.data.saveData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
                else {
                    this.data.updateData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
            }
        }
    }
};
InboundsmsComponent = __decorate([
    Component({
        selector: 'app-inboundsms',
        templateUrl: './inboundsms.component.html',
        styleUrls: ['./inboundsms.component.css']
    })
], InboundsmsComponent);
export { InboundsmsComponent };
//# sourceMappingURL=inboundsms.component.js.map