import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { ipForm } from '../sms.class';
let IpWhitelistsComponent = class IpWhitelistsComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.p = 1;
        this.page = 1;
        this.count = 0;
        this.tableSize = 5;
        this.tableSizes = [5, 9, 12];
        this.show = false;
        this.show1 = false;
        this.buttonName = "Add";
        this.submitted = false;
        this.heading = [];
        this.main_heading = "";
    }
    ngOnInit() {
        // @subscribing form group
        this.data.solution.subscribe(res => {
            if (res != null) {
                console.log("Update data " + JSON.stringify(res));
                this.cdata = new ipForm(res);
                this.keyfield = res.id;
                this.ipForm = this.cdata.makeform(this.fb);
            }
            else {
                console.log("adding data " + JSON.stringify(res));
                this.cdata = new ipForm(null);
                this.keyfield = -1;
                this.ipForm = this.cdata.makeform(this.fb);
            }
        });
        this.data.get_ipwhitelist().subscribe((result) => {
            this.header = result[0].headers_details;
            this.rowdata = result[0].ip_details;
            this.label = result[1];
            console.log(result);
        });
    }
    click() {
        this.show1 = !this.show1;
    }
    toggle() {
        this.show = !this.show;
        // CHANGE THE NAME OF THE BUTTON.
        if (this.show)
            this.buttonName = "Close";
        else
            this.buttonName = "Add";
    }
    // @to edit the record
    editRow(rowdata) {
        this.show = true;
        this.Edit(rowdata);
    }
    // @to save/update form data
    onSubmit() {
        console.log("event task save");
        this.submitted = true;
        if (this.ipForm.invalid) {
            return false;
        }
        else {
            console.log("submit data::", this.cdata);
            if (this.cdata.saveForm(this.ipForm)) {
                console.log("Submitted data ::\n" + JSON.stringify(this.cdata));
                if (this.keyfield == -1) {
                    this.data.saveData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
                else {
                    this.data.updateData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
            }
        }
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event;
    }
};
IpWhitelistsComponent = __decorate([
    Component({
        selector: 'app-ip-whitelists',
        templateUrl: './ip-whitelists.component.html',
        styleUrls: ['./ip-whitelists.component.css']
    })
], IpWhitelistsComponent);
export { IpWhitelistsComponent };
//# sourceMappingURL=ip-whitelists.component.js.map