import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from 'src/app/shared/service/AppService.class';
import { LoaderEnabled } from '../shared/loader/loader.service';
import { environment } from 'src/environments/environment';
let SmsService = class SmsService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
    }
    sendSMS(data) {
        const apiURL = environment.SERVER + 'sms';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiURL, data, { headers: httpHeaders });
    }
    saveData(data) {
        let tmp = this.appmod;
        this.appmod = 'mdrsearch';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    updateData(data) {
        let tmp = this.appmod;
        this.appmod = 'custom/saveheadermapping';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    getMDRFilter(data) {
        this.appmod = "getmdrfilter";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    getAllMmsMediaFiles() {
        let apiUrl = environment.SERVER + 'listallmmsmedia';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders });
    }
    summerySmsmdrForm(data) {
        this.appmod = "summerysmsmdrfilter";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    getMMSMDR(data) {
        this.appmod = "getmmsmdrfilter";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    summeryCdrForm(data) {
        this.appmod = "summerymmsmdrfilter";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    twofaTemaplate(data) {
        let apiUrl = environment.SERVER + '2fa-template';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiUrl, data, { headers: httpHeaders });
    }
    get2FATemplate(id2fa_template) {
        let apiUrl = environment.SERVER + '2fa-template';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders, params: { id2fa_template: id2fa_template } });
    }
    get2FATemplates(type) {
        let apiUrl = environment.SERVER + '2fa-templates';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders, params: { type } });
    }
    update2FATemplate(data) {
        let apiUrl = environment.SERVER + '2fa-template';
        let httpheaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.put(apiUrl, data, { headers: httpheaders });
    }
    delete2FATemplate(id2fa_template) {
        let apiUrl = environment.SERVER + '2fa-template';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.delete(apiUrl, { headers: httpHeaders, params: { id2fa_template: id2fa_template } });
    }
    SendOtpBySMS(data) {
        let tmp = this.appmod;
        this.appmod = 'sendotpbysms';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    verifySMSOtp(data) {
        let apiUrl = environment.SERVER + 'verifyotp';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiUrl, data, { headers: httpHeaders });
    }
    SendOtpByCall(data) {
        let apiUrl = environment.SERVER + 'sendotpbycall';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiUrl, data, { headers: httpHeaders });
    }
    verifyOtp(data) {
        let apiUrl = environment.SERVER + 'verify-call-otp';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiUrl, data, { headers: httpHeaders });
    }
    setDefaultTemplate(data) {
        const apiURL = environment.SERVER + '2fa-defaultTemplate';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.put(apiURL, { data }, { headers: httpHeaders });
    }
    get_mdrs() {
        return this.http.get('./assets/mdrs.json');
    }
    get_smsconf() {
        return this.http.get('./assets/smsconf.json');
    }
    get_testmessage() {
        return this.http.get('./assets/testmessage.json');
    }
    get_ipwhitelist() {
        return this.http.get('./assets/ipwhitelist.json');
    }
    deleteMmsMedia(mediaID) {
        let apiUrl = environment.SERVER + 'deletemmsmedia';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.delete(apiUrl, { headers: httpHeaders, params: { mediaID: mediaID } });
    }
    uploadMmsMediaFile(media, file) {
        const formData = new FormData();
        formData.append("UPLOAD", file);
        formData.append("data", JSON.stringify(media));
        const apiURL = environment.SERVER + 'uploadmmsmedia';
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, formData, { headers: httpHeaders });
    }
    getMmsMediaFiles() {
        let apiUrl = environment.SERVER + 'listmmsmedia';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiUrl, { headers: httpHeaders });
    }
};
__decorate([
    LoaderEnabled()
], SmsService.prototype, "sendSMS", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "saveData", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "getMDRFilter", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "getAllMmsMediaFiles", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "summerySmsmdrForm", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "getMMSMDR", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "summeryCdrForm", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "twofaTemaplate", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "get2FATemplate", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "get2FATemplates", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "update2FATemplate", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "delete2FATemplate", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "SendOtpBySMS", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "verifySMSOtp", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "SendOtpByCall", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "verifyOtp", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "setDefaultTemplate", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "deleteMmsMedia", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "uploadMmsMediaFile", null);
__decorate([
    LoaderEnabled()
], SmsService.prototype, "getMmsMediaFiles", null);
SmsService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], SmsService);
export { SmsService };
//# sourceMappingURL=sms.service.js.map