import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { supplierForm } from '../supplier.class';
let SupplierComponent = class SupplierComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.showMsg = false;
        this.p = 1;
        // defaultSelect : any = 1;
        this.page = 1;
        this.count = 0;
        this.tableSize = 5;
        this.tableSizes = [5, 9, 12];
        this.show = false;
        this.buttonName = "Add";
        this.submitted = false;
        this.fileToUpload = null;
    }
    ngOnInit() {
        // @subscribing form group
        this.data.solution.subscribe(res => {
            if (res != null) {
                console.log("Update data " + JSON.stringify(res));
                this.cdata = new supplierForm(res);
                this.keyfield = res.id;
                this.supplierForm = this.cdata.makeform(this.fb);
            }
            else {
                console.log("adding data " + JSON.stringify(res));
                this.cdata = new supplierForm(null);
                this.keyfield = -1;
                this.supplierForm = this.cdata.makeform(this.fb);
            }
        });
        this.data.getsuppiler().subscribe((result) => {
            this.listdata = result[1];
            console.log(result);
        });
        this.data.getrecord().subscribe((result) => {
            this.record = result[0].headers_details;
            this.list = result[0].profile_details;
            console.log(this.list);
        });
    }
    downloadMyFile() {
        this.data
            .download('./assets/sample-csv/ratelist-sample.csv')
            .subscribe(blob => {
            const a = document.createElement('a');
            const objectUrl = URL.createObjectURL(blob);
            a.href = objectUrl;
            a.download = 'ratelist-sample.csv';
            a.click();
            URL.revokeObjectURL(objectUrl);
        });
    }
    saveFile(event, type) {
        this.data.saveFile(event, type).subscribe(res => {
            console.log(res);
        }, error => {
            console.log(error);
        });
    }
    toggle() {
        this.show = !this.show;
        // CHANGE THE NAME OF THE BUTTON.
        if (this.show)
            this.buttonName = "Close";
        else
            this.buttonName = "Add";
    }
    // @to edit the record
    editRow(rowdata) {
        this.show = true;
        this.Edit(rowdata);
    }
    get f() { return this.supplierForm.controls; }
    ;
    // @to save/update form data
    onSubmit() {
        console.log("event task save");
        this.submitted = true;
        if (this.supplierForm.invalid) {
            return false;
        }
        else {
            console.log("submit data::", this.cdata);
            if (this.cdata.saveForm(this.supplierForm)) {
                console.log("Submitted data ::\n" + JSON.stringify(this.cdata));
                if (this.keyfield == -1) {
                    this.data.saveData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                    setTimeout(() => { alert('Data Successfully Save!'); }, 1000);
                    // this.show = true
                }
                else {
                    this.data.updateData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
            }
        }
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event;
    }
};
SupplierComponent = __decorate([
    Component({
        selector: 'app-supplier',
        templateUrl: './supplier.component.html',
        styleUrls: ['./supplier.component.css']
    })
], SupplierComponent);
export { SupplierComponent };
//# sourceMappingURL=supplier.component.js.map