import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
let AddServiceComponent = class AddServiceComponent {
    constructor(data, tariffService, router, fb, route) {
        this.data = data;
        this.tariffService = tariffService;
        this.router = router;
        this.fb = fb;
        this.route = route;
        this.submitted = false;
        this.preferenceDID = [];
        this.preferenceSMS = [];
        this.preferenceVoice = [];
        this.voiceSupplier = [];
        this.smsSupplier = [];
        this.didSupplier = [];
        this.status = false;
        this.idservice = "";
        this.didPreference = [];
        this.smsPreference = [];
        this.voicePreference = [];
    }
    ngOnInit() {
        this.preferenceForm = this.fb.group({
            idservice: [''],
            name: ['', [Validators.required, Validators.minLength(3)]],
            description: ['', [Validators.required, Validators.minLength(10)]],
        });
        this.didForm = this.fb.group({
            preference1: ['', [Validators.required]],
            preference2: [''],
            preference3: [''],
        });
        this.smsForm = this.fb.group({
            preference1: ['', [Validators.required]],
        });
        this.voiceForm = this.fb.group({
            preference1: ['', [Validators.required]],
        });
        this.addDidProvider();
        this.data.getpreference().subscribe((result) => {
            this.listdata = result;
        });
        this.route.paramMap.subscribe((params) => {
            this.idservice = params.get("id");
            if (this.idservice) {
                this.tariffService.getSingleService({ idservice: this.idservice }).subscribe(res => {
                    this.preferenceForm.patchValue({
                        idservice: this.idservice,
                        name: res.data.name,
                        description: res.data.description
                    });
                }, err => {
                    console.log(err.message);
                });
                this.data.getPreference({ type: "did", idservice: this.idservice }).subscribe(result => {
                    if (result.data.length > 0) {
                        this.didPreference = result.data;
                        this.didForm.patchValue({
                            preference1: this.didPreference[0].idsupplier,
                        });
                        if (this.didPreference[1]) {
                            this.didForm.patchValue({
                                preference2: this.didPreference[1].idsupplier,
                            });
                        }
                        if (this.didPreference[2]) {
                            this.didForm.patchValue({
                                preference3: this.didPreference[2].idsupplier,
                            });
                        }
                        for (let i = 0; i <= this.didPreference.length; i++) {
                            if (this.didPreference[i]) {
                                this.preferenceDID[i] = { index: i, idsupplier: this.didPreference[i].idsupplier, idservice: this.idservice, priority: this.didPreference[i].priority, type: this.didPreference[i].type, idpreferemce: this.didPreference[i].idpreference };
                            }
                        }
                    }
                    this.didProvider();
                }, error => {
                    this.responseMessage = error.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                });
                this.data.getPreference({ type: "sms", idservice: this.idservice }).subscribe(result => {
                    if (result.data.length > 0) {
                        this.smsPreference = result.data;
                        this.smsForm.patchValue({
                            preference1: this.smsPreference[0].idsupplier
                        });
                    }
                }, error => {
                    this.responseMessage = error.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                });
                this.data.getPreference({ type: "voice", idservice: this.idservice }).subscribe(result => {
                    if (result.data.length > 0) {
                        this.voicePreference = result.data;
                        this.voiceForm.patchValue({
                            preference1: this.voicePreference[0].idsupplier
                        });
                    }
                }, error => {
                    this.responseMessage = error.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                });
            }
        });
        this.data.getSuppliers().subscribe(supplier => {
            this.suppliers = supplier.data;
            supplier.data.forEach(element => {
                if (element.sms == "yes") {
                    this.smsSupplier.push(element);
                }
                if (element.voice == "yes") {
                    this.voiceSupplier.push(element);
                }
                if (element.did == "yes") {
                    this.didSupplier.push(element);
                }
            });
        });
    }
    addPreference() {
        this.submitted = false;
        if (this.preferenceForm.invalid) {
            return;
        }
        else {
            if (this.idservice) {
                this.tariffService.updatePreferenceService(this.preferenceForm.value).subscribe(res => {
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                }, err => {
                    this.responseMessage = err.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                });
            }
            else {
                this.tariffService.savePreferenceService(this.preferenceForm.value).subscribe(res => {
                    this.idservice = res.data.insertId;
                    sessionStorage.setItem("insertId", this.idservice);
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                }, err => {
                    this.responseMessage = err.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                });
            }
        }
    }
    // onPreference(e: any, type: any) {
    //   this.didSupplier.forEach(element => {
    //     if(element.selected =='true'){
    //       element.selected = "false";
    //     }
    //     if (e.target[e.target.options.selectedIndex].value == element.key) {
    //       element.selected = "true";
    //     }
    //   });
    //   if (this.idservice == "") {
    //     this.idservice = sessionStorage.getItem("insertId");
    //   }
    //   let index = e.target.id;
    //   this.preferenceDID[index] = { index: index, "idsupplier": e.target.value, "idservice": this.idservice, "priority": index, type: type };
    // }
    // For Add Preference
    addDidProvider() {
        this.didForm.get("preference2").disable();
        this.didForm.get("preference3").disable();
    }
    // For Edit Preference
    didProvider() {
        this.data1 = '';
        this.data2 = '';
        this.data3 = '';
        if (this.didPreference[0]) {
            this.data1 = this.didPreference[0].idsupplier !== 'undefined' || '' ? this.didPreference[0].idsupplier : '';
        }
        if (this.didPreference[1]) {
            this.data2 = this.didPreference[1].idsupplier !== 'undefined' || '' ? this.didPreference[1].idsupplier : '';
        }
        if (this.data3 = this.didPreference[2]) {
            this.data3 = this.didPreference[2].idsupplier !== 'undefined' || '' ? this.didPreference[2].idsupplier : '';
        }
        if (this.data1 == '' || this.data1 == undefined) {
            this.didForm.get("preference2").disable();
        }
        else {
            this.didForm.get("preference2").enable();
        }
        if (this.data2 == '' || this.data2 == undefined) {
            this.didForm.get("preference3").disable();
        }
        else {
            this.didForm.get("preference3").enable();
        }
    }
    // preference 1
    onPreference1(e, type) {
        if (e.target.value != '') {
            this.data1 = e.target.value;
            $(".select2 option[value='" + e.target.value + "']").prop('disabled', true);
            $(".select2 option[value!='" + e.target.value + "']").prop('disabled', false);
            $(".select3 option[value='" + e.target.value + "']").prop('disabled', true);
            $(".select3 option[value!='" + e.target.value + "']").prop('disabled', false);
            if (this.data3 != '' || this.data2 != '') {
                $(".select2 option[value='" + this.data3 + "']").prop('disabled', true);
                $(".select3 option[value='" + this.data2 + "']").prop('disabled', true);
            }
            this.didForm.get("preference2").enable();
            if (this.idservice == "") {
                this.idservice = sessionStorage.getItem("insertId");
            }
            let index = e.target.id;
            this.preferenceDID[index] = { index: index, "idsupplier": e.target.value, "idservice": this.idservice, "priority": index, type: type };
        }
    }
    // Preference 2
    onPreference2(e, type) {
        if (e.target.value != '') {
            this.data2 = e.target.value;
            $(".select3 option[value='" + e.target.value + "']").prop('disabled', true);
            $(".select3 option[value!='" + e.target.value + "']").prop('disabled', false);
            $(".select1 option[value='" + e.target.value + "']").prop('disabled', true);
            $(".select1 option[value!='" + e.target.value + "']").prop('disabled', false);
            if (this.data3 != '' || this.data1 != '') {
                $(".select1 option[value='" + this.data3 + "']").prop('disabled', true);
                $(".select3 option[value='" + this.data1 + "']").prop('disabled', true);
            }
            this.didForm.get("preference3").enable();
            if (this.idservice == "") {
                this.idservice = sessionStorage.getItem("insertId");
            }
            let index = e.target.id;
            this.preferenceDID[index] = { index: index, "idsupplier": e.target.value, "idservice": this.idservice, "priority": index, type: type };
        }
    }
    // preference 3
    onPreference3(e, type) {
        if (e.target.value != '') {
            this.data3 = e.target.value;
            $(".select1 option[value='" + e.target.value + "']").prop('disabled', true);
            $(".select1 option[value!='" + e.target.value + "']").prop('disabled', false);
            $(".select2 option[value='" + e.target.value + "']").prop('disabled', true);
            $(".select2 option[value!='" + e.target.value + "']").prop('disabled', false);
            if (this.data2 != '' || this.data1 != '') {
                $(".select2 option[value='" + this.data1 + "']").prop('disabled', true);
                $(".select1 option[value='" + this.data2 + "']").prop('disabled', true);
            }
            if (this.idservice == "") {
                this.idservice = sessionStorage.getItem("insertId");
            }
            let index = e.target.id;
            this.preferenceDID[index] = { index: index, "idsupplier": e.target.value, "idservice": this.idservice, "priority": index, type: type };
        }
    }
    onSMS(e, type) {
        this.didSupplier.forEach(element => {
            if (e.target[e.target.options.selectedIndex].value == element.key) {
                element.selected = "true";
            }
        });
        if (this.idservice == "") {
            this.idservice = sessionStorage.getItem("insertId");
        }
        let index = e.target.id;
        this.preferenceSMS[index] = { index: index, "idsupplier": e.target.value, "idservice": this.idservice, "priority": index, type: type };
    }
    onVoice(e, type) {
        this.didSupplier.forEach(element => {
            if (e.target[e.target.options.selectedIndex].value == element.key) {
                element.selected = "true";
            }
        });
        if (this.idservice == "") {
            this.idservice = sessionStorage.getItem("insertId");
        }
        let index = e.target.id;
        this.preferenceVoice[index] = { index: index, "idsupplier": e.target.value, "idservice": this.idservice, "priority": index, type: type };
    }
    resetOptions() {
        $('select').prop('selectedIndex', 0);
        this.didSupplier.forEach(element => {
            element.selected = "false";
        });
    }
    // @to save/update form data
    onSetPreference() {
        this.submitted = true;
        if (!this.idservice) {
            return false;
        }
        if (this.didForm.invalid) {
            return false;
        }
        else {
            this.data.updatePreference(JSON.stringify(this.preferenceDID)).subscribe(res => {
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }, err => {
                this.responseMessage = err.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            });
        }
    }
    onSetSMS() {
        this.submitted = true;
        if (!this.idservice) {
            return false;
        }
        if (this.smsForm.invalid) {
            return false;
        }
        else {
            this.data.updatePreference(JSON.stringify(this.preferenceSMS)).subscribe(res => {
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }, err => {
                this.responseMessage = err.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            });
        }
    }
    onSetVoice() {
        this.submitted = true;
        if (!this.idservice) {
            return false;
        }
        if (this.voiceForm.invalid) {
            return false;
        }
        else {
            this.data.updatePreference(JSON.stringify(this.preferenceVoice)).subscribe(res => {
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }, err => {
                this.responseMessage = err.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            });
        }
    }
    onReset() {
        this.submitted = false;
        const idservice = this.preferenceForm.value.idservice; // Store the existing idservice
        this.preferenceForm.reset(); // Reset the form
        this.preferenceForm.patchValue({ idservice });
    }
};
AddServiceComponent = __decorate([
    Component({
        selector: 'app-add-service',
        templateUrl: './add-service.component.html',
        styleUrls: ['./add-service.component.css']
    })
], AddServiceComponent);
export { AddServiceComponent };
//# sourceMappingURL=add-service.component.js.map