import { __decorate, __param } from "tslib";
import { Component, Inject } from '@angular/core';
import { MAT_DIALOG_DATA } from '@angular/material/dialog';
let AdvanceratesComponent = class AdvanceratesComponent {
    constructor(dialogRef, data, userService, fb) {
        this.dialogRef = dialogRef;
        this.data = data;
        this.userService = userService;
        this.fb = fb;
        this.optlist = ["A", "C", "E", "G", "Z", "Q", "B", "D", "F", "T", "NA", "P", "X", "S", "Y", "W"];
    }
    ngOnInit() {
        this.optid = this.data.id;
        this.header = this.data.label;
        this.ctype = this.data.type;
        let tmpform = {};
        this.optlist.forEach(ele => {
            if (this.ctype == "SMS-IN")
                tmpform["10dlc_sms_in_" + this.optid + "_" + ele] = [0];
            if (this.ctype == "SMS-OUT")
                tmpform["10dlc_sms_out_" + this.optid + "_" + ele] = [0];
            if (this.ctype == "MMS-IN")
                tmpform["10dlc_mms_in_" + this.optid + "_" + ele] = [0];
            if (this.ctype == "MMS-OUT")
                tmpform["10dlc_mms_out_" + this.optid + "_" + ele] = [0];
        });
        this.tollFreeForm = this.fb.group(tmpform);
        this.userService.getsmsrate().subscribe((result) => {
            this.headers = result[0].headers_details;
            this.listdata = result[0].rowdata;
        });
    }
    onSaveTollFree() {
        this.dialogRef.close(this.tollFreeForm.value);
    }
    closeForm() {
        this.dialogRef.close();
    }
};
AdvanceratesComponent = __decorate([
    Component({
        selector: 'app-advancerates',
        templateUrl: './advancerates.component.html',
        styleUrls: ['./advancerates.component.css']
    }),
    __param(1, Inject(MAT_DIALOG_DATA))
], AdvanceratesComponent);
export { AdvanceratesComponent };
//# sourceMappingURL=advancerates.component.js.map