import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
let ListComponent = class ListComponent {
    constructor(data, tariffService, fb) {
        this.data = data;
        this.tariffService = tariffService;
        this.fb = fb;
        this.searchText = { count: 0 };
        this.hide = true;
        this.page = 1;
        this.count = 0;
        this.tableSize = 50;
        this.tableSizes = [50, 100, 150];
        this.responseMessage = "";
        this.errMessage = "";
    }
    ngOnInit() {
        this.tariffForm = this.fb.group({
            id: [],
            name: ['', [Validators.required]],
            description: ['', [Validators.required, Validators.minLength(10)]],
            //day_num: new FormControl("", [Validators.required])    
        });
        this.tariffService.getTariffs().subscribe(res => {
            this.tariffs = res.data;
            $('#basic-datatables').DataTable().clear();
            $('#basic-datatables').DataTable().destroy();
            $.getScript('./assets/table.js');
            this.tariffLength = this.tariffs.length;
        });
    }
    editModal(data) {
        this.tariffForm.setValue({
            id: data.idtariff,
            name: data.name,
            description: data.description,
            //day_num: data.day_num
        });
    }
    editTariff() {
        if (this.tariffForm.invalid) {
            this.submitted = true;
            return;
        }
        else {
            this.tariffService.updateTariff(this.tariffForm.value).subscribe(res => {
                if (res.status == 201) {
                    $("#exampleModal").hide();
                    $(".modal-backdrop").remove();
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                    window.location.reload();
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.responseMessage = err.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            });
        }
    }
    deleteTariff(idtariff) {
        if (confirm("Are you sure you want delete data!")) {
            this.tariffService.deleteTariff(idtariff).subscribe(res => {
                if (res.status == 201) {
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                    window.location.reload();
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.responseMessage = err.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            });
        }
        else {
            "Cancel!";
        }
    }
    onClose() {
        this.submitted = false;
        this.tariffForm.reset();
    }
};
ListComponent = __decorate([
    Component({
        selector: 'app-list',
        templateUrl: './list.component.html',
        styleUrls: ['./list.component.css']
    })
], ListComponent);
export { ListComponent };
//# sourceMappingURL=list.component.js.map