import { __decorate } from "tslib";
import { Component } from '@angular/core';
let ServiceComponent = class ServiceComponent {
    constructor(data, tariffService, fb) {
        this.data = data;
        this.tariffService = tariffService;
        this.fb = fb;
        this.searchText = { count: 0 };
        this.hide = true;
        this.page = 1;
        this.count = 0;
        this.tableSize = 50;
        this.tableSizes = [50, 100, 150];
        this.responseMessage = "";
        this.errMessage = "";
        this.preferenceServices = [];
    }
    ngOnInit() {
        this.tariffService.getPreferenceService().subscribe(res => {
            this.preferenceServices = res.data;
            $('#basic-datatable01').DataTable().clear();
            $('#basic-datatable01').DataTable().destroy();
            $.getScript('./assets/table.js');
        }, err => {
            console.log(err);
        });
    }
    setAsDefaultService(idservice, iduser) {
        let data = idservice + '-' + iduser;
        this.tariffService.setDefault(data).subscribe((res) => {
            if (res.status == 201) {
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
                this.ngOnInit();
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    deleteService(idservice) {
        if (confirm("Are you sure you want delete data!")) {
            this.tariffService.deletePreferenceService(idservice).subscribe(res => {
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
                this.ngOnInit();
            }, err => {
                this.responseMessage = err.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            });
        }
        else {
            "Cancel!";
        }
    }
};
ServiceComponent = __decorate([
    Component({
        selector: 'app-service',
        templateUrl: './service.component.html',
        styleUrls: ['./service.component.css']
    })
], ServiceComponent);
export { ServiceComponent };
//# sourceMappingURL=service.component.js.map