import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
let SurchargeComponent = class SurchargeComponent {
    constructor(data, fb, tariffService, route) {
        this.data = data;
        this.fb = fb;
        this.tariffService = tariffService;
        this.route = route;
        this.searchText = { count: 0 };
        this.page = 1;
        this.count = 0;
        this.tableSize = 50;
        this.tableSizes = [50, 100, 150];
        this.responseMessage = "";
        this.errMessage = "";
        this.resAlertMessage = "";
        this.surcharges = [];
        this.surchargeData = [];
        this.submitted = false;
    }
    ngOnInit() {
        this.surchargeForm = this.fb.group({
            idsurcharge: ['', [Validators.required]],
            name: ['', [Validators.required]],
            description: ['', [Validators.required]],
        });
        this.getSurchargeList();
    }
    getSurchargeList() {
        this.tariffService.getSurcharge().subscribe(res => {
            if (res.status == 200) {
                this.surcharges = res.data;
                $.getScript('./assets/table.js');
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    deleteSurcharge(idsurcharge) {
        this.tariffService.deleteSurcharge(idsurcharge).subscribe(res => {
            if (res.status == 200) {
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
                this.ngOnInit();
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    onSurcharge(data) {
        this.dName = data.name;
        this.surchargeForm.patchValue({
            idsurcharge: data.idsurcharge,
            name: data.name,
            description: data.description
        });
    }
    editSercharge() {
        this.submitted = false;
        if (this.surchargeForm.invalid) {
            this.submitted = true;
            return true;
        }
        else {
            this.tariffService.editSurcharge(this.surchargeForm.value).subscribe(res => {
                if (res.status == 201) {
                    document.getElementById("closeModal").click();
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                    this.getSurchargeList();
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.errMessage = err.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            });
        }
    }
    resetModal() {
        this.submitted = false;
    }
};
SurchargeComponent = __decorate([
    Component({
        selector: 'app-surcharge',
        templateUrl: './surcharge.component.html',
        styleUrls: ['./surcharge.component.css']
    })
], SurchargeComponent);
export { SurchargeComponent };
//# sourceMappingURL=surcharge.component.js.map