import { __decorate } from "tslib";
import { HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { LoaderEnabled } from '../shared/loader/loader.service';
import { AppService } from '../shared/service/AppService.class';
let TariffService = class TariffService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.appmod = "usermanagement";
    }
    updatePreferenceService(data) {
        let tmp = this.appmod;
        this.appmod = "updateservicepreference";
        let result = super.updateService(data);
        this.appmod = tmp;
        return result;
    }
    savePreferenceService(data) {
        this.appmod = "preferenceservice";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    getSingleService(idservice) {
        const endpoint = environment.SERVER + 'singleservice';
        let httpHeaders = new HttpHeaders({});
        return this.http.get(endpoint, { headers: httpHeaders, params: idservice });
    }
    getSingleUsers() {
        this.appmod = "singleuser";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    searchByOperator(text) {
        let searchText = { text: text };
        const endpoint = environment.SERVER + 'operators';
        let httpHeaders = new HttpHeaders({
            "content-type": "application/json"
        });
        return this.http.get(endpoint, { headers: httpHeaders, params: searchText });
    }
    getPreferenceService() {
        this.appmod = "service";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    setDefault(data) {
        let apiUrl = environment.SERVER + "default_service";
        let httpHeaders = new HttpHeaders({
        // "Content-Type": "application/json",
        });
        return this.http.put(apiUrl, { data: data }, { headers: httpHeaders });
    }
    deletePreferenceService(data) {
        this.appmod = "deleteservice";
        let result = super.deleteService(data);
        this.appmod = "";
        return result;
    }
    saveSurcharge(data) {
        this.appmod = "savesurcharge";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    updateSurcharge(data) {
        this.appmod = "edit_Surcharge";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    getSurcharge() {
        this.appmod = "surcharge";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    editSurcharge(data) {
        this.appmod = 'editSurcharge';
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    deleteSurcharge(key) {
        this.appmod = 'deletesurcharge';
        let result = super.deleteService(key);
        this.appmod = "";
        return result;
    }
    saveTariff(data) {
        this.appmod = "saveTariff";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    copyTariff(data) {
        this.appmod = "copyTariff";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    getTariffs() {
        this.appmod = "getTariffs";
        let tmp = this.getService();
        this.appmod = "";
        return tmp;
    }
    getTypesTariff(type) {
        this.appmod = "type_tariffs";
        let tmp = this.getService(type);
        this.appmod = "";
        return tmp;
    }
    getTariff(idtariff) {
        this.appmod = "getTariff";
        let tmp = this.getService(idtariff);
        this.appmod = "";
        return tmp;
    }
    updateTariff(data) {
        this.appmod = 'updateTariff';
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    deleteTariff(key) {
        this.appmod = 'deleteTariff';
        let result = super.deleteService(key);
        this.appmod = "";
        return result;
    }
    addA2PDLCRates(data) {
        this.appmod = "add10dlca2p";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    addTollFreeRate(data) {
        this.appmod = "tollfreerates";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    // @LoaderEnabled()
    // SMS_Rates(data: any): Observable<any>{
    //   this.appmod = "usa_sms_rates";
    //   let result = super.saveService(data);
    //   this.appmod = "";
    //   return result;
    // }
    ShortCodeRate(data) {
        this.appmod = "addshortcode";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    onVoiceRates(data) {
        this.appmod = "addvoicerate";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    getRate(data) {
        this.appmod = "tier/billing_rate";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    getleadinfo() {
        this.appmod = "lerg_info";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getoperatormaping() {
        this.appmod = "operator-mapping";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    GetSmsRate(data) {
        const endpoint = environment.SERVER + 'usa_sms_rates';
        let httpHeaders = new HttpHeaders({});
        return this.http.get(endpoint, { headers: httpHeaders, params: data });
    }
    GetCampaignRate(data) {
        const endpoint = environment.SERVER + 'getcampaign_rate';
        let httpHeaders = new HttpHeaders({});
        return this.http.get(endpoint, { headers: httpHeaders, params: data });
    }
    Get10DLCRate(data) {
        this.appmod = "get10dlca2p";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    GetTollFreeRates(data) {
        this.appmod = "gettollfreerate";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    GetShortCode(data) {
        this.appmod = "getshortcode";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    GetVoiceRates(data) {
        this.appmod = "getvoicerate";
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    updateSMSRate(data) {
        this.appmod = "updateSMSRate";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    updatelookupRate(data) {
        this.appmod = "updatelookupRate";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    updateCampaignReviewRate(data) {
        this.appmod = "updateCampaignReviewRate";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    updateShortCodeRate(data) {
        this.appmod = "updateShortCodeRate";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    updateTollFreeRates(data) {
        this.appmod = "updateTollFreeRate";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    update10DLCRates(data) {
        this.appmod = "update10DLCRate";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    updateVoiceRates(data) {
        this.appmod = "updateVoiceRate";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    onRegisteredRates(data) {
        this.appmod = "addvoicerates";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    onSaveSmsRates(data) {
        this.appmod = "sms_rates";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    updateVoiceRate(data) {
        this.appmod = "updateunregisteredrates";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    //@LoaderEnabled()
    updateTariffDay(data) {
        this.appmod = 'updatetariffday';
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    updateProRate(data) {
        this.appmod = 'updateproratesetting';
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    /*Edit case Activate Msg Pricing*/
    updateactivatemessage(data) {
        this.appmod = "updateactivatemessage";
        console.log(data);
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    /*GET Activation MSg Pricing*/
    getactivate_msg(data) {
        const endpoint = environment.SERVER + 'getactivate_msg';
        let httpHeaders = new HttpHeaders({});
        return this.http.get(endpoint, { headers: httpHeaders, params: data });
    }
    getUnregisteredRate(data) {
        const endpoint = environment.SERVER + 'unregisteredrates';
        let httpHeaders = new HttpHeaders({});
        return this.http.get(endpoint, { headers: httpHeaders, params: data });
    }
    uploadLergFile(file) {
        const formData = new FormData();
        formData.append("profile_pic", file);
        const apiURL = environment.SERVER + 'upload_lerg';
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, formData, { headers: httpHeaders });
    }
    uploadZoneFile(file) {
        const formData = new FormData();
        formData.append("profile_pic", file);
        const apiURL = environment.SERVER + 'upload_zone';
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, formData, { headers: httpHeaders });
    }
    categoryLergInfo() {
        const apiURL = environment.SERVER + 'lerg_category';
        let httpHeaders = new HttpHeaders({});
        return this.http.get(apiURL, { headers: httpHeaders });
    }
    operatorsLergInfo(category) {
        const apiURL = environment.SERVER + 'lerg_operators';
        let httpHeaders = new HttpHeaders({});
        return this.http.get(apiURL, { headers: httpHeaders, params: category });
    }
    setOperatorMapping(data) {
        const apiURL = environment.SERVER + 'operator-mapping';
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, data, { headers: httpHeaders });
    }
    lookupRates(data) {
        const endpoint = environment.SERVER + 'lookupRates';
        let httpHeaders = new HttpHeaders({});
        return this.http.get(endpoint, { headers: httpHeaders, params: data });
    }
    campaignReviewRates(data) {
        const endpoint = environment.SERVER + 'campaignReviewRates';
        let httpHeaders = new HttpHeaders({});
        return this.http.get(endpoint, { headers: httpHeaders, params: data });
    }
    deleteMapping(operator) {
        const apiUrl = environment.SERVER + "delete-mapping";
        let httpHeaders = new HttpHeaders({});
        return this.http.delete(apiUrl, { headers: httpHeaders, params: { operator } });
    }
    getSurcharges(idsurcharge) {
        const apiUrl = environment.SERVER + "getsurcharge";
        let httpHeaders = new HttpHeaders({});
        return this.http.get(apiUrl, { headers: httpHeaders, params: { idsurcharge } });
    }
    getZones() {
        const apiUrl = environment.SERVER + "zones";
        let httpHeaders = new HttpHeaders({});
        return this.http.get(apiUrl, { headers: httpHeaders });
    }
    get_tarifflist() {
        this.appmod = "tarifflist";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    get_tariff(type) {
        this.appmod = "getteriff";
        let tmp = this.getService(type);
        this.appmod = "";
        return tmp;
    }
    get_voiceapi() {
        return this.http.get('./assets/voiceapi.json');
    }
    get_elasticSip() {
        return this.http.get('./assets/elasticsip.json');
    }
    get_MessagePricing() {
        return this.http.get('./assets/messagepricing.json');
    }
    get_lerginfo() {
        return this.http.get('./assets/lerginfo.json');
    }
    get_zone() {
        return this.http.get('./assets/zone.json');
    }
    get_lookuprates() {
        return this.http.get('./assets/lookuppricing.json');
    }
    get_activateMsg() {
        return this.http.get('./assets/activation_msg.json');
    }
};
__decorate([
    LoaderEnabled()
], TariffService.prototype, "updatePreferenceService", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "savePreferenceService", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "getSingleService", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "getSingleUsers", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "searchByOperator", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "getPreferenceService", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "setDefault", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "deletePreferenceService", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "saveSurcharge", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "updateSurcharge", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "getSurcharge", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "editSurcharge", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "deleteSurcharge", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "saveTariff", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "copyTariff", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "getTariffs", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "getTypesTariff", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "getTariff", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "updateTariff", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "deleteTariff", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "addA2PDLCRates", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "addTollFreeRate", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "ShortCodeRate", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "onVoiceRates", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "getRate", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "getleadinfo", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "getoperatormaping", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "GetSmsRate", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "GetCampaignRate", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "Get10DLCRate", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "GetTollFreeRates", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "GetShortCode", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "GetVoiceRates", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "updateSMSRate", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "updatelookupRate", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "updateCampaignReviewRate", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "updateShortCodeRate", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "updateTollFreeRates", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "update10DLCRates", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "updateVoiceRates", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "onRegisteredRates", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "onSaveSmsRates", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "updateVoiceRate", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "updateProRate", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "updateactivatemessage", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "getactivate_msg", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "getUnregisteredRate", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "uploadLergFile", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "uploadZoneFile", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "categoryLergInfo", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "operatorsLergInfo", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "setOperatorMapping", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "lookupRates", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "campaignReviewRates", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "deleteMapping", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "getSurcharges", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "getZones", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "get_tarifflist", null);
__decorate([
    LoaderEnabled()
], TariffService.prototype, "get_tariff", null);
TariffService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], TariffService);
export { TariffService };
//# sourceMappingURL=tariff.service.js.map