import { __decorate } from "tslib";
import { Component } from '@angular/core';
let UnregisteredComponent = class UnregisteredComponent {
    constructor(data, tariffService, fb) {
        this.data = data;
        this.tariffService = tariffService;
        this.fb = fb;
        this.hide = true;
        this.searchText = { count: 0 };
        this.page = 1;
        this.count = 0;
        this.tableSize = 50;
        this.tableSizes = [50, 100, 150];
        this.responseMessage = "";
    }
    ngOnInit() {
        this.tariffForm = this.fb.group({
            id: [],
            name: [],
            description: [],
        });
        this.tariffService.getTariffs().subscribe(res => {
            this.tariffs = res.data;
            this.tariffLength = this.tariffs.length;
        });
    }
    editModal(data) {
        this.tariffForm.setValue({
            id: data.idtariff,
            name: data.name,
            description: data.description
        });
    }
    editTariff() {
        this.tariffService.updateTariff(this.tariffForm.value).subscribe(res => {
            this.responseMessage = res.message;
            if (res.data[0]) {
                this.tariffs = res.data[0];
                $.getScript('./assets/table.js');
            }
            setTimeout(() => {
                this.responseMessage = "";
            }, 5000);
        }, err => {
            this.responseMessage = err.message;
            setTimeout(() => {
                this.responseMessage = "";
            }, 5000);
        });
        this.ngOnInit();
    }
    deleteTariff(idtariff) {
        if (confirm("Are you sure you want delete data!")) {
            this.tariffService.deleteTariff(idtariff).subscribe(res => {
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }, err => {
                this.responseMessage = err.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            });
        }
        else {
            "Cancel!";
        }
        this.ngOnInit();
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event;
    }
};
UnregisteredComponent = __decorate([
    Component({
        selector: 'app-unregistered',
        templateUrl: './unregistered.component.html',
        styleUrls: ['./unregistered.component.css']
    })
], UnregisteredComponent);
export { UnregisteredComponent };
//# sourceMappingURL=unregistered.component.js.map