import { __decorate } from "tslib";
import { Component } from '@angular/core';
let ZoneComponent = class ZoneComponent {
    constructor(formBuilder, tariffSevice) {
        this.formBuilder = formBuilder;
        this.tariffSevice = tariffSevice;
        this.show = false;
        this.buttonName = "Add";
        this.page = 1;
        this.count = 0;
        this.tableSize = 50;
        this.tableSizes = [50, 100, 200];
        this.responseMessage = "";
        this.errMessage = "";
    }
    ngOnInit() {
        // $.getScript('./assets/table.js');
        this.tariffSevice.getZones().subscribe(res => {
            if (res.status == 200) {
                if (res.data[0]) {
                    $.getScript('./assets/table.js');
                }
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
        this.tariffSevice.get_zone().subscribe((result) => {
            this.header = result[0].headers_details;
            // this.rowdata = result[0].zoneinfo; 
        });
    }
    toggle() {
        this.show = !this.show;
        if (this.show)
            this.buttonName = "Close";
        else
            this.buttonName = "Add";
    }
    pickedFile(event) {
        console.log(event, this.filePath);
        const file = event.target.files[0];
        this.zone_file = file;
        const reader = new FileReader();
        reader.readAsDataURL(file);
    }
    uploadZone() {
        this.tariffSevice.uploadZoneFile(this.zone_file).subscribe(res => {
            if (res.status == 201) {
                $("#exampleModal").hide();
                $(".modal-backdrop").remove();
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 3000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 3000);
        });
    }
};
ZoneComponent = __decorate([
    Component({
        selector: 'app-zone',
        templateUrl: './zone.component.html',
        styleUrls: ['./zone.component.css']
    })
], ZoneComponent);
export { ZoneComponent };
//# sourceMappingURL=zone.component.js.map