import { __decorate } from "tslib";
import { Component, ViewChild } from '@angular/core';
import { Validators } from '@angular/forms';
let AddverifysenderComponent = class AddverifysenderComponent {
    constructor(data, fb, router, route) {
        this.data = data;
        this.fb = fb;
        this.router = router;
        this.route = route;
        this.selectedItems = [];
        this.submitted = false;
        this.responseMessage = "";
        this.errMessage = "";
        this.isFilePath = false;
        this.selected1 = [];
        this.selectedFile = [];
    }
    ngOnInit() {
        let session$ = sessionStorage.getItem("isLoggedIn");
        let session = JSON.parse(session$);
        this.userType = session.type;
        this.iduser = session.iduser;
        this.idaccount = session.idaccount;
        this.verifySenderForm = this.fb.group({
            messagingprovider: ['Intelliquent'],
            businessname: ['', [Validators.required, Validators.pattern(/^[^\s].*$/)]],
            address: ['', [Validators.required, Validators.pattern(/^[^\s].*$/)]],
            address1: ['', [Validators.pattern(/^[^\s].*$/)]],
            city: ['', [Validators.required, Validators.pattern(/^[^\s].*$/)]],
            state: ['', [Validators.required, Validators.pattern(/^[^\s].*$/)]],
            zip: ['', [Validators.required, Validators.pattern(/^[^\s].*$/)]],
            firstname: ['', [Validators.required, Validators.pattern(/^([a-zA-Z!@#$%^&*().,<>{}[\]<>?_`~=+\-|;:\'\"\/])*[^\s]\1*$/)]],
            lastname: ['', [Validators.required, Validators.pattern(/^([a-zA-Z!@#$%^&*().,<>{}[\]<>?_`~=+\-|;:\'\"\/])*[^\s]\1*$/)]],
            email: ['', [Validators.required, Validators.pattern("^([A-Za-z0-9._%+-]+)@([A-Za-z0-9-]+\\.[A-Za-z]{2,4})(\\.[A-Za-z]{2,4})?$")]],
            phonenumber: ['', Validators.required],
            // number: ['', Validators.required],
            websiteurl: ['', [Validators.required, Validators.pattern(/^(?:http(s)?:\/\/)?[\w.-]+(?:\.[\w\.-]+)+[\w\-\._~:/?#[\]@!\$&'\(\)\*\+,;=.]+$/)]],
            usecase: ['', [Validators.required, Validators.pattern(/^[^\s].*$/)]],
            usecasecategory: ['', [Validators.pattern(/^[^\s].*$/)]],
            // smsprogram: ['', Validators.required],
            contentcampaign: ['', [Validators.required, Validators.pattern(/^[^\s].*$/)]],
            published: ['', [Validators.required, Validators.pattern(/^[^\s].*$/)]],
            url: ['', [Validators.required, Validators.pattern(/^(?:http(s)?:\/\/)?[\w.-]+(?:\.[\w\.-]+)+[\w\-\._~:/?#[\]@!\$&'\(\)\*\+,;=.]+$/)]],
            numbers: [''],
            messagevolume: [''],
            workdescription: ['', [Validators.pattern(/^[^\s].*$/)]],
            //addInfo: [''],
            //ticketnumber: [''],
            //isv: [''],
            supportdocs: ['', [Validators.pattern(/^[^\s].*$/)]],
            text_msg_type: ['', Validators.required],
            traffic_previous_msg_service: ['', Validators.required],
            traffic_expected: ['', Validators.required],
            oldFile: [''],
            dbaname: ['', [Validators.pattern(/^[^\s].*$/)]],
            company: ['', [Validators.required]]
        });
        // toget request id for pending review
        this.data.get_RequestID().subscribe((result) => {
            if (result.status == 200) {
                this.request_ID = result.data;
            }
        });
        this.getallData();
        /*getting form json*/
        this.data.get_tollfree_sender().subscribe((result) => {
            this.formdata = result;
            this.volumeMonth = this.formdata[9].subheading1.options;
            this.fortune = this.formdata[7].subheading2.options;
            this.text_msg = this.formdata[4].subheading1.options;
            this.text_previous = this.formdata[5].subheading1.options;
            this.traffic_expt = this.formdata[6].subheading1.options;
        });
    }
    onSubmit() {
        this.submitted = true;
        if (this.verifySenderForm.invalid || (!this.selectedFile || this.selectedFile.length === 0 || null) && (!this.files || this.files.length === 0 || null)) {
            return false;
        }
        if ((this.selectedFile && this.selectedFile.length > 10) || (this.files && this.files.length > 10)) {
            return false;
        }
        else {
            let payLoad = JSON.stringify({
                id: this.req_id,
                data: this.verifySenderForm.value,
                previosFile: this.previousfiles,
            });
            this.data.verifySender(payLoad, this.selectedFile).subscribe((res) => {
                if (res.status == 200) {
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = '';
                        this.router.navigateByUrl('/Verified-Sender');
                    }, 5000);
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = '';
                    }, 5000);
                }
            }, (err) => {
                this.errMessage = err.message;
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            });
        }
    }
    resetform() {
        this.submitted = false;
        this.verifySenderForm.reset();
        this.files = [];
        this.selectedFile = [];
        //this.previousfiles = []
        this.files = this.files;
        this.selectedFile = this.selectedFile;
        this.verifySenderForm.get('company').setValue('');
        this.verifySenderForm.get('traffic_expected').setValue('');
        this.verifySenderForm.get('traffic_previous_msg_service').setValue('');
        this.verifySenderForm.get('text_msg_type').setValue('');
        this.verifySenderForm.get('messagevolume').setValue('');
        this.verifySenderForm.get('messagingprovider').setValue('Intelliquent');
        this.selectElement.nativeElement.value = '';
    }
    getallData() {
        this.route.paramMap.subscribe((params) => {
            this.id = params.get('unique_request_id');
            this.req_id = this.id;
            let payLoad = JSON.stringify({
                id: this.id,
                idaccount: this.idaccount,
                iduser: this.iduser
            });
            this.data.view_VerifySender(payLoad).subscribe(result => {
                if (result.status == 200) {
                    this.user = result.data[0];
                    this.key = this.user.file_upload_key;
                    const filePaths = this.user.file_paths.split(',');
                    this.files = [];
                    this.previousfiles = [];
                    filePaths.forEach((filePath, index) => {
                        const fileName = filePath.substring(filePath.lastIndexOf('/') + 1);
                        const fileObject = {
                            file: filePath.trim(),
                            name: fileName,
                        };
                        this.files.push(fileObject);
                        this.previousfiles.push(fileObject);
                    });
                    this.verifySenderForm.patchValue({
                        messagingprovider: 'Intelliquent',
                        dbaname: this.user.dba_name,
                        businessname: this.user.business_name,
                        address: this.user.address1,
                        address1: this.user.address2,
                        city: this.user.city,
                        state: this.user.state,
                        zip: this.user.zip,
                        firstname: this.user.first_name,
                        lastname: this.user.last_name,
                        email: this.user.business_email,
                        phonenumber: this.user.business_phone,
                        websiteurl: this.user.corporate_website_url,
                        usecase: this.user.summarize_usecase,
                        usecasecategory: this.user.use_case_category,
                        contentcampaign: this.user.sample_message,
                        published: this.user.number_published,
                        company: this.user.fortune_company,
                        url: this.user.call_to_action_url,
                        numbers: this.user.call_to_action_numbers,
                        messagevolume: this.user.message_volume_per_month,
                        workdescription: this.user.opt_in_workflow_description,
                        //addInfo: this.user.additional_opt_on_information,
                        //ticketnumber: this.user.internal_ticket_number,
                        //isv: this.user.isv_reseller,
                        supportdocs: this.user.additional_supporting_documentation,
                        text_msg_type: this.user.text_message_type,
                        traffic_previous_msg_service: this.user.traffic_previously_msg_service,
                        traffic_expected: this.user.traffic_expected,
                        //smsprogram: this.user.sms_program,
                    });
                }
                else {
                    this.errMessage = result.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            });
        });
    }
    onFilePicked(event) {
        const file = event.target.files[0];
        this.file = file;
        const reader = new FileReader();
        reader.readAsDataURL(file);
        this.isFilePath = false;
    }
    clickForOldFile() {
        this.isFilePath = true;
        this.file = '';
        /* this.verifySenderForm.patchValue({
          smsprogram:''
        }) */
        this.verifySenderForm.get('smsprogram').setValue('');
    }
    updateSender() {
        this.submitted = true;
        if (this.verifySenderForm.invalid || this.files.length === 0 || null) {
            return false;
        }
        if (this.files.length > 10 || this.selectedFile.length > 10) {
            return false;
        }
        else {
            let payLoad = JSON.stringify({
                id: this.req_id,
                data: this.verifySenderForm.value,
                previosFile: this.previousfiles,
                key: this.key
            });
            this.data.updateVerifySender(payLoad, this.files).subscribe(res => {
                if (res.status == 200) {
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = '';
                        this.router.navigateByUrl('/Verified-Sender');
                    }, 5000);
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = '';
                    }, 5000);
                }
            }, (err) => {
                this.errMessage = err.message;
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            });
            // }
        }
    }
    onSelectChange(event) {
        this.selectedRequestId = event.target.value;
        let payLoad = JSON.stringify({
            id: this.selectedRequestId,
            idaccount: this.idaccount,
            iduser: this.iduser
        });
        this.data.view_VerifySender(payLoad).subscribe(result => {
            if (result.status == 200) {
                this.user = result.data[0];
                const filePaths = this.user.file_paths.split(',');
                this.files = [];
                this.previousfiles = [];
                filePaths.forEach((filePath, index) => {
                    const fileName = filePath.substring(filePath.lastIndexOf('/') + 1);
                    const fileObject = {
                        file: filePath,
                        name: fileName,
                    };
                    this.files.push(fileObject);
                    this.previousfiles.push(fileObject);
                });
                this.verifySenderForm.patchValue({
                    messagingprovider: 'Intelliquent',
                    businessname: this.user.business_name,
                    address: this.user.address1,
                    address1: this.user.address2,
                    city: this.user.city,
                    state: this.user.state,
                    zip: this.user.zip,
                    firstname: this.user.first_name,
                    lastname: this.user.last_name,
                    email: this.user.business_email,
                    phonenumber: this.user.business_phone,
                    websiteurl: this.user.corporate_website_url,
                    usecase: this.user.summarize_usecase,
                    usecasecategory: this.user.use_case_category,
                    contentcampaign: this.user.sample_message,
                    published: this.user.number_published,
                    url: this.user.call_to_action_url,
                    numbers: this.user.call_to_action_numbers,
                    messagevolume: this.user.message_volume_per_month,
                    workdescription: this.user.opt_in_workflow_description,
                    // addInfo: this.user.additional_opt_on_information,
                    // ticketnumber: this.user.internal_ticket_number,
                    // isv: this.user.isv_reseller,
                    supportdocs: this.user.additional_supporting_documentation,
                    text_msg_type: this.user.text_message_type,
                    traffic_previous_msg_service: this.user.traffic_previously_msg_service,
                    traffic_expected: this.user.traffic_expected,
                    //smsprogram: this.user.sms_program,
                    dbaname: this.user.dba_name,
                    company: this.user.fortune_company,
                });
            }
            else {
                this.errMessage = result.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    // handleClick1(file: File): void {
    //   if (this.files && this.selectedFile) {
    //     this.removeFile1(file);
    //     this.removeFile(file);
    //   }
    // }
    downloadFile(file) {
        if (file) {
            const a = document.createElement('a');
            a.href = URL.createObjectURL(file);
            a.download = file.name;
            a.click();
        }
    }
    viewFile(data) {
        const pdfModal = document.getElementById('modalPdfAppeal');
        const imageModal = document.getElementById('modalImageAppeal');
        const docxModal = document.getElementById('modalDocxAppeal');
        const modalImage = document.getElementById('modalImage');
        const modalImage123 = document.getElementById('modalPdf');
        const videoModal = document.getElementById('modalVideoForFile');
        const videoModal12 = document.getElementById('videoModal');
        if (data.type.startsWith('image/')) {
            const imageData = data;
            modalImage.src = URL.createObjectURL(imageData);
            // Open the modal for images
            $(imageModal).modal('show');
        }
        else if (data.type === 'application/pdf') {
            const pdfData = data;
            modalImage123.src = URL.createObjectURL(pdfData);
            // Open the modal for non-image files
            $(pdfModal).modal('show');
        }
        else if (data.type.startsWith('video/')) {
            const videoData = data;
            videoModal12.src = URL.createObjectURL(videoData);
            // Open Modal for Video
            $(videoModal).modal('show');
            $(videoModal).on('hidden.bs.modal', function () {
                videoModal12.pause();
            });
        }
        else {
            if (data) {
                const a = document.createElement('a');
                a.href = URL.createObjectURL(data);
                a.download = data.name;
                a.click();
                $(docxModal).modal('show');
            }
        }
    }
    viewFile1(data) {
        const fileExtension = data.name.split('.').pop();
        const pdfModal = document.getElementById('modalPdfAppeal');
        const imageModal = document.getElementById('modalImageAppeal');
        const docxModal = document.getElementById('modalDocxAppeal');
        const videoModal = document.getElementById('modalVideoForFile');
        const modalImage = document.getElementById('modalImage');
        const modalImage123 = document.getElementById('modalPdf');
        const videoModal12 = document.getElementById('videoModal');
        if (fileExtension === "png" || fileExtension === "jpg" || fileExtension === "jpeg") {
            const imageData = data.file;
            modalImage.src = data.file;
            // Open the modal for images
            $(imageModal).modal('show');
        }
        else if (fileExtension === 'pdf') {
            // const pdfData = data.file
            modalImage123.src = data.file;
            // Open the modal for non-image files
            $(pdfModal).modal('show');
        }
        else if (fileExtension === 'mp4') {
            // const videoData = data.file;
            videoModal12.src = data.file;
            // Open Modal for Video
            $(videoModal).modal('show');
            $(videoModal).on('hidden.bs.modal', function () {
                videoModal12.pause();
            });
        }
        else {
            if (data.file) {
                const a = document.createElement('a');
                a.href = data.file;
                a.download = data.name;
                document.body.appendChild(a);
                a.click();
                document.body.removeChild(a);
                $(docxModal).modal('show');
            }
        }
    }
    removeFile(fileToRemove) {
        this.selectedFile = this.selectedFile.filter(file => file !== fileToRemove);
    }
    removeFile1(fileToRemove) {
        this.selectedFile = this.selectedFile.filter(file => file !== fileToRemove);
        this.previousfiles = this.previousfiles.filter(file => file !== fileToRemove);
        this.previousfiles = this.previousfiles;
        this.files = this.files.filter(file => file !== fileToRemove);
    }
    downloadFile1(data) {
        if (data.file) {
            const a = document.createElement('a');
            a.href = data.file;
            a.download = data.name;
            a.click();
        }
    }
    handledownload(file) {
        if (file.file && file.name) {
            this.downloadFile1(file);
        }
        else {
            this.downloadFile(file);
        }
    }
    onFileChange(event) {
        const fileInput = event.target;
        if (fileInput.files && fileInput.files.length > 0) {
            const file = fileInput.files[0];
            const fileSize = file.size;
            const maxSizePerFile = 10 * 1024 * 1024;
            if (fileSize > maxSizePerFile) {
                this.errMessage = "Individual file size limit exceeded";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
                fileInput.value = '';
                return;
            }
            const totalFileSize = this.selectedFile.reduce((total, selectedFile) => total + selectedFile.size, 0);
            const maxTotalSize = 30 * 1024 * 1024;
            if (totalFileSize + fileSize > maxTotalSize) {
                this.errMessage = "Total files size limit exceeded";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
                fileInput.value = '';
                return;
            }
            const allowedTypes = ['image/jpeg', 'image/png', 'application/pdf', 'application/msword', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'video/mp4', 'text/plain'];
            if (!allowedTypes.includes(file.type)) {
                this.errMessage = "Invalid file type. Allowed types are: .jpg, .jpeg, .png, .pdf, .docx, .mp4, .txt";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
                fileInput.value = '';
                return;
            }
            const reader = new FileReader();
            reader.readAsDataURL(file);
            if (this.req_id) {
                this.selectedFile.push(file);
                this.files.push(file);
            }
            else {
                this.selectedFile.push(file);
                this.files.push(file);
            }
            fileInput.value = '';
        }
    }
    handleClick(file) {
        if (this.files && this.selectedFile) {
            this.viewFile1(file);
            this.viewFile(file);
        }
    }
    ngOnDestroy() {
        this.modalVideoForFile.nativeElement.click();
        this.modalPdfAppeal.nativeElement.click();
        this.modalImageAppeal.nativeElement.click();
    }
};
__decorate([
    ViewChild('selectElement')
], AddverifysenderComponent.prototype, "selectElement", void 0);
__decorate([
    ViewChild('modalImageAppeal')
], AddverifysenderComponent.prototype, "modalImageAppeal", void 0);
__decorate([
    ViewChild('modalPdfAppeal')
], AddverifysenderComponent.prototype, "modalPdfAppeal", void 0);
__decorate([
    ViewChild('modalVideoForFile')
], AddverifysenderComponent.prototype, "modalVideoForFile", void 0);
AddverifysenderComponent = __decorate([
    Component({
        selector: 'app-addverifysender',
        templateUrl: './addverifysender.component.html',
        styleUrls: ['./addverifysender.component.css']
    })
], AddverifysenderComponent);
export { AddverifysenderComponent };
//# sourceMappingURL=addverifysender.component.js.map