import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from '../shared/service/AppService.class';
import { LoaderEnabled } from '../shared/loader/loader.service';
import { environment } from 'src/environments/environment';
let TollfreesmsService = class TollfreesmsService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
    }
    get_tollfreeheader() {
        return this.http.get('./assets/tollfreesms.json');
    }
    get_tollfree_detail() {
        return this.http.get('./assets/tollfree_viewdetail.json');
    }
    get_tollfree_sender() {
        return this.http.get('./assets/tollfree_verifysender.json');
    }
    did_number() {
        this.appmod = "did_number";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    /* to get request id acc to idaccount*/
    get_RequestID() {
        this.appmod = "get_RequestID";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    updateVerifySender(data, file) {
        const formData = new FormData();
        for (let i = 0; i < file.length; i++) {
            formData.append("ATTACHMENTS", file[i]);
        }
        formData.append("data", data);
        const apiURL = environment.SERVER + 'updateVerifySender';
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, formData, { headers: httpHeaders });
    }
    verifySender(data, file) {
        const formData = new FormData();
        for (let i = 0; i < file.length; i++) {
            formData.append("ATTACHMENTS", file[i], file[i].name);
        }
        formData.append("ATTACHMENTS", file);
        formData.append("data", data);
        const apiURL = environment.SERVER + 'saveVefiySender';
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, formData, { headers: httpHeaders });
    }
    get_verifySender() {
        let tmp = this.appmod;
        this.appmod = "getVerified_Sender";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    view_VerifySender(payLoad) {
        this.appmod = 'getsingleSenderDetails';
        let result = super.getService(payLoad);
        this.appmod = "";
        return result;
    }
    getRequestIdfromBatchId(id) {
        this.appmod = 'getrequestID';
        let result = super.getService(id);
        this.appmod = "";
        return result;
    }
    getAssign_number() {
        let tmp = this.appmod;
        this.appmod = "getAssign_number";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    downloadCSVemail(id) {
        this.appmod = 'downloadCSVemail';
        let result = super.getService(id);
        this.appmod = "";
        return result;
    }
    getBatch() {
        this.appmod = 'getbatchId';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    approveSender(data) {
        this.appmod = "approveSenderStatus";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    rejectSenderStatus(data) {
        this.appmod = "rejectSenderstatus";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    sendMailIds(data) {
        this.appmod = "csvForIntq";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    approveReview(data) {
        this.appmod = "approveReviewStatus";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    rejectReview(data) {
        this.appmod = "rejectReviewStatus";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    applyTollfreeFilter(data) {
        this.appmod = "tollfreefilter";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    did_change(data) {
        this.appmod = "did_change";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    did_reject(data) {
        this.appmod = "did_reject";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    get_status(data) {
        this.appmod = 'get_status';
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    resendEmail(data) {
        this.appmod = "resendEmailtoIntq";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    emailTollfreeFilter(data) {
        this.appmod = "emailtollfreefilter";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    onEnable_service(data) {
        this.appmod = "EnableTFsms";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    onDisable_service(data) {
        this.appmod = "disableTFsms";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    applyFilter(data) {
        this.appmod = "tollfreeAssignfilter";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
};
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "did_number", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "get_RequestID", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "updateVerifySender", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "verifySender", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "get_verifySender", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "view_VerifySender", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "getRequestIdfromBatchId", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "getAssign_number", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "downloadCSVemail", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "getBatch", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "approveSender", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "rejectSenderStatus", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "sendMailIds", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "approveReview", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "rejectReview", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "applyTollfreeFilter", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "did_change", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "did_reject", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "get_status", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "resendEmail", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "emailTollfreeFilter", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "onEnable_service", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "onDisable_service", null);
__decorate([
    LoaderEnabled()
], TollfreesmsService.prototype, "applyFilter", null);
TollfreesmsService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], TollfreesmsService);
export { TollfreesmsService };
//# sourceMappingURL=tollfreesms.service.js.map