import { __decorate } from "tslib";
import { Component, ViewChild } from '@angular/core';
import { Validators } from '@angular/forms';
import * as XLSX from 'xlsx';
import { saveAs } from 'file-saver';
import { environment } from 'src/environments/environment';
let TollfreesmsComponent = class TollfreesmsComponent {
    constructor(router, http, data, fb, _http, userService) {
        this.router = router;
        this.http = http;
        this.data = data;
        this.fb = fb;
        this._http = _http;
        this.userService = userService;
        this.show = false;
        this.tabs = [];
        this.headers = [];
        this.sendMail = false;
        this.isShow = false;
        this.currentFilter = 'Pending Review';
        this.selectedTab = '';
        this.show_filter = false;
        this.submitted = false;
        this.verified = [];
        this.selectedAwait = [];
        this.iselectAll = false;
        this.isSelected = false;
        this.isChecked = false;
        this.EXCEL_TYPE = 'application/csv';
        this.EXCEL_EXTENSION = '.csv';
        this.checkedNumbers = [];
        this.VerifiedfilterCSV = [];
        this.Verifiedfilter = [];
        this.did_sinch = [];
        this.did_status = [];
        this.users = [];
        this.batchId = false;
        this.selectAllChecked = false;
        this.checkStatus = (num) => {
            this.checkedNumbers = this.checkedNumbers.includes(num)
                ? this.checkedNumbers.filter((n) => n !== num)
                : [...this.checkedNumbers, num];
            if (this.checkedNumbers.length === 0) {
                this.isShow = false;
            }
            else {
                this.isShow = true;
            }
            this.selectAllChecked = this.did_status
                .filter((num) => num.sinch_status === '15')
                .every((num) => this.checkedNumbers.includes(num.did));
        };
    }
    ngOnInit() {
        this.selectedAwaitCount = '';
        let session$ = sessionStorage.getItem("isLoggedIn");
        let session = JSON.parse(session$);
        this.userType = session.type;
        this.iduser = session.iduser;
        this.idaccount = session.idaccount;
        /*get headers for all tabs*/
        this.data.get_tollfreeheader().subscribe((result) => {
            this.userInfo = result[0].header;
            this.tabheader1 = this.userInfo[0].tableheaders;
            this.tabheader2 = this.userInfo[1].tableheaders;
            this.tabheader3 = this.userInfo[2].tableheaders;
            this.tabheader4 = this.userInfo[3].tableheaders;
            this.tabheader5 = this.userInfo[4].tableheaders;
            this.tabheader6 = this.userInfo[5].tableheaders;
            this.tabheader7 = this.userInfo[6].tableheaders;
        });
        /*get header for customer*/
        this.data.get_tollfree_detail().subscribe((result) => {
            this.userInfo1 = result;
            this.tabheader01 = this.userInfo1[0].tableheaders;
        });
        // starting filter code 
        this.data.get_tollfreeheader().subscribe((result) => {
            this.userInfo2 = result[1].filterheader;
            this.label = this.userInfo2;
            this.userInfo3 = result[2].rejectfield;
            this.Status = result[3].StatusValues;
        });
        this.batchData();
        $.getScript('./assets/tollfree.js');
        this.tollFree = this.fb.group({
            from_date: [''],
            to_date: [''],
            Request_Id: [''],
            username: [''],
            statusResponse: [''],
            filter_type: [''],
            batchid: ['']
        });
        // end here filter code
        this.Get_VerifiedList();
        this.rejectForm = this.fb.group({
            reject_text: ['', [Validators.required]],
        });
        this.tollFree.patchValue({
            filter_type: this.userType == 1 ? "Pending Review" : ''
        });
        // For showing Username and san of customers
        this.userService.getUsers("main").subscribe(res => {
            if (res.status == 200) {
                this.users = res.data[0];
                this.users.sort((a, b) => {
                    return a.san - b.san;
                });
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    filterByUser(ev) {
        this.selectedUser = ev.target.value;
    }
    byStatus(ev) {
        this.selectedStatus = ev.target.value;
    }
    Get_VerifiedList() {
        // Fetch batch data
        this.data.getBatch().subscribe(res1 => {
            this.data.get_verifySender().subscribe(res => {
                if (res.status == 200) {
                    this.getVerifyData = res.data;
                    for (const itemVerifySender of res.data) {
                        const uniqueRequestId = itemVerifySender.unique_request_id;
                        const matchingBatchData = this.batchdata.find(batchItem => batchItem.verified_sender_id.includes(uniqueRequestId));
                        if (matchingBatchData) {
                            itemVerifySender.batch_id = matchingBatchData.batch_id;
                        }
                    }
                    this.verified = [];
                    this.pending = [];
                    this.rejected = [];
                    this.Awaiting = [];
                    this.verified_started = [];
                    this.verified_rejected = [];
                    this.verified_approved = [];
                    if (res.data.length > 0) {
                        this.verified = res.data;
                        if (this.userType == 1) {
                            this.verified.forEach((element) => {
                                if (element.status == 1) {
                                    element.status = 'Pending Review';
                                    this.pending.push(element);
                                }
                                if (element.status == 2) {
                                    element.status = 'Rejected';
                                    this.rejected.push(element);
                                }
                                if (element.status == 3) {
                                    element.status = 'Awaiting Downstream Processing';
                                    this.Awaiting.push(element);
                                }
                                if (element.status == 4) {
                                    element.status = 'Verified Sender Review Process Started';
                                    this.verified_started.push(element);
                                }
                                if (element.status == 5) {
                                    element.status = 'Verified Sender Submission Rejected';
                                    this.verified_rejected.push(element);
                                }
                                if (element.status == 6) {
                                    element.status = 'Verified Sender Submission Approved';
                                    this.verified_approved.push(element);
                                }
                            });
                        }
                        else {
                            this.verified = res.data;
                            this.setStatus(this.verified);
                            $('#basic-datatables7').dataTable().fnClearTable();
                            $('#basic-datatables7').dataTable().fnDraw();
                            $('#basic-datatables7').dataTable().fnDestroy();
                            $.getScript('./assets/tollfree.js');
                        }
                        $('#basic-datatables1').dataTable().fnClearTable();
                        $('#basic-datatables1').dataTable().fnDraw();
                        $('#basic-datatables1').dataTable().fnDestroy();
                        $('#basic-datatables2').dataTable().fnClearTable();
                        $('#basic-datatables2').dataTable().fnDraw();
                        $('#basic-datatables2').dataTable().fnDestroy();
                        $('#basic-datatables3').dataTable().fnClearTable();
                        $('#basic-datatables3').dataTable().fnDraw();
                        $('#basic-datatables3').dataTable().fnDestroy();
                        $('#basic-datatables4').dataTable().fnClearTable();
                        $('#basic-datatables4').dataTable().fnDraw();
                        $('#basic-datatables4').dataTable().fnDestroy();
                        $('#basic-datatables5').dataTable().fnClearTable();
                        $('#basic-datatables5').dataTable().fnDraw();
                        $('#basic-datatables5').dataTable().fnDestroy();
                        $('#basic-datatables6').dataTable().fnClearTable();
                        $('#basic-datatables6').dataTable().fnDraw();
                        $('#basic-datatables6').dataTable().fnDestroy();
                        $.getScript('./assets/tollfree.js');
                    }
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = '';
                    }, 5000);
                }
            });
        });
    }
    onSelectAll(e) {
        if (e.target.checked) {
            this.selectedAwait = [];
            this.Awaiting.forEach((ele) => {
                ele.isChecked = true;
                this.selectedAwait.push(ele);
            });
        }
        else {
            this.iselectAll = false;
            this.selectedAwait = [];
            this.Awaiting.forEach((ele) => {
                ele.isChecked = false;
            });
        }
        if (this.selectedAwait.length == this.Awaiting.length) {
            this.iselectAll = true;
        }
        else {
            this.iselectAll = false;
        }
        this.selectedAwaitCount = this.selectedAwait.length;
    }
    onSelectAwait(e, data, idx) {
        if (e.target.checked) {
            this.selectedAwait.push(data);
        }
        else {
            this.selectedAwait = this.selectedAwait.filter(item => item.unique_request_id !== data.unique_request_id);
        }
        if (this.selectedAwait.length === this.Awaiting.length) {
            this.iselectAll = true;
        }
        else {
            this.iselectAll = false;
        }
        this.isSelected = this.selectedAwait.length > 0;
        this.selectedAwaitCount = this.selectedAwait.length;
    }
    showbtn1(data) {
        // Add more conditions for other tabs if needed
        if (data === 'Awaiting Downstream Processing') {
            this.sendMail = true;
            this.currentFilter = 'Awaiting Downstream Processing';
        }
        else if (data === 'Verified Sender Review Process Started') {
            this.sendMail = false;
            this.currentFilter = 'Verified Sender Review Process Started';
        }
        else if (data === 'Verified Sender Submission Rejected') {
            this.sendMail = false;
            this.currentFilter = 'Verified Sender Submission Rejected';
        }
        else if (data === 'Verified Sender Submission Approved') {
            this.sendMail = false;
            this.currentFilter = 'Verified Sender Submission Approved';
        }
        else if (data === 'Email Sent to INTQ') {
            this.sendMail = false;
            this.currentFilter = 'Email Sent to INTQ';
        }
        else if ((data === 'Rejected')) {
            this.sendMail = false;
            this.currentFilter = 'Rejected';
        }
        else {
            this.sendMail = false;
            this.currentFilter = 'Pending Review';
        }
        if (data === 'Email Sent to INTQ') {
            this.batchId = true;
        }
        else {
            this.batchId = false;
        }
        this.tollFree.reset();
        this.tollFree.patchValue({
            filter_type: this.userType == 1 ? data : ''
        });
    }
    /*for filter function*/
    showfilter() {
        if (this.show_filter == false) {
            this.show_filter = true;
        }
        else {
            this.show_filter = false;
        }
    }
    /*for getting request IDs*/
    sendmailid() {
        const selectedCheckboxIds = this.selectedAwait.map(item => item.unique_request_id);
        let data = {
            requestId: selectedCheckboxIds
        };
        if (confirm("Please click on 'OK' to Submit ")) {
            this.data.sendMailIds(data).subscribe((res) => {
                if (res.status == 200) {
                    let manageDID = res.data;
                    if (manageDID.length > 0) {
                        const groupedData = this.groupfiles_and_did(manageDID);
                        const worksheet = XLSX.utils.json_to_sheet(groupedData);
                        const workbook = { Sheets: { 'did': worksheet }, SheetNames: ['did'] };
                        const excelBuffer = XLSX.write(workbook, { bookType: 'csv', type: 'array' });
                        this.saveAsExcelFile(excelBuffer);
                    }
                    else {
                        this.errMessage = "Data is not Available";
                        setTimeout(() => {
                            this.errMessage = "";
                        }, 5000);
                    }
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            });
        }
        else {
            this.router.navigateByUrl['/toll-free-sms'];
        }
    }
    groupfiles_and_did(data) {
        const groupedData = {};
        data.forEach(entry => {
            const trimmedPhoneNumber = entry.Phone_Numbers.trim();
            const Additional = entry.Additional_Opt_In_Information;
            if (!groupedData[entry.REquest_ID]) {
                groupedData[entry.REquest_ID] = Object.assign(Object.assign({}, entry), { Phone_Numbers: trimmedPhoneNumber });
                groupedData[entry.REquest_ID] = Object.assign(Object.assign({}, entry), { Additional_Opt_In_Information: Additional });
            }
            else {
                groupedData[entry.REquest_ID].Phone_Numbers += ';' + trimmedPhoneNumber;
                groupedData[entry.REquest_ID].Additional_Opt_In_Information += ';' + Additional;
            }
            delete groupedData[entry.REquest_ID].REquest_ID;
        });
        return Object.values(groupedData);
    }
    saveAsExcelFile(csvFile) {
        const selectedCheckboxIds = this.selectedAwait.map(item => item.unique_request_id);
        var target = environment.SERVER + "sentMailtoIntq";
        let data = JSON.stringify({
            requestId: selectedCheckboxIds
        });
        const blob = new Blob([csvFile], { type: 'text/csv' });
        const formData = new FormData();
        formData.append('ATTACHMENTS', blob, "file.csv");
        formData.append('data', data);
        const token = sessionStorage.getItem('authkey');
        this.http.post(target, formData, { headers: { "Authorization": `${token}` } })
            .subscribe((res) => {
            if (res.status == 200) {
                this.responseMessage = res.message;
                setTimeout(() => {
                    window.location.reload();
                    this.responseMessage = "";
                }, 3000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 3000);
            }
        });
    }
    selectAll() {
        if (this.did_status && this.did_status.length > 0) {
            if (this.selectAllChecked) {
                this.checkedNumbers = this.did_status
                    .filter((num) => num.sinch_status === '15')
                    .map((num) => num.did);
            }
            else {
                this.checkedNumbers = [];
            }
        }
        this.did_status.forEach((num) => {
            if (num.sinch_status === '15') {
                num.isChecked = this.selectAllChecked;
            }
        });
        this.isShow = this.checkedNumbers.length > 0;
    }
    setStatus(list) {
        list.forEach(element => {
            if (element.status == 1) {
                element.status = 'Pending Review';
            }
            if (element.status == 2) {
                element.status = 'Rejected';
            }
            if (element.status == 3) {
                element.status = 'Awaiting Downstream Processing';
            }
            if (element.status == 4) {
                element.status = 'Verified Sender Review Process Started';
            }
            if (element.status == 5) {
                element.status = 'Verified Sender Submission Rejected';
            }
            if (element.status == 6) {
                element.status = 'Verified Sender Submission Approved';
            }
            if (element.status == 7) {
                element.status = 'Profile Approved';
            }
        });
    }
    verifyReview(id) {
        this.reviewId = id;
        const user = this.getVerifyData.find((user) => user.unique_request_id === this.reviewId);
        this.user_id = user.iduser;
        this.user_acc = user.idaccount;
        let data = {
            iduser: this.user_id,
            idaccount: this.user_acc,
            id: this.reviewId,
        };
        this.data.approveReview(data).subscribe((res) => {
            if (res.status == 201) {
                this.responseMessage = res.message;
                this.Get_VerifiedList();
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    /*for filter process*/
    onSubmitfilter() {
        this.submitted = true;
        if (this.tollFree.invalid) {
            return false;
        }
        else {
            this.data.applyTollfreeFilter(this.tollFree.value).subscribe((res) => {
                if (res.status == 200) {
                    this.Verifiedfilter = res.data;
                    this.VerifiedfilterCSV = res.data;
                    for (const itemVerifySender of this.Verifiedfilter) {
                        const uniqueRequestId = itemVerifySender.unique_request_id;
                        const matchingBatchData = this.batchdata.find(batchItem => batchItem.verified_sender_id && batchItem.verified_sender_id.includes(uniqueRequestId));
                        if (matchingBatchData) {
                            itemVerifySender.batch_id = matchingBatchData.batch_id;
                        }
                    }
                    if (this.userType == 1) {
                        if (this.currentFilter == 'Pending Review') {
                            $('#basic-datatables1').DataTable().clear();
                            $('#basic-datatables1').DataTable().destroy();
                            this.pending = this.Verifiedfilter;
                            this.setStatus(this.pending);
                        }
                        if (this.currentFilter == 'Rejected') {
                            $('#basic-datatables2').DataTable().clear();
                            $('#basic-datatables2').DataTable().destroy();
                            this.rejected = this.Verifiedfilter;
                            this.setStatus(this.rejected);
                        }
                        if (this.currentFilter == 'Awaiting Downstream Processing') {
                            $('#basic-datatables3').DataTable().clear();
                            $('#basic-datatables3').DataTable().destroy();
                            this.Awaiting = this.Verifiedfilter;
                            this.setStatus(this.Awaiting);
                        }
                        if (this.currentFilter == 'Verified Sender Review Process Started') {
                            $('#basic-datatables4').DataTable().clear();
                            $('#basic-datatables4').DataTable().destroy();
                            this.verified_started = this.Verifiedfilter;
                            this.setStatus(this.verified_started);
                        }
                        if (this.currentFilter == 'Verified Sender Submission Rejected') {
                            $('#basic-datatables5').DataTable().clear();
                            $('#basic-datatables5').DataTable().destroy();
                            this.verified_rejected = this.Verifiedfilter;
                            this.setStatus(this.verified_rejected);
                        }
                        if (this.currentFilter == 'Verified Sender Submission Approved') {
                            $('#basic-datatables6').DataTable().clear();
                            $('#basic-datatables6').DataTable().destroy();
                            this.verified_approved = this.Verifiedfilter;
                            this.setStatus(this.verified_approved);
                        }
                    }
                    else {
                        $('#basic-datatables7').DataTable().clear();
                        $('#basic-datatables7').DataTable().destroy();
                        this.verified = this.Verifiedfilter;
                        this.setStatus(this.verified);
                    }
                    $.getScript('./assets/tollfree.js');
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = '';
                    }, 5000);
                }
            });
        }
    }
    /*for email Send filter*/
    Emailfilter() {
        this.submitted = true;
        if (this.tollFree.invalid) {
            return false;
        }
        else {
            this.data.emailTollfreeFilter(this.tollFree.value).subscribe(res => {
                if (res.status == 200) {
                    this.Verifiedfilter = res.data;
                    this.VerifiedfilterCSV = res.data;
                    if (this.userType == 1) {
                        if (this.currentFilter == "Email Sent to INTQ") {
                            $('#basic-datatabless').DataTable().clear();
                            $('#basic-datatabless').DataTable().destroy();
                            this.batchdata = this.Verifiedfilter;
                            $.getScript('./assets/tollfree.js');
                        }
                    }
                    else {
                        $('#basic-datatabless').DataTable().clear();
                        $('#basic-datatabless').DataTable().destroy();
                        this.verified = this.Verifiedfilter;
                        this.setStatus(this.verified);
                    }
                    $.getScript('./assets/tollfree.js');
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            });
        }
    }
    downloadCSVFileEMail() {
        this.Emailfilter();
        setTimeout(() => {
            if (this.VerifiedfilterCSV.length > 0) {
                let NewFilteredRes = this.VerifiedfilterCSV.map((item) => {
                    const { batch_id, created_at } = item;
                    const Batch_ID = batch_id;
                    const formattedDate = new Date(created_at).toLocaleDateString('en-US');
                    return { 'Batch Id': Batch_ID, Date: formattedDate };
                });
                const worksheet = XLSX.utils.json_to_sheet(NewFilteredRes);
                const workbook = { Sheets: { TollFree: worksheet }, SheetNames: ['TollFree'] };
                const excelBuffer = XLSX.write(workbook, { bookType: 'csv', type: 'array' });
                this.saveAsExcelFile1(excelBuffer, 'TollFree');
            }
            else {
                this.errMessage = 'No Record Available!';
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            }
        }, 2000);
    }
    batchData() {
        this.data.getBatch().subscribe(res => {
            if (res.status == 200) {
                $('#basic-datatabless').dataTable().fnClearTable();
                $('#basic-datatabless').dataTable().fnDraw();
                $('#basic-datatabless').dataTable().fnDestroy();
                this.batchdata = res.data;
                //$.getScript('./assets/tollfree.js');
            }
            else {
                this.errMessage = "";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    /*closed here filter email send*/
    resetfilter() {
        this.submitted = false;
        this.tollFree.reset();
        this.tollFree.get('statusResponse').setValue('');
        this.tollFree.patchValue({
            filter_type: this.userType === 1 ? this.currentFilter : ''
        });
        this.Get_VerifiedList();
        this.batchData();
        this.currentFilter = this.currentFilter;
    }
    /*for download csv files*/
    downloadCSVFile() {
        this.onSubmitfilter();
        setTimeout(() => {
            if (this.VerifiedfilterCSV.length > 0) {
                let NewFilteredRes = this.VerifiedfilterCSV.map((item) => {
                    if (this.userType === 1) {
                        const { idaccount, first_name, last_name, created_at, status, unique_request_id } = item;
                        const SAN = 100000000 + idaccount;
                        const Customer_Name = `${first_name} ${last_name}`;
                        const Status = status;
                        const Request_ID = unique_request_id;
                        const formattedDate = new Date(created_at).toLocaleDateString('en-US');
                        return { 'Request ID': Request_ID, 'Customer Name': Customer_Name, SAN, Status, Date: formattedDate };
                    }
                    else {
                        const { first_name, last_name, created_at, status, business_name, unique_request_id } = item;
                        // const CustomerName = `${first_name} ${last_name}`;
                        const BusinesName = business_name;
                        const Status = status;
                        const Request_ID = unique_request_id;
                        const formattedDate = new Date(created_at).toLocaleDateString('en-US');
                        return { 'Request ID': Request_ID, 'Business Name': BusinesName, Status, Date: formattedDate };
                    }
                });
                const worksheet = XLSX.utils.json_to_sheet(NewFilteredRes);
                const workbook = { Sheets: { TollFree: worksheet }, SheetNames: ['TollFree'] };
                const excelBuffer = XLSX.write(workbook, { bookType: 'csv', type: 'array' });
                this.saveAsExcelFile1(excelBuffer, 'TollFree');
            }
            else {
                this.errMessage = 'No Record Available!';
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            }
        }, 2000);
    }
    saveAsExcelFile1(buffer, fileName) {
        const data = new Blob([buffer], {
            type: this.EXCEL_TYPE
        });
        saveAs(data, fileName + new Date().getTime() + this.EXCEL_EXTENSION);
    }
    savedDownloadFile(path, batchId) {
        if (path) {
            fetch(path).then(resp => resp.arrayBuffer()).then(resp => {
                const file = new Blob([resp], { type: 'text/csv' });
                const fileURL = URL.createObjectURL(file);
                const link = document.createElement('a');
                link.href = fileURL;
                link.download = batchId + '-CSVFile.csv';
                link.click();
            });
        }
        else {
            this.errMessage = "File Type is Corrupted!";
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        }
    }
    rejectReview(id) {
        this.unique_id = id;
        const user = this.getVerifyData.find((user) => user.unique_request_id === this.unique_id);
        this.user_id = user.iduser;
        this.user_acc = user.idaccount;
        let data = {
            iduser: this.user_id,
            idaccount: this.user_acc,
            id: this.unique_id,
        };
        this.data.rejectReview(data).subscribe((res) => {
            if (res.status === 201) {
                this.responseMessage = res.message;
                this.Get_VerifiedList();
                setTimeout(() => {
                    this.responseMessage = '';
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            }
        });
    }
    resendEmail(id) {
        this.bach_id = id;
        this.data.resendEmail(this.bach_id).subscribe((res) => {
            if ((res.status = 200)) {
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = '';
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            }
        });
    }
    openModal(id, user, account) {
        this.unique_id = id;
        this.idaccount1 = account;
        this.iduser1 = user;
        this.submitted = false;
        this.rejectForm.reset();
        const rejectModal = document.getElementById('reject');
        $(rejectModal).modal('show');
    }
    getNumber(id) {
        this.selectAllChecked = false;
        this.ShowMessage = false;
        this.did_status = [];
        this.number = [];
        this.isShow = false;
        this.checkedNumbers = [];
        this.reques_id = id;
        this.data.getAssign_number().subscribe((result) => {
            if (result.status === 200) {
                const dataArray = result.data;
                const groupedData = {};
                dataArray.forEach((item) => {
                    const requestId = item.requestId;
                    const didList = item.did.split(',');
                    if (!groupedData[requestId]) {
                        groupedData[requestId] = [item];
                    }
                    else {
                        const existingItem = groupedData[requestId][0];
                        existingItem.did += ',' + didList.join(',');
                    }
                });
                this.AssignNum = Object.values(groupedData);
                this.AssignNum = [].concat(...this.AssignNum);
            }
            const user = this.AssignNum.find((user) => user.requestId === this.reques_id);
            if (user === null || user === void 0 ? void 0 : user.did) {
                this.number = this.number || [];
                const numbersArray = user.did.split(',');
                this.number = this.number.concat(numbersArray);
                this.data.get_status(this.number).subscribe((result) => {
                    if (result.status == 200) {
                        this.did_sinch = result.data;
                        this.did_status = this.did_sinch.filter((obj, index, self) => index === self.findIndex((o) => o.did === obj.did));
                        if (this.number.length === 0 ||
                            !this.did_status.some((num) => num.sinch_status === '15')) {
                            this.ShowMessage = true;
                        }
                        const Modal = document.getElementById('viewalldata1');
                        $(Modal).modal('show');
                    }
                });
            }
            else {
                this.ShowMessage = true;
                const Modal = document.getElementById('viewalldata1');
                $(Modal).modal('show');
            }
        });
    }
    onSubmit() {
        const user = this.getVerifyData.find((user) => user.unique_request_id === this.reques_id);
        this.user_id = user.iduser;
        const account = user.idaccount;
        let data = {
            iduser: this.user_id,
            number: this.checkedNumbers,
            idaccount: account,
        };
        this.data.did_change(data).subscribe((result) => {
            if ((result.status = 200)) {
                this.responseMessage = result.message;
                const Modal = document.getElementById('viewalldata1');
                $(Modal).modal('hide');
                this.responseMessage = result.message;
                setTimeout(() => {
                    this.responseMessage = '';
                }, 5000);
            }
            else {
                this.errMessage = result.message;
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            }
        });
    }
    onRejectt() {
        const user = this.getVerifyData.find((user) => user.unique_request_id === this.reques_id);
        this.user_id = user.iduser;
        const account = user.idaccount;
        let data = {
            iduser: this.user_id,
            number: this.checkedNumbers,
            idaccount: account,
        };
        this.data.did_reject(data).subscribe((result) => {
            if ((result.status = 200)) {
                this.responseMessage = result.message;
                const Modal = document.getElementById('viewalldata1');
                $(Modal).modal('hide');
                this.responseMessage = result.message;
                setTimeout(() => {
                    this.responseMessage = '';
                }, 5000);
            }
            else {
                this.errMessage = result.message;
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            }
        });
    }
    awaiting_getnumber(id) {
        this.ShowMessage = false;
        this.did_status = [];
        this.number = [];
        this.reques_id = id;
        this.data.getAssign_number().subscribe((result) => {
            if (result.status === 200) {
                const dataArray = result.data;
                const groupedData = {};
                dataArray.forEach((item) => {
                    const requestId = item.requestId;
                    const didList = item.did.split(',');
                    if (!groupedData[requestId]) {
                        groupedData[requestId] = [item];
                    }
                    else {
                        const existingItem = groupedData[requestId][0];
                        existingItem.did += ',' + didList.join(',');
                    }
                });
                this.AssignNum = Object.values(groupedData);
                this.AssignNum = [].concat(...this.AssignNum);
            }
            const user = this.AssignNum.find((user) => user.requestId === this.reques_id);
            if (user === null || user === void 0 ? void 0 : user.did) {
                this.number = this.number || [];
                const numbersArray = user.did.split(',');
                this.number = this.number.concat(numbersArray);
                if (this.number.length === 0) {
                    this.ShowMessage = true;
                }
                const Modal = document.getElementById('viewalldata11');
                $(Modal).modal('show');
            }
            else {
                this.ShowMessage = true;
                const Modal = document.getElementById('viewalldata11');
                $(Modal).modal('show');
            }
        });
    }
    messageshow() {
        const fromDate = this.tollFree.get('from_date').value;
        const toDate = this.tollFree.get('to_date').value;
        const currentDate = new Date();
        if ((!fromDate && !toDate)) {
        }
        else if ((fromDate == null || !fromDate) && (toDate != null)) {
            this.tollFree.get('from_date').setErrors({ 'dateRange': 'Please select From Date' });
        }
        else if ((fromDate != null) && (toDate == null || !toDate)) {
            this.tollFree.get('to_date').setErrors({ 'dateRange': 'Please select To Date' });
        }
        else if (fromDate && toDate && new Date(toDate) < new Date(fromDate)) {
            this.tollFree.get('to_date').setErrors({ 'dateRange': 'To date cannot be smaller than from date' });
            return;
        }
        else if (toDate && new Date(toDate) > currentDate) {
            this.tollFree.get('to_date').setErrors({ 'dateRange': 'To date cannot be greater than current date' });
            return;
        }
        else if (fromDate && new Date(fromDate) > currentDate) {
            this.tollFree.get('from_date').setErrors({ 'dateRange': 'From date cannot be greater than current date' });
            return;
        }
        else {
            this.tollFree.get('from_date').setErrors(null);
            this.tollFree.get('to_date').setErrors(null);
        }
    }
    ngOnDestroy() {
        this.viewalldata11.nativeElement.click();
        this.viewalldata1.nativeElement.click();
    }
};
__decorate([
    ViewChild('checkboxes')
], TollfreesmsComponent.prototype, "checkboxes", void 0);
__decorate([
    ViewChild('viewalldata11')
], TollfreesmsComponent.prototype, "viewalldata11", void 0);
__decorate([
    ViewChild('viewalldata1')
], TollfreesmsComponent.prototype, "viewalldata1", void 0);
TollfreesmsComponent = __decorate([
    Component({
        selector: 'app-tollfreesms',
        templateUrl: './tollfreesms.component.html',
        styleUrls: ['./tollfreesms.component.css']
    })
], TollfreesmsComponent);
export { TollfreesmsComponent };
//# sourceMappingURL=tollfreesms.component.js.map