import { __decorate } from "tslib";
import { Component, ViewChild } from '@angular/core';
import { Validators } from '@angular/forms';
let VerifysenderdetailComponent = class VerifysenderdetailComponent {
    constructor(router, http, data, route, fb) {
        this.router = router;
        this.http = http;
        this.data = data;
        this.route = route;
        this.fb = fb;
        this.verified = [];
        this.responseMessage = "";
        this.submitted = false;
        this.number = [];
        this.selectedFile = [];
    }
    ngOnInit() {
        let session$ = sessionStorage.getItem("isLoggedIn");
        let session = JSON.parse(session$);
        this.userType = session.type;
        this.iduser = session.iduser;
        this.idaccount = session.idaccount;
        this.data.get_tollfree_detail().subscribe((result) => {
            this.userdetail = result;
            this.header_detail = this.userdetail[1].viewDetails;
        });
        this.route.paramMap.subscribe((params) => {
            this.id = params.get('unique_request_id');
            this.viewdetailsdata();
        });
        this.rejectForm = this.fb.group({
            reject_text: ['', [Validators.required, Validators.pattern(/^[^\s].*$/)]],
        });
    }
    viewdetailsdata() {
        let payLoad = JSON.stringify({
            id: this.id,
        });
        this.data.view_VerifySender(payLoad).subscribe((result) => {
            if (result.status == 200) {
                this.view_data = result.data[0];
                this.eventDetails = result.data;
                this.Vstatus = this.view_data.status;
                this.key = this.view_data.file_upload_key;
                if (!this.key) {
                    this.files = [];
                }
                if (this.key) {
                    const filePaths = this.view_data.file_paths.split(',');
                    this.files = [];
                    filePaths.forEach((filePath, index) => {
                        const fileName = filePath.substring(filePath.lastIndexOf('/') + 1);
                        const fileObject = {
                            file: filePath.trim(),
                            name: fileName,
                        };
                        this.files.push(fileObject);
                    });
                }
                $('#basic-datatables3').dataTable().fnClearTable();
                $('#basic-datatables3').dataTable().fnDraw();
                $('#basic-datatables3').dataTable().fnDestroy();
                $.getScript('./assets/tollfree.js');
            }
        });
    }
    verifySender() {
        let data = {
            idaccount: this.view_data.idaccount,
            iduser: this.view_data.iduser,
            id: this.view_data.unique_request_id
        };
        this.data.approveSender(data).subscribe((res) => {
            if (res.status == 201) {
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                    this.router.navigate(['./toll-free-sms']);
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    rejectSender() {
        this.submitted = true;
        if (this.rejectForm.invalid) {
            return false;
        }
        const data = {
            idaccount: this.view_data.idaccount,
            iduser: this.view_data.iduser,
            id: this.view_data.unique_request_id,
            reject_text: this.rejectForm.get('reject_text').value,
        };
        this.data.rejectSenderStatus(data).subscribe((res) => {
            if (res.status === 201) {
                this.responseMessage = res.message;
                this.closeIcon.nativeElement.click();
                setTimeout(() => {
                    this.responseMessage = '';
                    this.router.navigate(['./toll-free-sms']);
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            }
        });
    }
    OnReset() {
        this.submitted = false;
        this.rejectForm.reset();
    }
    toggleDescription(data) {
        data.moreShown = !data.moreShown;
    }
    downloadFile(data) {
        if (data.file) {
            const a = document.createElement('a');
            a.href = data.file;
            a.download = data.name;
            a.click();
        }
    }
    viewFile(data) {
        const fileExtension = data.name.split('.').pop();
        const pdfModal = document.getElementById('modalPdfAppeal');
        const imageModal = document.getElementById('modalImageAppeal');
        const docxModal = document.getElementById('modalDocxAppeal');
        const videoModal = document.getElementById('modalVideoForFile');
        const modalImage = document.getElementById('modalImage');
        const modalImage123 = document.getElementById('modalPdf');
        const videoModal12 = document.getElementById('videoModal');
        if (fileExtension === "png" || fileExtension === "jpg" || fileExtension === "jpeg") {
            const imageData = data.file;
            modalImage.src = data.file;
            // Open the modal for images
            $(imageModal).modal('show');
        }
        else if (fileExtension === 'pdf') {
            // const pdfData = data.file
            modalImage123.src = data.file;
            // Open the modal for non-image files
            $(pdfModal).modal('show');
        }
        else if (fileExtension === 'mp4') {
            // const videoData = data.file;
            videoModal12.src = data.file;
            // Open Modal for Video
            $(videoModal).modal('show');
            $(videoModal).on('hidden.bs.modal', function () {
                videoModal12.pause();
            });
        }
        else {
            if (data.file) {
                const a = document.createElement('a');
                a.href = data.file;
                a.download = data.name;
                document.body.appendChild(a);
                a.click();
                document.body.removeChild(a);
                $(docxModal).modal('show');
            }
        }
    }
    ngOnDestroy() {
        this.reject.nativeElement.click();
        this.modalVideoForFile.nativeElement.click();
        this.modalPdfAppeal.nativeElement.click();
        this.modalImageAppeal.nativeElement.click();
    }
};
__decorate([
    ViewChild('closeIcon')
], VerifysenderdetailComponent.prototype, "closeIcon", void 0);
__decorate([
    ViewChild('reject')
], VerifysenderdetailComponent.prototype, "reject", void 0);
__decorate([
    ViewChild('modalImageAppeal')
], VerifysenderdetailComponent.prototype, "modalImageAppeal", void 0);
__decorate([
    ViewChild('modalPdfAppeal')
], VerifysenderdetailComponent.prototype, "modalPdfAppeal", void 0);
__decorate([
    ViewChild('modalVideoForFile')
], VerifysenderdetailComponent.prototype, "modalVideoForFile", void 0);
VerifysenderdetailComponent = __decorate([
    Component({
        selector: 'app-verifysenderdetail',
        templateUrl: './verifysenderdetail.component.html',
        styleUrls: ['./verifysenderdetail.component.css']
    })
], VerifysenderdetailComponent);
export { VerifysenderdetailComponent };
//# sourceMappingURL=verifysenderdetail.component.js.map