import { __decorate } from "tslib";
import { Component, ViewChild, Input } from '@angular/core';
import { FormControl } from '@angular/forms';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { BehaviorSubject } from 'rxjs';
import { MatAccordion } from '@angular/material/expansion';
let DeleteuserComponent = class DeleteuserComponent extends AppComponentClass {
    constructor(data, router, fb, dialog, route) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.dialog = dialog;
        this.route = route;
        this.curuserid = -1;
        this.searchText = { count: 0 };
        this.p = 1;
        this.userlist$ = new BehaviorSubject([{ iduser: -1, first_name: "", last_name: "", user_name: "", email: "", contact_number: "", password: "", profile_pic: "", pShow: false, pswd: "password" }]);
        this.userlist = this.userlist$.asObservable();
        this.isDeleted = '2';
        this.page = 1;
        this.count = 0;
        this.tableSize = 50;
        this.tableSizes = [50, 100, 150];
        this.ids = [];
        this.responseMessage = "";
        this.errMessage = "";
        this.deleteUsers = [];
        this.dids = [];
        this.planname = "";
        this.ismonthly = false;
        this.price = "";
        this.subCustomer = [];
        this.returnsms = false;
        this.checkdelete = false;
        this.active = {
            style1: "cursor: pointer;",
            style2: "cursor: pointer;",
            style3: "cursor: pointer;",
        };
        this.invoicePdfDetails = [];
    }
    ngOnInit() {
        this.data.getuserheader().subscribe((result) => {
            this.userlistheader = result.DeletedAdminHeader;
        });
        this.data.getInvoicePdfData().subscribe((res) => {
            this.invoicePdfDetails = res.data;
        });
        // To load the users list
        this.GetUsers();
        this.filterForm = this.fb.group({
            selectedUser: new FormControl(''),
            didnumber: new FormControl(''),
            didnpa: new FormControl(''),
            selectState: new FormControl(''),
            selectSMS: new FormControl('')
        });
        this.data.getuserheader().subscribe((result) => {
            this.subuserlistheader = result.headers_sub_details1;
        });
    }
    editSubUserdata(idaccount, iduser) {
        this.user_id = iduser;
        this.account_id = idaccount;
        this.data.getSubListUsers({ idaccount: idaccount, iduser: iduser, type: "profile" }).subscribe((result) => {
            this.userlist = result.data[0];
            this.userlength = result.data[0].length;
            this.subCustomer = result.data[0];
            $('#basic-datatabless2').dataTable().fnClearTable();
            $('#basic-datatabless2').dataTable().fnDraw();
            $('#basic-datatabless2').dataTable().fnDestroy();
            $.getScript('./assets/table.js');
        }, err => {
            console.log(err.message);
        });
    }
    /**
     * It will load the user's list
     */
    GetUsers() {
        this.data.getUsers("main").subscribe(res => {
            $('#basic-datatables04').dataTable().fnClearTable();
            $('#basic-datatables04').dataTable().fnDraw();
            $('#basic-datatables04').dataTable().fnDestroy();
            this.userlist = res.data[0];
            this.deleteUsers = [];
            this.userlist.forEach(element => {
                if (element.is_deleted == 2) {
                    this.deleteUsers.push(element);
                    let invoicePDF = this.invoicePdfDetails.find(i => i.idaccount == element.idaccount);
                    if (invoicePDF != undefined) {
                        element.invoice_pdf = invoicePDF.path;
                    }
                    else {
                        element.invoice_pdf = '';
                    }
                }
            });
            $.getScript('./assets/table.js');
            this.countUser = res.data[0];
        });
    }
    callCheck() {
        this.returnsms = false;
    }
    onYes() {
        this.data1 = {
            sesiduser: this.user_id,
            sesidaccount: this.account_id,
            isDeleted: this.isDeleted
        };
        if (!this.checkdelete || !this.data1.sesiduser || !this.data1.isDeleted) {
            this.returnsms = true;
            return;
        }
        else {
            this.data.onFinalDeleteAccount(this.data1).subscribe((res) => {
                if (res.status == 201) {
                    $('#DeleteModal').modal('hide');
                    this.responseMessage = "You have successfully deleted this account!";
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 3000);
                }
            });
        }
    }
    showAllCampData(idaccount, iduser) {
        this.user_id = iduser;
        this.account_id = idaccount;
        let payLoad = JSON.stringify({
            idaccount: idaccount,
            iduser: iduser
        });
        // get campaign
        this.campaigns = '';
        this.data.getCampaignForReview(payLoad).subscribe(result => {
            if (result.status == 200) {
                this.campaigns = result.data.length;
            }
            else {
                this.errMessage = result.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
        //Balance
        this.balance = '';
        this.data.getcustBalance({ idaccount: idaccount, iduser: iduser }).subscribe(response => {
            if (response.status == 200) {
                if (response.data.length > 0) {
                    this.balance = response.data[0].balance;
                }
            }
            else {
                this.errMessage = response.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
        //subCustomer
        this.userlength = '';
        this.data.getSubListUsers({ idaccount: idaccount, iduser: iduser, type: "profile" }).subscribe((result) => {
            if (result.status == 200) {
                this.userlength = result.data[0].length;
            }
        });
        // Dids
        this.dids = [];
        this.filterForm = this.fb.group({
            selectedUser: this.user_id + '-' + this.account_id
        });
        this.dids[0] = 'comming...';
        this.data.custDidsCount(this.filterForm.value).subscribe(res => {
            if (res.status == 200) {
                this.dids = res.data.length;
            }
        });
        // get plan
        this.planname = '';
        this.data.getSubscriptionPlan(payLoad).subscribe(result => {
            if (result.status == 200) {
                this.tmplist = result.data[0];
                if (this.tmplist != undefined) {
                    switch (this.tmplist.idtariff) {
                        case 142:
                        case "142":
                            {
                                this.planname = "LAUNCH PLAN";
                                this.price = "Pay As You Go";
                            }
                            break;
                        case 143:
                        case "143":
                            {
                                this.planname = "GROWTH PLAN";
                                this.price = "99";
                                this.ismonthly = true;
                            }
                            break;
                        case 145:
                        case "145":
                            {
                                this.planname = "SCALE PLAN";
                                this.price = "2499";
                                this.ismonthly = true;
                            }
                            break;
                        default:
                            this.planname = "CUSTOM PLAN";
                            break;
                    }
                }
            }
            else {
                this.errMessage = result.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    restoreUser() {
        if (confirm("Are you sure you want Restore Account!")) {
            let payLoad = {
                sesidaccount: this.account_id,
                iduser: this.user_id,
                isDeleted: 0
            };
            this.data.onDeleteAccount(payLoad).subscribe((res) => {
                if (res.status == 201) {
                    this.responseMessage = "Customer Account Restored Succussfully.";
                    setTimeout(() => {
                        this.responseMessage = "";
                        window.location.reload();
                    }, 3000);
                }
            });
        }
    }
    loginUser(data) {
        let userLogin = { username: data.user_name, password: data.password, typeCheck: 'admin_checking', sessionType: "MORPHING" };
        this.data.userLogin(userLogin).subscribe(res => {
            if (res.authkey) {
                let userData = res;
                this.router.navigate([], { state: { userData: userData } }).then(result => {
                    window.open(window.location.origin + '/#/dashboards/dashboard/' + userData.authkey, '_blank');
                });
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
};
__decorate([
    ViewChild(MatAccordion)
], DeleteuserComponent.prototype, "accordion", void 0);
__decorate([
    Input()
], DeleteuserComponent.prototype, "usertype", void 0);
__decorate([
    Input()
], DeleteuserComponent.prototype, "curuserid", void 0);
DeleteuserComponent = __decorate([
    Component({
        selector: 'app-deleteuser',
        templateUrl: './deleteuser.component.html',
        styleUrls: ['./deleteuser.component.css']
    })
], DeleteuserComponent);
export { DeleteuserComponent };
//# sourceMappingURL=deleteuser.component.js.map