import { __decorate } from "tslib";
import { Component, ViewChild } from '@angular/core';
import { Validators } from '@angular/forms';
let DomainBlockerComponent = class DomainBlockerComponent {
    constructor(data, fb, route, router) {
        this.data = data;
        this.fb = fb;
        this.route = route;
        this.router = router;
        this.submitted = false;
        this.responseMessage = "";
        this.modeltext = '';
        this.messs = '';
        this.saveDomain = 'Submit';
        this.originalDomenId = '';
    }
    ngOnInit() {
        this.domainForm = this.fb.group({
            ip: ['', [Validators.pattern('(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)')]],
            email: ['', [Validators.pattern("^([A-Za-z0-9._%+-]+)@([A-Za-z0-9-]+\\.[A-Za-z]{2,4})(\\.[A-Za-z]{2,4})?$")]],
            specific_domain: ['', [Validators.pattern('^(?!-)[A-Za-z0-9-]+([\\-\\.]{1}[a-z0-9]+)*\\.[A-Za-z]{2,6}$')]],
            first_name: [''],
            last_name: [''],
            contact: [''],
            domen_id: ['']
        });
        this.getDomenlist();
    }
    onKeyPress(event) {
        this.messs = '';
    }
    blankMsg(event) {
        this.messs = '';
        this.domainForm.reset({
            domen_id: this.originalDomenId
        });
    }
    getDomenlist() {
        this.data.getDomainBlock().subscribe(res => {
            if (res.status == 200) {
                this.domainInfo = res.data;
                $("#basic-datatabless12").DataTable().clear();
                $("#basic-datatabless12").DataTable().destroy();
                $.getScript('./assets/table.js');
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    showdata(data) {
        this.onClose();
        this.modeltext = 'Add Domain Block',
            this.saveDomain = 'Submit';
        if (data.domain_block_id) {
            this.modeltext = 'Edit Domain Block';
            this.saveDomain = 'Update';
            this.domainForm.patchValue({
                ip: data.ip_address,
                email: data.email,
                specific_domain: data.domain_name,
                first_name: data.first_name,
                last_name: data.last_name,
                contact: data.contact,
                domen_id: data.domain_block_id
            });
            this.domenIdToUpdate = data.domain_block_id;
        }
        else {
            //reset form
        }
    }
    onsubmit() {
        if (this.domainForm.invalid) {
            this.submitted = true;
            // this.submitted = false;
            return;
        }
        else {
            if (this.domainForm.value.ip || this.domainForm.value.email ||
                this.domainForm.value.specific_domain || this.domainForm.value.first_name || this.domainForm.value.last_name || this.domainForm.value.contact) {
                this.domainForm.value.ip = this.domainForm.value.ip == null ? '' : this.domainForm.value.ip;
                this.domainForm.value.email = this.domainForm.value.email == null ? '' : this.domainForm.value.email;
                this.domainForm.value.specific_domain = this.domainForm.value.specific_domain == null ? '' : this.domainForm.value.specific_domain;
                this.domainForm.value.first_name = this.domainForm.value.first_name == null ? '' : this.domainForm.value.first_name;
                this.domainForm.value.last_name = this.domainForm.value.last_name == null ? '' : this.domainForm.value.last_name;
                this.domainForm.value.contact = this.domainForm.value.contact == null ? '' : this.domainForm.value.contact;
                if (this.domenIdToUpdate) {
                    this.domainForm.value.domen_id = this.domenIdToUpdate;
                    this.data.updateDomainBlock(this.domainForm.value).subscribe(res => {
                        if (res.status == 200) {
                            this.responseMessage = res.message;
                            setTimeout(() => {
                                this.responseMessage = "";
                            }, 3000);
                            document.getElementById("add-domain").click();
                            this.getDomenlist();
                            this.domainForm.reset();
                            this.closeModal.nativeElement.click();
                        }
                        else {
                            this.errMessage = res.message;
                            setTimeout(() => {
                                this.errMessage = "";
                            }, 3000);
                        }
                    });
                }
                else {
                    this.saveDomain = 'Submit';
                    this.data.saveDomainBlock(this.domainForm.value).subscribe(res => {
                        if (res.status == 200) {
                            this.responseMessage = res.message;
                            setTimeout(() => {
                                this.responseMessage = "";
                            }, 3000);
                            document.getElementById("add-domain").click();
                            this.getDomenlist();
                            this.domainForm.reset();
                            this.closeModal.nativeElement.click();
                        }
                        else {
                            this.errMessage = res.message;
                            setTimeout(() => {
                                this.errMessage = "";
                            }, 3000);
                        }
                    });
                }
            }
            else {
                this.messs = "Please Enter atleast 1 field!";
            }
        }
    }
    onClose() {
        this.domainForm.reset();
        this.messs = '';
    }
    deleteDomen(id) {
        if (confirm("Are you sure you want delete data!")) {
            this.data.onDeleteDomainBlock(id).subscribe(res => {
                if (res.status == 201) {
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 3000);
                    this.getDomenlist();
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    });
                }
            }, error => {
                this.responseMessage = error.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 3000);
            });
        }
        else {
            return;
        }
    }
};
__decorate([
    ViewChild('closebutton')
], DomainBlockerComponent.prototype, "closebutton", void 0);
__decorate([
    ViewChild('closeModal')
], DomainBlockerComponent.prototype, "closeModal", void 0);
DomainBlockerComponent = __decorate([
    Component({
        selector: 'app-domain-blocker',
        templateUrl: './domain-blocker.component.html',
        styleUrls: ['./domain-blocker.component.css']
    })
], DomainBlockerComponent);
export { DomainBlockerComponent };
//# sourceMappingURL=domain-blocker.component.js.map