import { __decorate } from "tslib";
import { Component, Input } from '@angular/core';
import { Validators } from '@angular/forms';
let PasswordComponent = class PasswordComponent {
    constructor(data, fb, activeModal, config, modalService) {
        this.data = data;
        this.fb = fb;
        this.activeModal = activeModal;
        this.config = config;
        this.modalService = modalService;
        this.submitted3 = false;
        this.key = -1;
        this.responseMessage = "";
        this.errMessage = "";
        this.eyetoggle = false;
        this.eyetoggle1 = false;
        this.eyetoggle2 = false;
        this.showErr = "";
        this.oldPass = "";
        config.backdrop = 'static';
        config.keyboard = false;
    }
    ngOnInit() {
        this.changepasswordForm = this.fb.group({
            old_password: ['', [Validators.required]],
            new_password: ['', [Validators.required, Validators.minLength(8)]],
            confirm_password: ['', [Validators.required, Validators.minLength(8)]]
        });
    }
    change_password() {
        this.submitted3 = true;
        if (this.changepasswordForm.invalid) {
            return false;
        }
        else {
            this.key = this.currentUser.iduser;
            if (this.changepasswordForm.get('new_password').value == this.changepasswordForm.get('old_password').value)
                alert("New password should be different from old password");
            else {
                if (this.changepasswordForm.get('new_password').value == this.changepasswordForm.get('confirm_password').value) {
                    this.data.updatePass(JSON.stringify(this.changepasswordForm.value), this.key).subscribe(rs => {
                        if (rs.status == 201) {
                            this.activeModal.close({ message: rs.message, status: true, result: rs.result });
                            this.responseMessage = rs.message;
                            setTimeout(() => {
                                this.responseMessage = "";
                            }, 3000);
                        }
                        else {
                            this.errMessage = rs.message;
                            this.showErr = rs.message;
                            // this.oldPass = rs.result[0]; 
                            setTimeout(() => {
                                this.errMessage = "";
                            }, 3000);
                        }
                    }, err => {
                        this.errMessage = err.message;
                        setTimeout(() => {
                            this.errMessage = "";
                        }, 3000);
                    });
                }
                else {
                    alert("Your entered confirm password does not match");
                }
            }
        }
    }
    closeModal() {
        this.activeModal.close({ message: "", status: false });
    }
    removeErr() {
        this.showErr = '';
    }
    eyeToggle(check) {
        if (check == 1)
            if (this.eyetoggle)
                this.eyetoggle = false;
            else
                this.eyetoggle = true;
        else if (check == 2)
            if (this.eyetoggle1)
                this.eyetoggle1 = false;
            else
                this.eyetoggle1 = true;
        else if (this.eyetoggle2)
            this.eyetoggle2 = false;
        else
            this.eyetoggle2 = true;
    }
};
__decorate([
    Input()
], PasswordComponent.prototype, "currentUser", void 0);
PasswordComponent = __decorate([
    Component({
        selector: 'app-password',
        templateUrl: './password.component.html',
        styleUrls: ['./password.component.css']
    })
], PasswordComponent);
export { PasswordComponent };
//# sourceMappingURL=password.component.js.map