import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
import { AdddialogComponent } from '../../usermanagement/adddialog/adddialog.component';
let UsersettingComponent = class UsersettingComponent {
    constructor(data, dialog, fb) {
        this.data = data;
        this.dialog = dialog;
        this.fb = fb;
        this.searchText = { count: 0 };
        this.pShow = false;
        this.page = 1;
        this.count = 0;
        this.tableSize = 25;
        this.tableSizes = [25, 50, 100];
        this.show = true;
        this.status = false;
        this.isapply = true;
        this.subbmitted = false;
        this.isAutoPayment = false;
        this.isAutoEmail = false;
        this.isAutowebhook = false;
        this.errMessage = "";
    }
    ngOnInit() {
        this.paymentSettingForm = this.fb.group({
            idwallet: [],
            defaultamt: ['', [Validators.required, Validators.min(200), Validators.max(500000)]],
            topup_amount: [''],
            webhook_url: ['']
        });
        this.data.getBalance().subscribe(response => {
            if (response.status == 200) {
                this.paymentSettingForm.patchValue({
                    idwallet: response.data[0].idwallet,
                    defaultamt: response.data[0].min_balance,
                    topup_amount: response.data[0].topup_amount,
                    webhook_url: response.data[0].webhook_url,
                });
                if (response.data[0].status == "true") {
                    this.isAutoPayment = true;
                }
                else {
                    this.isAutoPayment = false;
                }
                if (response.data[0].isEmail == "true") {
                    this.isAutoEmail = true;
                }
                else {
                    this.isAutoEmail = false;
                }
                if (response.data[0].isWebhook == "true") {
                    this.isAutowebhook = true;
                }
                else {
                    this.isAutowebhook = false;
                }
            }
            else {
                this.responseMessage = response.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 3000);
            }
        }, err => {
            this.responseMessage = err.message;
            setTimeout(() => {
                this.responseMessage = "";
            }, 3000);
        });
        this.data.getpaymentsetting().subscribe(res => {
            this.header = res[0].headers_details;
            this.paymentlist = res[0].list;
        });
        this.sessData = JSON.parse(sessionStorage.getItem("isLoggedIn"));
        this.defaultUser = this.sessData.username;
        this.userType = this.sessData.type;
        this.getUser();
        this.data.getuserheader().subscribe((result) => {
            let headers = result.headers_details.slice(0, -2);
            this.userlistheader = headers.slice(0, -1);
            this.userlistheader.push("Action");
        });
    }
    // getUser(){
    //   this.data.getUsers("profile").subscribe(res => {
    //     if (res.data[0]) {
    //       this.userlist = res.data[0];        
    //       this.userlist.forEach(element => {
    //         element.pShow = false;
    //         element.pswd = "password";
    //       });   
    //       $('#basic-datatables14').DataTable().clear();
    //       $('#basic-datatables14').DataTable().destroy();
    //       $.getScript('./assets/table.js');   
    //     }
    //   });
    // }
    getUser() {
        this.data.getUsers("profile").subscribe(res => {
            if (res.data[0]) {
                const uniqueUsers = [];
                this.userlist = res.data[0];
                this.userlist.forEach(element => {
                    const existingUser = uniqueUsers.find(user => user.idaccount === element.idaccount &&
                        user.iduser === element.iduser);
                    if (!existingUser) {
                        element.pShow = false;
                        element.pswd = "password";
                        uniqueUsers.push(element);
                    }
                });
                $('#basic-datatables13').DataTable().clear();
                $('#basic-datatables13').DataTable().destroy();
                $.getScript('./assets/table.js');
                this.userlist = uniqueUsers; // Update the userlist with unique entries
            }
        });
    }
    onPaymentSetting() {
        this.subbmitted = true;
        if (this.paymentSettingForm.invalid) {
            return;
        }
        else {
            if (this.paymentSettingForm.value.idwallet == null || this.paymentSettingForm.value.idwallet == undefined) {
                this.responseMessage = "Add Amount in Your Wallet!";
                setTimeout(() => {
                    this.responseMessage = "";
                }, 3000);
            }
            else {
                this.data.updatePaymentService(this.paymentSettingForm.value).subscribe(response => {
                    if (response.status == 201) {
                        this.responseMessage = response.message;
                        setTimeout(() => {
                            this.responseMessage = "";
                        }, 3000);
                        this.ngOnInit();
                    }
                    else {
                        this.responseMessage = response.message;
                        setTimeout(() => {
                            this.responseMessage = "";
                        }, 3000);
                    }
                }, err => {
                    this.responseMessage = err;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 3000);
                });
            }
        }
    }
    adduser() {
        let tmp = sessionStorage.getItem("isLoggedIn");
        tmp = JSON.parse(tmp);
        const dialogRef = this.dialog.open(AdddialogComponent, {
            width: '600px', disableClose: true,
            data: { iduser: tmp.iduser, type: tmp.type, idaccount: tmp.idaccount, dialogtype: 1, savetype: 0 }
        });
        dialogRef.afterClosed().subscribe(res => {
            if (res == 1) {
                this.responseMessage = "Sub Customer Created Successfully!";
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
                this.getUser();
            }
        });
    }
    keyToggle(id) {
        this.userlist.forEach(element => {
            if (element.iduser == id) {
                if (element.pswd == 'password') {
                    element.pswd = 'text';
                    element.pShow = true;
                }
                else {
                    element.pswd = 'password';
                    element.pShow = false;
                }
            }
        });
    }
    editUser(data) {
        let tmp = sessionStorage.getItem("isLoggedIn");
        tmp = JSON.parse(tmp);
        data["dialogtype"] = 2;
        data["savetype"] = 0;
        const dialogRef = this.dialog.open(AdddialogComponent, {
            width: '600px', disableClose: true,
            data
        });
        dialogRef.afterClosed().subscribe(res => {
            if (res == 1) {
                this.responseMessage = "Sub Customer Updated Successfully!";
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
                this.getUser();
            }
        });
    }
    numberOnly(event) {
        const charCode = (event.which) ? event.which : event.keyCode;
        if (charCode > 31 && (charCode < 48 || charCode > 57)) {
            return false;
        }
        return true;
    }
    DeleteUser(id) {
        if (confirm("Are You Sure ?")) {
            this.data.deleteUserSingleData(id).subscribe(res => {
                if (res.status == 201) {
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 3000);
                    // this.getUser();
                    this.ngOnInit();
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            });
        }
        else {
            return;
        }
    }
    onEmailStatus(e) {
        this.data.updatePaymentService({ idwallet: this.paymentSettingForm.value.idwallet, isAutoEmail: e.checked }).subscribe(response => {
            if (response.status == 201) {
                this.responseMessage = response.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 3000);
                this.ngOnInit();
            }
            else {
                this.responseMessage = response.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 3000);
            }
        }, err => {
            this.responseMessage = err;
            setTimeout(() => {
                this.responseMessage = "";
            }, 3000);
        });
    }
    onAutoPayment(e) {
        this.data.updatePaymentService({ idwallet: this.paymentSettingForm.value.idwallet, isAutoPayment: e.checked }).subscribe(response => {
            if (response.status == 201) {
                this.responseMessage = response.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 3000);
                this.ngOnInit();
            }
            else {
                this.responseMessage = response.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 3000);
            }
        }, err => {
            this.responseMessage = err;
            setTimeout(() => {
                this.responseMessage = "";
            }, 3000);
        });
    }
    onIsWebhook(e) {
        this.data.updatePaymentService({ idwallet: this.paymentSettingForm.value.idwallet, isAutowebhook: e.checked }).subscribe(response => {
            if (response.status == 201) {
                this.responseMessage = response.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 3000);
                this.ngOnInit();
            }
            else {
                this.responseMessage = response.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 3000);
            }
        }, err => {
            this.responseMessage = err;
            setTimeout(() => {
                this.responseMessage = "";
            }, 3000);
        });
    }
};
UsersettingComponent = __decorate([
    Component({
        selector: 'app-usersetting',
        templateUrl: './usersetting.component.html',
        styleUrls: ['./usersetting.component.css']
    })
], UsersettingComponent);
export { UsersettingComponent };
//# sourceMappingURL=usersetting.component.js.map