import { __decorate } from "tslib";
import { Component } from '@angular/core';
let SubusersComponent = class SubusersComponent {
    constructor(data, route) {
        this.data = data;
        this.route = route;
        this.page = 1;
        this.count = 0;
        this.tableSize = 25;
        this.tableSizes = [25, 50, 100];
        this.searchText = { count: 0 };
        this.responseMessage = "";
        this.userlistheader = [];
        this.userlist = [];
    }
    ngOnInit() {
        this.data.getuserheader().subscribe((result) => {
            this.userlistheader = result.headers_details1;
        });
        this.route.paramMap.subscribe((params) => {
            let userData = params.get('id');
            let splitUser = userData.split('-');
            this.iduser = splitUser[0];
            this.idaccount = splitUser[1];
            this.data.getSubListUsers({ idaccount: this.idaccount, iduser: this.iduser, type: "profile" }).subscribe((result) => {
                this.userlist = result.data[0];
                $('#basic-datatablesRs').dataTable().fnClearTable();
                $('#basic-datatablesRs').dataTable().fnDraw();
                $('#basic-datatablesRs').dataTable().fnDestroy();
                $.getScript('./assets/table.js');
            }, err => {
                console.log(err.message);
            });
        });
    }
    deleteUser(iduser, idaccount) {
        let sdata = { "iduser": iduser, "idaccount": idaccount };
        if (confirm("Are you sure you want delete data!")) {
            this.data.deleteUser(JSON.stringify(sdata)).subscribe(result => {
                this.responseMessage = result.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
                this.ngOnInit();
            });
        }
        else {
            "Cancel!";
        }
    }
};
SubusersComponent = __decorate([
    Component({
        selector: 'app-subusers',
        templateUrl: './subusers.component.html',
        styleUrls: ['./subusers.component.css']
    })
], SubusersComponent);
export { SubusersComponent };
//# sourceMappingURL=subusers.component.js.map