import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { SuspendedServicesComponent } from '../suspended-services/suspended-services.component';
let SuspendedUserComponent = class SuspendedUserComponent {
    constructor(data, dialog) {
        this.data = data;
        this.dialog = dialog;
        this.suspendedUsers = [];
        this.responseMessage = "";
        this.errMessage = "";
        this.subscriptionName = this.data.getUpdate().subscribe(message => {
            if (message.text) {
                this.ngOnInit();
            }
        });
    }
    ngOnInit() {
        this.data.getfeatureService().subscribe((res) => {
            this.featureServiceData = res.data;
        });
        this.getUsers();
        this.data.getSuspendedService().subscribe((res) => {
            this.suspendedUserList = res.data;
        });
    }
    getUsers() {
        this.data.getUsers('main').subscribe((res) => {
            this.userlist = res.data[0];
            this.countUser = res.data[0];
            $('#basic-datatablessSus').dataTable().fnClearTable();
            $('#basic-datatablessSus').dataTable().fnDraw();
            $('#basic-datatablessSus').dataTable().fnDestroy();
            $.getScript('./assets/table.js');
            this.suspendedUserList.forEach((suspendedUser) => {
                const suspendSame = this.userlist.find((user) => user.idaccount === suspendedUser.idaccount);
                if (suspendSame) {
                    this.suspendedUsers.push(suspendSame);
                }
            });
        });
    }
    suspendedDialog(featureServiceData, idaccount) {
        const dialogRef = this.dialog.open(SuspendedServicesComponent, {
            width: '50px',
            data: { serviceData: featureServiceData, idaccount: idaccount }
        });
        dialogRef.afterClosed().subscribe(res => {
            if (res.status == 200) {
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
};
SuspendedUserComponent = __decorate([
    Component({
        selector: 'app-suspended-user',
        templateUrl: './suspended-user.component.html',
        styleUrls: ['./suspended-user.component.css']
    })
], SuspendedUserComponent);
export { SuspendedUserComponent };
//# sourceMappingURL=suspended-user.component.js.map