import { __decorate } from "tslib";
import { Component, EventEmitter, Output } from '@angular/core';
import { FormControl, FormGroup, Validators } from '@angular/forms';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let UploadComponent = class UploadComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.onFile = new EventEmitter();
        this.p = 1;
        this.show = false;
        this.buttonName = "Add";
        this.submitted = false;
    }
    ngOnInit() {
        this.fileForm = new FormGroup({
            fileName: new FormControl(null, [Validators.required])
        });
        this.data.getdidupload().subscribe((result) => {
            this.modelform = result;
            console.log(result);
        });
    }
    onFilePicked(event) {
        const file = event.target.files[0];
        this.fileForm.patchValue({
            fileName: file,
        });
        this.fileName = file.name;
        this.fileForm.get("fileName").updateValueAndValidity();
    }
    onSaveFile(event) {
        const file = event.target.files[0];
        this.fileForm.patchValue({
            fileName: file,
        });
        // this.fileName = file.name;
        this.fileForm.get("fileName").updateValueAndValidity();
        this.onFile.emit(this.fileForm.value.fileName);
        // this.data.saveFile(this.fileForm.value.fileName).subscribe(res => {
        // 	console.log(res);
        //   }, error => {
        // 	console.log(error);
        //   });
    }
};
__decorate([
    Output()
], UploadComponent.prototype, "onFile", void 0);
UploadComponent = __decorate([
    Component({
        selector: 'app-upload',
        templateUrl: './upload.component.html',
        styleUrls: ['./upload.component.css']
    })
], UploadComponent);
export { UploadComponent };
//# sourceMappingURL=upload.component.js.map