import { __decorate } from "tslib";
import { HttpHeaders } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { Subject } from "rxjs";
import { environment } from "src/environments/environment";
import { LoaderEnabled } from "../shared/loader/loader.service";
import { AppService } from "../shared/service/AppService.class";
let UsermanagementService = class UsermanagementService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.subjectName = new Subject();
        // getallData(arg0: { iduser: any; idaccount: any; }) {
        //   throw new Error('Method not implemented.');
        // }
        this.httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        this.appmod = "usermanagement";
    }
    sendUpdate(message) {
        this.subjectName.next({ text: message });
    }
    getUpdate() {
        return this.subjectName.asObservable();
    }
    getpaymentsetting() {
        return this.http.get('./assets/paymentsetting.json');
    }
    getratesms() {
        throw new Error('Method not implemented.');
    }
    gettier() {
        return this.http.get('./assets/tier.json');
    }
    userLogin(userLogin) {
        this.appmod = 'login';
        let result = super.saveService(userLogin);
        this.appmod = "";
        return result;
    }
    companyProfile() {
        this.appmod = "company";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    updateCompanyProfile(data) {
        this.appmod = "company";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    AdminRecharge(data) {
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        let apiUrl = environment.SERVER + "recharge";
        return this.http.post(apiUrl, data, { headers: httpHeaders });
    }
    postFile(fileToUpload, sessionid, filetype) {
        const endpoint = environment.SERVER + 'uploads/document_upload';
        const formData = new FormData();
        formData.append('fileKey', fileToUpload, fileToUpload.name);
        formData.append('filetype', filetype);
        formData.append('sessionid', sessionid);
        let httpHeaders = new HttpHeaders();
        return this.http
            .post(endpoint, formData, { headers: httpHeaders });
    }
    saveFile(profile_pic) {
        const apiURL = environment.SERVER + 'uploads/profile_pic';
        let formData = new FormData();
        formData.append("profile_pic", profile_pic);
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, formData, { headers: httpHeaders });
    }
    getBalance() {
        this.appmod = "getbalance";
        let result = this.getService();
        this.appmod = "usermanagement";
        return result;
    }
    getcustBalance(data) {
        const apiURL = environment.SERVER + 'getcustbalance';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: data });
    }
    getFeature() {
        this.appmod = "tier/get_feature";
        let tmp = this.getService();
        this.appmod = "usermanagement";
        return tmp;
    }
    getRate(data) {
        let tmp = this.appmod;
        this.appmod = 'tier/billing_rate';
        let result = super.getService(data);
        this.appmod = tmp;
        return result;
    }
    getSuppliers() {
        this.appmod = "supplier";
        let tmp = this.getService();
        this.appmod = "usermanagement";
        return tmp;
    }
    getUsers(type) {
        this.appmod = "user";
        let tmp = this.getService(type);
        this.appmod = "usermanagement";
        return tmp;
    }
    getResellerUsers() {
        this.appmod = "getResellerUsers";
        let tmp = this.getService();
        this.appmod = "usermanagement";
        return tmp;
    }
    getResellerTariff(type) {
        this.appmod = "getResellerTariff";
        let tmp = this.getService(type);
        this.appmod = "usermanagement";
        return tmp;
    }
    // added function for dropdown userlist
    customerList() {
        this.appmod = "customerList";
        let tmp = this.getService();
        this.appmod = "usermanagement";
        return tmp;
    }
    // closed here
    getSubListUsers(data) {
        const apiURL = environment.SERVER + 'users';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: data });
    }
    getAllUsers(data) {
        const apiURL = environment.SERVER + 'getAllUsers';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: data });
    }
    getSingleUsers() {
        this.appmod = "singleuser";
        let tmp = this.getService();
        this.appmod = "usermanagement";
        return tmp;
    }
    getSingleUsersForAdmin(iduser) {
        this.appmod = "getSingleUsersForAdmin";
        let tmp = this.getService(iduser);
        this.appmod = "usermanagement";
        return tmp;
    }
    getCustSubListUsers(data) {
        const apiURL = environment.SERVER + 'users';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: data });
    }
    getMyTariff(id) {
        this.appmod = "getTariff";
        let data = super.getService(id.toString());
        this.appmod = "usermanagement";
        return data;
    }
    getUser(type) {
        const apiURL = environment.SERVER + 'user';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: type });
        // this.appmod="user";
        // let tmp=this.getService(type);
        // this.appmod="usermanagement";
        // return tmp;
    }
    download(url) {
        return this.http.get(url, {
            responseType: 'blob'
        });
    }
    SaveUserData(data) {
        this.appmod = "user";
        let result = super.saveService(data);
        this.appmod = "usermanagement";
        return result;
    }
    getCountry() {
        this.appmod = "get-country";
        let tmp = this.getService();
        this.appmod = "usermanagement";
        return tmp;
    }
    // updatepaymentsetting
    // @LoaderEnabled()
    // deleteUserSingleData(key: any){
    //   this.appmod="user";
    //   let result = super.deleteService(key);
    //   this.appmod="usermanagement";
    //   return result;
    // }
    SaveAdminData(data) {
        this.appmod = "admin";
        let result = super.saveService(data);
        this.appmod = "usermanagement";
        return result;
    }
    savePreference(data) {
        this.appmod = "preference";
        let result = super.saveService(data);
        // this.appmod = "usermanagement";
        return result;
    }
    getPreference(data) {
        const apiURL = environment.SERVER + 'preference';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: data });
    }
    updatePreference(data) {
        const apiURL = environment.SERVER + 'updatepreference';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.put(apiURL, data, { headers: httpHeaders });
    }
    resetPass(data) {
        const apiURL = environment.SERVER + 'resetPass';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.put(apiURL, data, { headers: httpHeaders });
    }
    saveRates(data) {
        ;
        this.appmod = "tier/save_rate";
        let result = super.saveService(data);
        this.appmod = "usermanagement";
        return result;
    }
    updaterates(data) {
        this.appmod = "tier/update_rate";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    onDeleteAccount(data) {
        this.appmod = "deleteAccount";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    // @LoaderEnabled()
    // onFinalDeleteAccount(data: any): Observable<any> {
    //   this.appmod = "final_delete_account";
    //   let result = super.updateService(data);
    //   this.appmod = "";
    //   return result;
    // }
    onFinalDeleteAccount(data) {
        this.appmod = "adminCloseCustomerAccount";
        let result = super.updateService(data);
        this.appmod = "";
        return result;
    }
    saveUser(type, data) {
        this.appmod = type;
        let result = super.saveService(data);
        this.appmod = "usermanagement";
        return result;
    }
    savewhitelablel(data) {
        this.appmod = "white-label";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    getrates() {
        return this.http.get('./assets/tierreports.json');
    }
    emailVerify(data) {
        const apiURL = environment.SERVER + 'emailverify';
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, data, { headers: httpHeaders });
    }
    saveOtp(otp) {
        const apiURL = environment.SERVER + 'saveotp';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiURL, otp, { headers: httpHeaders });
    }
    saveOtpbyCall(data) {
        const apiURL = environment.SERVER + 'sendotpCall';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiURL, data, { headers: httpHeaders });
    }
    verifyOtp(otp) {
        const apiURL = environment.SERVER + 'signup_verifyOtp';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiURL, otp, { headers: httpHeaders });
    }
    stripeCard() {
        const apiURL = environment.SERVER + 'stripe-card';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders });
    }
    stripeCards() {
        const apiURL = environment.SERVER + 'stripe-cards';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders });
    }
    stripeDefaultCards() {
        const apiURL = environment.SERVER + 'stripe-cards-default';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders });
    }
    createCard(token) {
        const apiURL = environment.SERVER + 'create-card';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiURL, { token: token }, { headers: httpHeaders });
    }
    onBoardcreateCard(token) {
        const apiURL = environment.SERVER + 'onBoardcreateCard';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiURL, { token: token }, { headers: httpHeaders });
    }
    finalSubmitCardForm(data) {
        let tmp = this.appmod;
        this.appmod = 'saveCardForm';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    onBoardstripecards() {
        const apiURL = environment.SERVER + 'onBoardstripecards';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders });
    }
    saveEsignature(data) {
        this.appmod = "saveEsignature";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    getEsignature() {
        this.appmod = 'getEsignature';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getUserStatus(uid) {
        this.appmod = 'getUserStatus';
        let result = super.getService(uid);
        this.appmod = "";
        return result;
    }
    setDefaultCard(customer_id) {
        const apiURL = environment.SERVER + 'set-default-card';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.put(apiURL, { customer_id }, { headers: httpHeaders });
    }
    deleteCard(customer_id) {
        const apiURL = environment.SERVER + 'delete-card';
        let httpHeaders = new HttpHeaders({});
        return this.http.delete(apiURL, { headers: httpHeaders, params: { customer_id: customer_id } });
    }
    deleteOnBoardCard(customer_id) {
        const apiURL = environment.SERVER + 'deleteOnBoardCard';
        let httpHeaders = new HttpHeaders({});
        return this.http.delete(apiURL, { headers: httpHeaders, params: { customer_id: customer_id } });
    }
    updateProfile(data, profile_pic) {
        const formData = new FormData();
        formData.append("profile_pic", profile_pic);
        formData.append("data", JSON.stringify(data));
        const apiURL = environment.SERVER + 'user';
        let httpHeaders = new HttpHeaders({});
        return this.http.post(apiURL, formData, { headers: httpHeaders });
    }
    updateProfilePic(profile_pic) {
        const formData = new FormData();
        formData.append("profile_pic", profile_pic);
        const apiURL = environment.SERVER + 'profile-pic';
        let httpHeaders = new HttpHeaders({});
        return this.http.put(apiURL, formData, { headers: httpHeaders });
    }
    removeProfilePic(profile_pic) {
        this.appmod = "removeProfile-pic";
        let result = super.updateService(profile_pic);
        this.appmod = "usermanagement";
        return result;
    }
    deleteUser(key) {
        this.appmod = "deleteUser";
        let result = super.deleteService(key);
        this.appmod = "usermanagement";
        return result;
    }
    updateTariff(key) {
        this.appmod = "update-tariff";
        let result = super.updateService(key);
        this.appmod = "usermanagement";
        return result;
    }
    addBillingAddress(data) {
        let tmp = this.appmod;
        this.appmod = 'add_billing_address';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    //@LoaderEnabled()
    sendFinalMail(data) {
        let tmp = this.appmod;
        this.appmod = 'signup_confirmation';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    getGeoCodeAdd(data) {
        let tmp = this.appmod;
        this.appmod = 'get_geo_code';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    deleteUserSingleData(key) {
        this.appmod = "deleteUserSingleData";
        let result = super.deleteService(key);
        this.appmod = "usermanagement";
        return result;
    }
    saveData(data) {
        let result = super.saveService(data);
        return result;
    }
    updatePaymentService(data) {
        let tmp = this.appmod;
        this.appmod = 'updatepaymentsetting';
        let result = super.updateService(data);
        this.appmod = tmp;
        return result;
    }
    updateData(data) {
        let tmp = this.appmod;
        this.appmod = 'custom/saveheadermapping';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    // @LoaderEnabled()
    // getCampaign(data:any): Observable<any> {
    //   console.log(data);
    //   this.appmod = 'CampaignData';
    //   let result = super.getService(data);
    //   this.appmod = "";
    //   return result;
    // }
    getCampaign(data) {
        const apiURL = environment.SERVER + 'CampaignData';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: data });
    }
    emailResend() {
        const apiURL = environment.SERVER + 'resendemail';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.post(apiURL, { type: "resend" }, { headers: httpHeaders });
    }
    morphingSession(key) {
        const apiURL = environment.SERVER + 'morphing-session';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.get(apiURL, { headers: httpHeaders, params: { key } });
    }
    billingEnable(data) {
        this.appmod = "billingEnable";
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    getKycPdfData() {
        this.appmod = "downloadPdfForAdmin";
        let result = super.getService();
        this.appmod = "usermanagement";
        return result;
    }
    getfederalPdfData() {
        this.appmod = "getFederalPdfForAdmin";
        let result = super.getService();
        this.appmod = "usermanagement";
        return result;
    }
    getFederalPDFAccount() {
        this.appmod = "getFederalPDFAccount";
        let result = super.getService();
        this.appmod = "usermanagement";
        return result;
    }
    getCardPdfForAdmin() {
        this.appmod = "getCardPdfForAdmin";
        let result = super.getService();
        this.appmod = "usermanagement";
        return result;
    }
    /*KYC verification update function*/
    kycVerify(data) {
        this.appmod = "kycVerification";
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    /*FOR DOMIAN BLOCK*/
    /*Inser domain block service*/
    saveDomainBlock(data) {
        this.appmod = "domainBlock";
        let result = super.saveService(data);
        this.appmod = "usermanagement";
        return result;
    }
    /*GET domain block service*/
    getDomainBlock() {
        this.appmod = "getDomainBlk";
        let tmp = this.getService();
        this.appmod = "usermanagement";
        return tmp;
    }
    /*UPDATE domain block service*/
    updateDomainBlock(data) {
        this.appmod = "updateDomainBlock";
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    /*DELETE domain block service*/
    onDeleteDomainBlock(domain_block_id) {
        const apiURL = environment.SERVER + 'deleteDomainBlock';
        let httpHeaders = new HttpHeaders({});
        return this.http.delete(apiURL, { headers: httpHeaders, params: { domain_block_id: domain_block_id } });
    }
    /*end here domian block services..*/
    getKycHeader() {
        this.appmod = "kycHeader";
        let tmp = this.getService();
        this.appmod = "usermanagement";
        return tmp;
    }
    getuserheader() {
        return this.http.get('./assets/usermanagement.json');
    }
    getsuppiler() {
        return this.http.get('./assets/supplieruser.json');
    }
    getsmsrate() {
        return this.http.get('./assets/ratelist.json');
    }
    getVoiceForm() {
        return this.http.get('./assets/voicerate.json');
    }
    getTollFreeForm() {
        return this.http.get('./assets/tollfree.json');
    }
    getshortcode() {
        return this.http.get('./assets/shortcode.json');
    }
    getusasms() {
        return this.http.get('./assets/usasmsmms.json');
    }
    getdidupload() {
        return this.http.get('./assets/uploaddid.json');
    }
    getintegrated() {
        return this.http.get('./assets/integratedsupplier.json');
    }
    getintegratedAPI() {
        return this.http.get('./assets/apicontrol.json');
    }
    getrecord() {
        return this.http.get('./assets/didreport.json');
    }
    getpreference() {
        return this.http.get('./assets/userpreference.json');
    }
    numbersearch() {
        return this.http.get('./assets/numbersearch.json');
    }
    ordernumber() {
        return this.http.get('./assets/orddernumber.json');
    }
    getdiallogform() {
        return this.http.get('./assets/dialogpopup.json');
    }
    record() {
        return this.http.get('./assets/tierreports.json');
    }
    get_surcharge() {
        return this.http.get('./assets/surcharge.json');
    }
    US_State() {
        return this.http.get('./assets/newBrand.json');
    }
    api(cdata) {
        const endpoint = environment.SERVER + 'api_token';
        let httpHeaders = new HttpHeaders();
        return this.http.post(endpoint, cdata, { headers: httpHeaders });
    }
    api_integrate(data) {
        let tmp = this.appmod;
        this.appmod = 'api_integration';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    /**
     * To fetch the list of Timezones
     */
    GetTimeZones() {
        this.appmod = "get_timezones";
        let result = this.getService();
        this.appmod = "usermanagement";
        return result;
    }
    /**
     * To fetch the user's TimeZone
     */
    GetUserTimeZone() {
        this.appmod = "get_user_timezone";
        let result = this.getService();
        this.appmod = "usermanagement";
        return result;
    }
    /**
     * To save the user's TimeZone
     */
    UpdateUserTimeZone(data) {
        let tmp = this.appmod;
        this.appmod = 'user_timezone';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    currentSession(authkey) {
        const endpoint = environment.SERVER + 'session';
        let httpHeaders = new HttpHeaders();
        return this.http.get(endpoint, { headers: httpHeaders, params: { authkey: authkey } });
    }
    onGetBuyDids(filter) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "dids";
        return this.http.get(apiUrl, { headers: httpHeaders, params: filter });
    }
    getAllDID(data) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "exportdid";
        return this.http.post(apiUrl, { data: data }, { headers: httpHeaders });
    }
    custDidsCount(filter) {
        let httpHeaders = new HttpHeaders({
            'Content-Type': 'application/json',
        });
        let apiUrl = environment.SERVER + "custdidscount";
        return this.http.get(apiUrl, { headers: httpHeaders, params: filter });
    }
    GetCampaignsList(payLoad) {
        this.appmod = 'campaignsList';
        let result = super.getService(payLoad);
        this.appmod = "";
        return result;
    }
    getSubscriptionPlan(payLoad) {
        this.appmod = 'getPlan';
        let result = super.getService(payLoad);
        this.appmod = "";
        return result;
    }
    getCampaignForReview(payLoad) {
        this.appmod = 'getCampaignForReview';
        let result = super.getService(payLoad);
        this.appmod = "";
        return result;
    }
    getfeatureService() {
        this.appmod = "getfeatureService";
        let result = this.getService();
        this.appmod = "usermanagement";
        return result;
    }
    getfeatureServiceStatus() {
        this.appmod = "getfeatureServiceStatus";
        let result = this.getService();
        this.appmod = "usermanagement";
        return result;
    }
    getSuspendedService() {
        this.appmod = "getSuspendedService";
        let result = this.getService();
        this.appmod = "usermanagement";
        return result;
    }
    getfeatureServiceById(idaccount) {
        this.appmod = "getfeatureServiceById";
        let result = this.getService(idaccount);
        this.appmod = "usermanagement";
        return result;
    }
    updateSuspendedService(data) {
        this.appmod = "updateSuspendedService";
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    getInvoiceDetails() {
        this.appmod = "getInvoiceDetails";
        let result = this.getService();
        this.appmod = "usermanagement";
        return result;
    }
    get_addcard() {
        return this.http.get('./assets/addcard.json');
    }
    confirmInvoice(id) {
        this.appmod = "deleteCusAccount";
        let result = super.deleteService(id);
        this.appmod = "usermanagement";
        return result;
    }
    getInvoicePdfData() {
        this.appmod = "getInvoicePdfForAdmin";
        let result = super.getService();
        this.appmod = "usermanagement";
        return result;
    }
    // to update payment status
    Sendpayment(data) {
        this.appmod = "paymentstatus";
        let result = super.updateService(data);
        this.appmod = "usermanagement";
        return result;
    }
    // to get the payment status
    trustScore() {
        this.appmod = "trust_Score";
        let tmp = this.getService();
        this.appmod = "usermanagement";
        return tmp;
    }
    getKycPDFLog() {
        this.appmod = "getKycPdfLog";
        let result = super.getService();
        this.appmod = "usermanagement";
        return result;
    }
};
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "userLogin", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "companyProfile", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "updateCompanyProfile", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "AdminRecharge", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "saveFile", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getBalance", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getFeature", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getRate", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getSuppliers", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getUsers", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getResellerUsers", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getResellerTariff", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "customerList", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getSubListUsers", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getAllUsers", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getSingleUsers", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getSingleUsersForAdmin", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getMyTariff", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getUser", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "SaveUserData", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getCountry", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "SaveAdminData", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "savePreference", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getPreference", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "updatePreference", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "resetPass", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "saveRates", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "updaterates", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "onDeleteAccount", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "onFinalDeleteAccount", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "saveUser", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "savewhitelablel", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "emailVerify", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "saveOtp", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "saveOtpbyCall", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "verifyOtp", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "stripeCard", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "stripeCards", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "stripeDefaultCards", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "createCard", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "onBoardcreateCard", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "finalSubmitCardForm", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "onBoardstripecards", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "saveEsignature", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getEsignature", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getUserStatus", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "setDefaultCard", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "deleteCard", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "deleteOnBoardCard", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "updateProfile", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "updateProfilePic", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "removeProfilePic", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "deleteUser", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "updateTariff", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "addBillingAddress", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getGeoCodeAdd", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "deleteUserSingleData", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "updatePaymentService", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getCampaign", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "emailResend", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "morphingSession", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "billingEnable", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getKycPdfData", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getfederalPdfData", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getFederalPDFAccount", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getCardPdfForAdmin", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "kycVerify", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "saveDomainBlock", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getDomainBlock", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "updateDomainBlock", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "onDeleteDomainBlock", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getKycHeader", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getTollFreeForm", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getshortcode", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "api", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "api_integrate", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "onGetBuyDids", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getAllDID", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "custDidsCount", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "GetCampaignsList", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getSubscriptionPlan", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getCampaignForReview", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getfeatureService", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getfeatureServiceStatus", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getfeatureServiceById", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "updateSuspendedService", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getInvoiceDetails", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "confirmInvoice", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getInvoicePdfData", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "Sendpayment", null);
__decorate([
    LoaderEnabled()
], UsermanagementService.prototype, "getKycPDFLog", null);
UsermanagementService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], UsermanagementService);
export { UsermanagementService };
//# sourceMappingURL=usermanagement.service.js.map