import { __decorate, __param } from "tslib";
import { Component, Inject, Input } from '@angular/core';
import { FormControl } from '@angular/forms';
import { MAT_DIALOG_DATA } from '@angular/material/dialog';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { BehaviorSubject } from 'rxjs';
let AdddialogComponent = class AdddialogComponent extends AppComponentClass {
    constructor(tariffService, dialogRef, ddata, data, router, fb) {
        super(data, router, fb);
        this.tariffService = tariffService;
        this.dialogRef = dialogRef;
        this.ddata = ddata;
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.curuserid = -1;
        this.show = false;
        this.reg_status$ = new BehaviorSubject("Un-Register");
        this.reg_status = this.reg_status$.asObservable();
        this.savetype = 0;
        this.submitted = false;
        this.errMessage = "";
        this.Password = '';
        this.savePlan = 'Submit';
    }
    ngOnInit() {
        // this.tariffService.getTariffs("registered").subscribe(res => {
        // 	this.regTariffs = res.data;
        // });
        // this.tariffService.getTariffs("unregistered").subscribe(res => {
        // 	this.unregTariffs = res.data;
        // });
        this.data.getsuppiler().subscribe((result) => {
            this.listdata = result[1];
            this.field = result[2];
            this.listdata.forEach(element => {
                element.disabled = false;
            });
            let fields = {};
            this.boxtype = this.ddata.dialogtype;
            if (this.ddata.savetype)
                this.savetype = this.ddata.savetype;
            if (this.boxtype == 1) {
                this.savePlan = 'Submit';
                fields["iduser"] = [-1];
                fields["idaccount"] = [this.ddata.idaccount];
                fields["newUser_status"] = [this.ddata.newUser_status];
                fields["type"] = [this.ddata.type + "2"];
                this.listdata.forEach(element => {
                    fields[element.formControl] = new FormControl('');
                });
                this.usermanagementForm = this.fb.group(fields);
                this.usermanagementForm.patchValue({
                    status: false
                });
                this.show = true;
            }
            else {
                this.savePlan = 'Update';
                fields["iduser"] = [this.ddata.iduser];
                fields["idaccount"] = [this.ddata.idaccount];
                fields["type"] = [this.ddata.type];
                this.savetype = 0;
                this.listdata.forEach(element => {
                    fields[element.formControl] = [this.ddata[element.formControl]];
                });
                this.usermanagementForm = this.fb.group(fields);
                this.show = true;
            }
        });
    }
    checkPassword(e) {
        if (e.target.value.length < 8) {
            this.Password = "Password must be minimum 8 characters long";
        }
        // if (e.target.value.length >= 20) {
        // 	this.Password = "Password must be maximum 20 characters long";
        // }
        if (e.target.value.length <= 0) {
            this.Password = "Password is required";
        }
        if (e.target.value.length >= 8) {
            this.Password = "";
        }
    }
    onAddUser() {
        this.submitted = true;
        if (this.usermanagementForm.value.iduser !== -1) {
            this.usermanagementForm.patchValue({
                password: ''
            });
        }
        if (this.usermanagementForm.invalid) {
            if (!this.usermanagementForm.value.password && this.usermanagementForm.value.iduser == -1) {
                this.Password = 'Password is required';
            }
            return false;
            // this.submitted = true;
        }
        else {
            this.Password = '';
            if (this.savetype == 0) {
                if (!this.usermanagementForm.value.password && this.usermanagementForm.value.iduser == -1) {
                    this.Password = 'Password is required';
                    return;
                }
                this.savePlan = 'Submit';
                this.data.SaveUserData(JSON.stringify(this.usermanagementForm.value)).subscribe(res => {
                    if (res.status == 201) {
                        this.dialogRef.close(1);
                        this.submitted = false;
                        this.ngOnInit();
                    }
                    else {
                        this.errMessage = res.message;
                        setTimeout(() => {
                            this.errMessage = "";
                        }, 5000);
                    }
                });
            }
            if (this.savetype == 1) {
                this.data.SaveAdminData(JSON.stringify(this.usermanagementForm.value)).subscribe(res => {
                    if (res.status == 201) {
                        this.responseMessage = res.message;
                        this.submitted = false;
                        setTimeout(() => {
                            this.responseMessage = "";
                            this.dialogRef.close(1);
                        }, 3000);
                        this.ngOnInit();
                    }
                    else {
                        this.errMessage = res.message;
                        setTimeout(() => {
                            this.errMessage = "";
                        }, 5000);
                    }
                });
            }
        }
    }
    close() {
        this.dialogRef.close(-1);
    }
    onCheck(e) {
        if (e.target.checked) {
            this.reg_status$.next("Register");
        }
        else {
            this.reg_status$.next("Un-Register");
        }
    }
    reset() {
        let data = {};
        data = this.usermanagementForm.value;
        console.log("data", data);
        this.submitted = false;
        this.Password = '';
        this.usermanagementForm.reset({
            credit_limit: data.credit_limit,
            idaccount: data.idaccount,
            iduser: data.iduser,
            is_sms: data.is_sms,
            is_voice: data.is_voice,
            newUser_status: data.newUser_status,
            service: data.service,
            status: data.status,
            tariff1: data.tariff1,
            type: data.type
        });
    }
};
__decorate([
    Input()
], AdddialogComponent.prototype, "usertype", void 0);
__decorate([
    Input()
], AdddialogComponent.prototype, "curuserid", void 0);
__decorate([
    Input()
], AdddialogComponent.prototype, "responseMessage", void 0);
AdddialogComponent = __decorate([
    Component({
        selector: 'app-adddialog',
        templateUrl: './adddialog.component.html',
        styleUrls: ['./adddialog.component.css']
    }),
    __param(2, Inject(MAT_DIALOG_DATA))
], AdddialogComponent);
export { AdddialogComponent };
//# sourceMappingURL=adddialog.component.js.map