import { __decorate } from "tslib";
import { HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { LoaderEnabled } from '../shared/loader/loader.service';
import { AppService } from "../shared/service/AppService.class";
let WhitelabelService = class WhitelabelService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.appmod = "usermanagement";
    }
    updateTheme(data, logo) {
        const formData = new FormData();
        formData.append("profile_pic", logo);
        formData.append("data", JSON.stringify(data));
        const apiURL = environment.SERVER + 'updatetheme';
        let httpHeaders = new HttpHeaders({});
        return this.http.put(apiURL, formData, { headers: httpHeaders });
    }
    saveTheme(data) {
        this.appmod = "savetheme";
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    getThemes() {
        this.appmod = "themes";
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    getTheme(idTheme) {
        this.appmod = "theme";
        let result = super.getService(idTheme);
        this.appmod = "";
        return result;
    }
};
__decorate([
    LoaderEnabled()
], WhitelabelService.prototype, "updateTheme", null);
__decorate([
    LoaderEnabled()
], WhitelabelService.prototype, "saveTheme", null);
__decorate([
    LoaderEnabled()
], WhitelabelService.prototype, "getThemes", null);
__decorate([
    LoaderEnabled()
], WhitelabelService.prototype, "getTheme", null);
WhitelabelService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], WhitelabelService);
export { WhitelabelService };
//# sourceMappingURL=whitelabel.service.js.map